import java.lang.*;
import java.util.*;
import java.io.*;

import javax.swing.*;                                           
import java.awt.*;
import java.awt.event.*;                                                  
import java.awt.Toolkit.*;       
import java.awt.datatransfer.*;                 
import java.util.zip.*;



class cellautorulec {
  abstractcellautorulefamily rulefamily = null;
  public int seed = 0;
  public String filename = null;
  public String description = null;
  public byte lookuptable[][];
  boolean lookuptableallused = true;
  public byte lookuptableused[][];
  public int cellvalue[];
  public Color cellvaluecolor[];
  public int numalloccolors = 0;
  public int numcolors = 4;
  public int numcellvalues = 256;
  public int bordersize = 1;
  public int bordervalue[][];
  public int bordersum = 0;
  public int borderflip[][];
  public int tablewidth;
  public int tableheight;
  public int tableoffset;       
  public int buffer[][];
  public int buffer2[][];
  public int bufferoffsetx = 0;
  public int bufferoffsety = 0;
  public int rulechange = 2;
  public boolean debug2534 = false;
  Color white; 
  public long numcellscalculate = 0;
  public boolean neighborhoodchanged = true;
  public int neighboroffsetx[] = null;
  public int neighboroffsety[] = null;
  public int numneighbors = 0;
  cellautorulec(cellautorulec c){
    neighborhoodchanged = true;
    rulefamily = c.rulefamily;
    seed = c.seed;
    buffer = new int[16+bordersize+bordersize][16+bordersize+bordersize];
    buffer2 = new int[16][16];
    white = c.white;
    numcellvalues = 256;

    //create the rule table and copy it from the other rule
    tablewidth = c.tablewidth;
    tableheight = c.tableheight;
    tableoffset = c.tableoffset;
    lookuptable = new byte[tablewidth][tableheight];
    for (int x = 0;x < tablewidth;x++){
      for (int y = 0;y < tableheight;y++){
        lookuptable[x][y] = c.lookuptable[x][y];
      }
    }

    lookuptableallused = c.lookuptableallused;
    if (lookuptableallused == false){
      lookuptableused = new byte[tablewidth][tableheight];
      for (int x = 0;x < tablewidth;x++){
        for (int y = 0;y < tableheight;y++){
          lookuptableused[x][y] = c.lookuptableused[x][y];
        }
      }
    }
    
    numcolors = c.numcolors;
    writenumalloccolors(numcolors);
    for (int i = 0;i < numcolors;i++){
      cellvalue[i] = c.cellvalue[i];
      cellvaluecolor[i] = c.cellvaluecolor[i];
    }

    bordersum = c.bordersum;
    bordersize = c.bordersize;
    int bs = (bordersize*2) + 1;
    bordervalue = new int[bs][bs];
    for (int x = 0;x < bs;x++){
      for (int y = 0;y < bs;y++){
        bordervalue[x][y] = c.bordervalue[x][y];
      }
    }  

    borderflip = new int[2][2];
    for (int x = 0;x < 2;x++){
      for (int y = 0;y < 2;y++){
        borderflip[x][y] = c.borderflip[x][y];
      }
    }
  }
  cellautorulec(){
    neighborhoodchanged = true;
    seed = 0;
    buffer = new int[16+bordersize+bordersize][16+bordersize+bordersize];
    buffer2 = new int[16][16];
    lookuptableallused = true;
    borderflip = new int[2][2];
    borderflip[0][0] = 0;
    borderflip[0][1] = 0;
    borderflip[1][0] = 0;
    borderflip[1][1] = 0;
    
    //create the rule table
    tablewidth = 9;
    tableheight = 4;
    lookuptable = new byte[tablewidth][tableheight];
    for (int x = 0;x < tablewidth;x++){
      for (int y = 0;y < tableheight;y++){
        lookuptable[x][y] = 0;
      }
    }
    lookuptable[3][0] = 1;
    lookuptable[3][1] = 1;
    lookuptable[2][1] = 1;

    bordersum = 0;
    bordersize = 1;
    bordervalue = new int[(bordersize*2)+1][(bordersize*2)+1];
    for (int x = 0;x < 3;x++){
      for (int y = 0;y < 3;y++){
        bordervalue[x][y] = 1;
        bordersum = bordersum + 1;
      }
    }
    bordervalue[1][1] = 0;
    bordersum = bordersum - 1;
    
    white = new Color(255,255,255);
    writenumalloccolors(numcellvalues);
    numcolors = 4;
    for (int i = 0;i < numcellvalues;i++){
      cellvalue[i] = 0;
      cellvaluecolor[i] = null;
    }
    cellvaluecolor[0] = new Color(0,0,0);
    cellvaluecolor[1] = new Color(255,255,0);
    cellvaluecolor[2] = new Color(255,0,0);
    cellvaluecolor[3] = new Color(0,0,255);

    cellvalue[1] = 1;
    
  }
  
  //addnewstate adds a new color to the color box
  //and resizes the rule table
  //it returns the index of the new color
  int addnewstate(){
    int n = getnumcolors();
    if (n >= 256) {return -1;}
    if (tableheight < getnumcolors()) {
      resizetable(tablewidth,getnumcolors());
    }
    setnumcolors(n+1);
    writenumalloccolors(n+1);
    cellvaluecolor[n] = new Color(255,255,255);
    if (n > 0){
      if (cellvalue[n-1] > 0) {cellvalue[n] = 1;}
      else {cellvalue[n] = 0;}
    } else {
      cellvalue[n] = 0;
    }
    byte a[][];
    a = lookuptable;
    cleartable(tablewidth,tableheight+1);
    for (int y = 0;y < (tableheight-1);y++){
      for (int x = 0;x < tablewidth;x++){
        lookuptable[x][y] = a[x][y];
      }
    }
    if (lookuptableallused == false){
      a = new byte[tablewidth][tableheight];
      for (int y = 0;y < (tableheight-1);y++){
        for (int x = 0;x < tablewidth;x++){
          a[x][y] = lookuptableused[x][y];
        }
      }
      for (int x = 0;x < tablewidth;x++){
        a[x][tableheight-1] = 1;
      }
      lookuptableused = a;
    }
    return n;
  }
  int get_max_cell_value() {
    int best_cell_value = 0;
    for (int i = 0;i < numcolors;i++) {
      if (cellvalue[i] > best_cell_value) { 
        best_cell_value = cellvalue[i];
      }
    }
    return best_cell_value;
  }
  void makeruletablewider() {
    int max_cell_value = get_max_cell_value();
    //System.out.println("bordersum " + bordersum);
    int new_table_width = (bordersum * max_cell_value) + 1 + tableoffset;
    if (new_table_width > tablewidth) {
      resizetable(new_table_width,tableheight);
    }
  }
  int readnumalloccolors(){
    return numalloccolors;
  }
  void writenumalloccolors(int size){
    if (size <= numalloccolors){return;}
    int tmpcellvalue[] = cellvalue;
    Color tmpcellvaluecolor[] = cellvaluecolor;
    cellvalue = new int[size];
    cellvaluecolor = new Color[size];
    for (int i = 0;i < numalloccolors;i++){
      cellvalue[i] = tmpcellvalue[i];
      cellvaluecolor[i] = tmpcellvaluecolor[i];
    }
    numalloccolors = size;
  }
  int readtableoffset(){
    return tableoffset;
  }
  void writetableoffset(int a){
    tableoffset = a;
  }
  int readborderflip(int x,int y){
    return borderflip[x & 1][y & 1];
  }
  void writeborderflip(int x,int y,int a){
    borderflip[x & 1][y & 1] = a; 
  }
  void setupneighboroffsets() {
    int n = 0;
    for (int dx = -bordersize;dx <= bordersize;dx++){ 
      for (int dy = -bordersize;dy <= bordersize;dy++){
        int a2 = bordervalue[dx+bordersize][dy+bordersize];
        if (a2 != 0) {n++;}
      }
    }
    neighboroffsetx = new int[n];
    neighboroffsety = new int[n];
    numneighbors = 0;
    for (int dx = -bordersize;dx <= bordersize;dx++){ 
      for (int dy = -bordersize;dy <= bordersize;dy++){
        int a2 = bordervalue[dx+bordersize][dy+bordersize];
        if (a2 != 0) {
          neighboroffsetx[numneighbors] = dx;
          neighboroffsety[numneighbors] = dy;
          numneighbors++;
        }
      }
    }
    neighborhoodchanged = false;
  }
  void printneighboroffsets() {
    System.out.println("");
    for (int i = 0;i < numneighbors;i++){
      int dx = neighboroffsetx[i];
      int dy = neighboroffsety[i];
      System.out.println("neighbor offset " + dx + "," + dy);
    }
  }

  // this function counts the value of the cell's neighbors
  //Parameters:
  //  b: the board the cell is on
  //  x: the cell's x position
  //  y: the cell's y position
  //  usebuffer: wherever to use the buffer or not
  //Returns:
  //  the sum of the cell's neighbors
  int getneighborvalue(boardc b,int x,int y) {
    int a0 = tableoffset;
    int a1 = 0;
    int a3 = borderflip[x & 1][y & 1];
    if (neighborhoodchanged == true){
      setupneighboroffsets();
    }
    for (int i = 0;i < numneighbors;i++){
      int dx = neighboroffsetx[i];
      int dy = neighboroffsety[i];
      int a2 = bordervalue[dx+bordersize][dy+bordersize];
      //if (a2 == 0){return;}
      int dx2 = dx;
      int dy2 = dy;
      if ((a3 & 1) == 1){dx2 = -dx2;}
      if ((a3 & 2) == 2){dy2 = -dy2;}
      a1 = b.getsq(x+dx2,y+dy2);
      a0 = a0 + (cellvalue[a1] * a2);      
    }
    return a0;
  }
  
  
  
  
  
  //calcblock calculates a 32x32 block of cells
  //Parameters:
  //  b: what board to read from
  //  b2: what board to write to
  //  x: the block's x offset
  //  y: the block's y offset
  void calcblock(boardc b,boardc b2,int x,int y) {
    //System.out.println("calcblock");
    int a0 = tableoffset;
    blockc bl = b.block[x >> 5][y >> 5];
    blockc bl2 = b2.block[x >> 5][y >> 5];
    if ((bl != null) | (b.usedblock[x >> 5][y >> 5] == 1)){
      for (int x2 = 0;x2 < 32;x2 = x2 + 4){
        for (int y2 = 0;y2 < 32;y2 = y2 + 4){
          calcblock44(b,b2,x,y,x2,y2);
        }
      }
    }
  }

  
  //calcblock2 calculates a 32x32 block of cells
  //Parameters:
  //  b: what board to read from
  //  b2: what board to write to
  //  x: the block's x offset
  //  y: the block's y offset
  void calcblock2(boardc b,boardc b2,int x,int y){
    //System.out.println("calcblock2");
    blockc bl = b.block[x >> 5][y >> 5];
    blockc bl2 = b2.block[x >> 5][y >> 5];
    if ((bl != null)) {
      if ((b2.background_tile_sub_board.equals(b2.background_tile_sub_board2) == false)) {

        for (int x2 = 0;x2 < 32;x2++){
          for (int y2 = 0;y2 < 32;y2++){
            if (bl2 != null) {
              if (bl2.board[x2][y2] == b2.get_background_color5(x+x2,y+y2,1)) {
                bl2.board[x2][y2] = (byte) b2.get_background_color5(x+x2,y+y2,0);
              }
            }
          }
        }
      }
    }
    if ((bl != null) | (b.usedblock[x >> 5][y >> 5] == 1)){
      for (int x2 = 0;x2 < 32;x2 = x2 + 4){
        for (int y2 = 0;y2 < 32;y2 = y2 + 4){
          if ((b.readused(x+x2,y+y2) == 1)|(b2.readused(x+x2,y+y2) == 1)) {
            calcblock44(b,b2,x,y,x2,y2);
          }
        }
      }
    }
  }

  void calcblock44(boardc b,boardc b2,int x,int y,int x2,int y2) {
    int a0 = tableoffset;
             for (int x3 = 0;x3 < 4;x3++){
              for (int y3 = 0;y3 < 4;y3++){
                int x4 = x + x2 + x3;
                int y4 = y + y2 + y3;
                
                int a2 = 0;
                if (x4 >= b.width){break;}
                if (y4 >= b.height){break;}
                int a3 = 0;
                if (rulefamily != null){
                  a3 = rulefamily.calcsq(this,b,x4,y4,cellautoapp.generation);
                } else {
                  a0 = getneighborvalue(b,x4,y4);
                  a2 = b.getsq(x4,y4);
                  a3 = getlookuptable(a0,a2);
                  if (lookuptableallused == false){
                    setlookuptableused(a0,a2,1);
                  }
                }     
                b2.setsq(x4,y4,a3);
                
              }
            }
            numcellscalculate = numcellscalculate + 16;

  }
  boardc calcbgcolor(boardc b,boardc b2) { 
    int a0 = tableoffset;
    int a2 = 0;
    b2.dfcolor2 = b2.dfcolor;
    //buffer = new int[32+bordersize+bordersize][32+bordersize+bordersize];
    if ((rulefamily == null) & (b.background_tile_sub_board == null)){
      for (int dx = -bordersize;dx <= bordersize;dx++){ 
        for (int dy = -bordersize;dy <= bordersize;dy++){
          a0 = a0 + (cellvalue[b.dfcolor] * bordervalue[dx+bordersize][dy+bordersize]);      
        
        }
      }
    }
    if ((rulefamily == null)){
      if (b.background_tile_sub_board != null){
        b2.background_tile_sub_board2.copy(b2.background_tile_sub_board);
        for (int x = 0;x < b2.background_tile_sub_board.get_width();x++){
          for (int y = 0;y < b2.background_tile_sub_board.get_height();y++){
            int sq = b.background_tile_sub_board.getsq(x,y);
            int n = this.getneighborvalue(b.background_tile_sub_board,x,y);
            if (lookuptableallused == false){
              setlookuptableused(n,sq,1);
            }
            sq = getlookuptable(n,sq);
            b2.background_tile_sub_board.setsq(x,y,sq);
          }
        }
      } else {
        b2.dfcolor2 = b2.dfcolor;
        if (lookuptableallused == false){
          setlookuptableused(a0,b.dfcolor,1);
        }
        b2.dfcolor = getlookuptable(a0,b.dfcolor);
      }
    } else {
      if (b.background_tile_sub_board != null){
        //System.out.println("a53");
        b2.background_tile_sub_board2.copy(b2.background_tile_sub_board);
        for (int x = 0;x < b2.background_tile_sub_board.get_width();x++){
          for (int y = 0;y < b2.background_tile_sub_board.get_height();y++){
            int sq = 0;
            sq = rulefamily.calcsq(this,b.background_tile_sub_board,x,y,cellautoapp.generation);
            b2.background_tile_sub_board.setsq(x,y,sq);
          }
        }
        b2.dfcolor = b2.background_tile_sub_board.getsq(0,0);
      }
    }
    return b2;
  }
  
  //this function calc3 calculates the next state of
  //all the cells and updates the board
  //Parameters:
  //  b: the current board
  //  b2: the last board
  //Returns:
  // the new board
  boardc calc3(boardc b,boardc b2){
    b2.clearusedbitboard();
    b2 = calcbgcolor(b,b2);
    if (rulechange > 0){
      b.usenonemptyblocks();
      //b2 = calcbgcolor(b,b2);
      b2.changecellstates(b.get_background_color(0,0),b2.get_background_color(0,0));
      rulechange--;
    }   
    int w2 = (b.width+3) >> 2;
    int h2 = (b.height+3) >> 2;
    
    //System.out.println("b.sb " + b.background_tile_sub_board.getsq(0,0));
    //System.out.println("b.sb2 " + b.background_tile_sub_board2.getsq(0,0));
    //System.out.println("b2.sb " + b2.background_tile_sub_board.getsq(0,0));
    //System.out.println("b2.sb2 " + b2.background_tile_sub_board2.getsq(0,0));

    for (int x = 0;x < b.width;x = x + 32){
      for (int y = 0;y < b.height;y = y + 32){
          calcblock2(b,b2,x,y);
        
      }
    }
    return b2;
  }

  boardc calc_one_row_func(boardc b){
    int p = cellautoapp.generation % b.height;
    for (int x = 0;x < b.width;x++) {
      int sq = rulefamily.calcsq(this,b,x,p+1,cellautoapp.generation);
      if ((p+1) == b.height) {
        b.setsq(x,0,sq);
      } else {
        b.setsq(x,p+1,sq);
      }
    }
    return b;
  }
  void setnumcolors(int i){
    numcolors = i;
  }
  void setnumcolors2(int i){
    int a = 0;
    if (i < numcolors){
      for (int i2 = i;i2 < numcolors;i2++){
        if (cellvalue[i2] > 0){
          a = 1;
        }
      }
      if (a == 0){
        numcolors = i;
      }
    }else{
      numcolors = i;
    }
  }
  
  int getnumcolors() {
    return numcolors;
  }
  
  //setcellvaluecolor sets the state's color
  //Parameters:
  //  i: the state's index
  //  c: the state's new color
  void setcellvaluecolor(int i,Color c) {
    if (i < 0){System.out.println("note: cellvalue index is out of range");}
    if (i >= numcellvalues){System.out.println("note: cellvalue index is out of range");}
    if (i >= numcolors){setnumcolors(i+1);}    
    writenumalloccolors(i+1);
    cellvaluecolor[i] = c;
  }

  //getcellvaluecolor gets the state's color
  //Parameters:
  //  i: the state's index
  //Returns:
  // the state's color
  Color getcellvaluecolor(int i) {
    if (i < 0){System.out.println("note: cellvalue index is out of range");}
    if (i >= numcellvalues){System.out.println("note: cellvalue index is out of range");}
    if (cellvaluecolor[i] == null){
      return white;
    }else{
      return cellvaluecolor[i];
    }
  }
  
  //resizetable resizes the rule table
  //Parameters:
  //  w: the table's new width
  //  h: the table's new height
  void resizetable(int w,int h) {
    byte tmp[][] = lookuptable;
    byte tmp2[][] = lookuptableused;
    int tmpwidth = tablewidth;
    int tmpheight = tableheight;
    cleartable(w,h);
    for (int y = 0;y < tmpheight;y++){
      for (int x = 0;x < tmpwidth;x++){
        if (x < w){
          if (y < h){
            lookuptable[x][y] = tmp[x][y];
            if (lookuptableallused == false) {
              lookuptableused[x][y] = tmp2[x][y];
            }
          }
        }
      }
    }
  }
  //cleartable clears the rule table and resizes it
  //Parameters:
  //  w: the table's new width
  //  h: the table's new height
  void cleartable(int w,int h) {
    tablewidth = w;
    tableheight = h;
    lookuptable = new byte[tablewidth][tableheight];
    if (lookuptableallused == false) {
      //System.out.println("lookuptableused = new byte[tablewidth][tableheight];");
      lookuptableused = new byte[tablewidth][tableheight];
    }
  }

  //clearborder resets all the neighbor weights to zero
  //it can also resize the neighborhood
  void clearborder(int a) {
    int a2 = bordersize;
    bordersize = a;
    bordersum = 0;
    bordervalue = new int[(bordersize*2)+1][(bordersize*2)+1];
    neighborhoodchanged = true;
  }
  
  void resizeborder(int a) {
    int tmp[][] = bordervalue;
    int a2 = bordersize;
    clearborder(a);
    int a3 = a2;
    if (a2 > a){a3 = a;}
    for (int y = -a3;y <= a3;y++){
      for (int x = -a3;x <= a3;x++){
        bordervalue[x+a][y+a] = tmp[x+a2][y+a2];
      }
    }
    neighborhoodchanged = true;
  }
  // getbordersize returns the neighborhood size
  // the number 1 is a 3x3 neighborhood
  // the number 2 is a 5x5 neighborhood
  // the number 3 is a 7x7 neighborhood
  // the number 4 is a 9x9 neighborhood
  // etc
  int getbordersize() {
    return bordersize;
  }

  //getbordervalue gets the neighbor's weight
  //Parameters:
  //  x: the neighbor's x offset
  //  y: the neighbor's y offset
  //Returns:
  //  the neighbor's weight
  public int getbordervalue(int x,int y) {
    if (((x+bordersize) < 0) | ((y+bordersize) < 0) | 
       ((x+bordersize) >= ((bordersize*2)+1)) |
       ((y+bordersize) >= ((bordersize*2)+1))) {
      System.out.println("note: bordervalue index is out of range");
      return 0;
    }
    
    return bordervalue[x+bordersize][y+bordersize]; 
  }
  
  //setbordervalue sets the neighbor's weight
  //Parameters:
  //  x: the neighbor's x offset
  //  y: the neighbor's y offset
  //  a: the neighbor's new weight
  public void setbordervalue(int x,int y,int a) {
    if (((x+bordersize) < 0) | ((y+bordersize) < 0) | 
       ((x+bordersize) >= ((bordersize*2)+1)) |
       ((y+bordersize) >= ((bordersize*2)+1))) {
      System.out.println("note: bordervalue index is out of range");
      return;
    }
    bordersum = (bordersum - bordervalue[x+bordersize][y+bordersize]) + a;
    bordervalue[x+bordersize][y+bordersize] = a;
    neighborhoodchanged = true;
  }
  
  //getcellvalue gets the state's value
  //Parameters:
  //  i: the state's index
  //Returns:
  //  the state's value
  public int getcellvalue(int i) {
    if ((i < 0) | (i >= numcellvalues)) {
      System.out.println("note: cellvalue index is out of range");
      return 0;
    }
    
    return cellvalue[i];
  }

  //setcellvalue sets the state's value
  //Parameters:
  //  i: the state's index
  //  a: the state's new value
  public void setcellvalue(int i,int a) {
    if ((i < 0) | (i >= numcellvalues)) {
      System.out.println("note: cellvalue index is out of range");
      return;
    }
    if (i >= numcolors){numcolors = i+1;}    
    writenumalloccolors(i+1);
    cellvalue[i] = a;
    
  }
  
  public void filllookuptableused() {
    lookuptableallused = true;
    for (int x = 0;x < tablewidth;x++){
      for (int y = 0;y < tableheight;y++){
        setlookuptableused(x,y,1);
      }
    }
  }
  public void clearlookuptableused() {
    for (int x = 0;x < tablewidth;x++){
      for (int y = 0;y < tableheight;y++){
        setlookuptableused(x,y,0);
      }
    }
  }
  public void setlookuptableused(int x,int y,int a) {
    if ((x < 0) | (y < 0) | (x >= tablewidth) | (y >= tableheight)) {
      System.out.println("note: table index is out of range ");
      return;
    }
    if (a == 0){
      if (rulefamily != null){
        return;
      }
      if (lookuptableallused == true){
        lookuptableused = new byte[tablewidth][tableheight];
        for (int x2 = 0;x2 < tablewidth;x2++){
          for (int y2 = 0;y2 < tableheight;y2++){
            lookuptableused[x2][y2] = 1;
          }
        }
        lookuptableallused = false;
      }
    }
    if (lookuptableallused == false){
      lookuptableused[x][y] = ((byte) a);
    }
  }
  public int getlookuptableused(int x,int y) {
    if ((x < 0) | (y < 0) | (x >= tablewidth) | (y >= tableheight)) {
    //  System.out.println("note: table index is out of range");
      return 1;
    }
    if (lookuptableallused == false){
      return lookuptableused[x][y];
    }else{
      return 1;
    }
  }

  //this function writes to the rule table
  //Parameters:
  //  x: the entry's x offset or the neighborhood count
  //  y: the entry's y offset or the cell's state
  //  a: the entry's new value
  public void setlookuptable(int x,int y,int a) {
    if ((x < 0) | (y < 0) | (x >= tablewidth) | (y >= tableheight)) {
      System.out.println("note: table index is out of range" + x + " " + y);
      return;
    }
    if (a >= 128){ 
      a = a - 256;
    }
    lookuptable[x][y] = ((byte) a);
    rulechange = 2;
  }
  
  //this function reads from the rule table
  //Parameters:
  //  x: the entry's x offset or the neighborhood count
  //  y: the entry's y offset or the cell's state
  //Returns:
  //  the entry's value
  public int getlookuptable(int x,int y) {
    if ((x < 0) | (y < 0) | (x >= tablewidth) | (y >= tableheight)) {
    //  System.out.println("note: table index is out of range");
      return 0;
    }
    int a = lookuptable[x][y];
    if (a < 0) {a = a + 256;}
    return ((int) a);
  }
  
};
class mousemotionlisc implements MouseMotionListener{
  int x2;
  int y2;
  
  int getsqx(int x){
    x = x - 0;
    x = x / cellautomainwindowc.sqsize;
    x = x + cellautoapp.offsetx;
    return x;
  }
  int getsqy(int y){
    y = y - 0;
    y = y / cellautomainwindowc.sqsize;
    y = y + cellautoapp.offsety;
    return y;
  }
  public void mouseDragged(MouseEvent e){
    Graphics g = cellautoapp.cellautomainwindow.getGraphics();
    int x = getsqx(e.getX());
    int y = getsqy(e.getY());
    //mouselisc.x2 = x;
    //mouselisc.y2 = y;
    
    //if (cellautoapp.toollistindex == cellautoapp.SELECT_TOOL){}
    if (mouselisc.mouse_in_selection == true) {
      if ((x != x2) | (y != y2)) {
        cellautoapp.selx1 = x-mouselisc.mouse_selection_offsetx;
        cellautoapp.sely1 = y-mouselisc.mouse_selection_offsety;
        cellautoapp.selx2 = (x-mouselisc.mouse_selection_offsetx) + cellautoapp.selw;
        cellautoapp.sely2 = (y-mouselisc.mouse_selection_offsety) + cellautoapp.selh;
        cellautoapp.setupsel();
        cellautoapp.cellautomainwindow.repaint();
      }
    } else {
      if (cellautoapp.toollistindex == cellautoapp.PENCIL_TOOL){
        cellautoapp.board.setsq(x,y,cellautoapp.colorlistindex);
        cellautoapp.board2.setsq(x,y,cellautoapp.colorlistindex);
        cellautoapp.cellautomainwindow.paintsquare(g,x-cellautoapp.offsetx,y-cellautoapp.offsety,cellautoapp.colorlistindex);
      }
    }
    x2 = x;
    y2 = y;
  }
  public void mouseMoved(MouseEvent e){
    
  }
  
}
class mouselisc implements MouseListener{
  int x1;
  int y1;
  int x2;
  int y2;
  
  static boolean mouse_in_selection;
  static int mouse_selection_offsetx;
  static int mouse_selection_offsety;
  
  int getsqx(int x){
    x = x - 0;
    x = x / cellautomainwindowc.sqsize;
    x = x + cellautoapp.offsetx;
    return x;
  }
  int getsqy(int y){
    y = y - 0;
    y = y / cellautomainwindowc.sqsize;
    y = y + cellautoapp.offsety;
    return y;
  }
  public void mouseClicked(MouseEvent e){
    //System.out.println("clicked");
  }
  public void mouseEntered(MouseEvent e){
    //System.out.println("entered");
    
  }
  public void mouseExited(MouseEvent e){
    
    //System.out.println("exited");
  }
  public void mousePressed(MouseEvent e){
    if (cellautoapp.verbose == true) {
      System.out.println("pressed");
    }
    mouselisc.mouse_in_selection = false;
    x1 = getsqx(e.getX());
    y1 = getsqy(e.getY());
    if (((x1 >= cellautoapp.selx) & (x1 < (cellautoapp.selx+cellautoapp.selw))) &
        ((y1 >= cellautoapp.sely) & (y1 < (cellautoapp.sely+cellautoapp.selh)))){
      //move the selection 
        if (e.isControlDown()){
          cellautoapp.pasteseldata();
        }
        mouselisc.mouse_in_selection = true;
        mouselisc.mouse_selection_offsetx = x1 - cellautoapp.selx;
        mouselisc.mouse_selection_offsety = y1 - cellautoapp.sely;
     }    
    
  }
  public void mouseReleased(MouseEvent e){
    if (cellautothreadc.running == true){
      cellautoapp.stop();
      return;
      //cellautothreadc.done = true;
    }
    if (cellautoapp.verbose == true) {
      System.out.println("release");
    }
    //get the x,y chord of the cell that was clicked
    x2 = getsqx(e.getX());
    y2 = getsqy(e.getY());
    if (cellautoapp.verbose == true) {
      System.out.println(" x1 " + x1 + " y1 " + y1 + " x2 " + x2 + " y2 " + y2);
    }
    if (mouselisc.mouse_in_selection == true) {
          cellautoapp.selx1 = x2-mouselisc.mouse_selection_offsetx;
          cellautoapp.sely1 = y2-mouselisc.mouse_selection_offsety;
          cellautoapp.selx2 = (x2-mouselisc.mouse_selection_offsetx) + cellautoapp.selw;
          cellautoapp.sely2 = (y2-mouselisc.mouse_selection_offsety) + cellautoapp.selh;
          cellautoapp.setupsel();
          return;
    }
    if (cellautoapp.toollistindex == cellautoapp.COLOR_PICKER_TOOL){
      int a1 = cellautoapp.board.getsq(x2,y2);
      cellautoapp.colorbox.colorboxpanel.selcolor = a1;
      cellautoapp.colorlistindex = a1;
      if (cellautoapp.addeditstatedialog.isVisible() == true){
        cellautoapp.addeditstatedialog.selectstate(cellautoapp.colorlistindex);
      }
      cellautoapp.updatestatusbar();
      cellautoapp.colorbox.colorboxpanel.repaint();
    }
    if (cellautoapp.toollistindex == cellautoapp.TABLE_TOOL){
      int i = cellautoapp.colorlistindex;
      int a1 = cellautoapp.board.getsq(x2,y2);
      int a2 = cellautoapp.cellauto131.getneighborvalue(cellautoapp.board,x2,y2);
      int a3 = cellautoapp.cellauto131.getlookuptableused(a2,a1);
      if (a3 <= 0){
        cellautoapp.cellauto131.setlookuptable(a2,a1,i);
      }
      cellautoapp.edittablewindow.repaint();
      cellautoapp.cellautomainwindow.repaint();
    }

    if (cellautoapp.toollistindex == cellautoapp.LINE_TOOL){
      cellautoapp.drawline(x1,y1,x2,y2);
    }
    
    if (cellautoapp.toollistindex == cellautoapp.CIRCLE_TOOL){
      cellautoapp.drawcircle(x1,y1,x2,y2);
    }

    if (cellautoapp.toollistindex == cellautoapp.FILLEDCIRCLE_TOOL){
      cellautoapp.fillcircle(x1,y1,x2,y2);
    }
    
    if (cellautoapp.toollistindex == cellautoapp.RECTANGLE_TOOL){
      cellautoapp.drawrectangle(x1,y1,x2,y2);
    }

    if (cellautoapp.toollistindex == cellautoapp.FILL_TOOL){
      int c1 = cellautoapp.colorlistindex;
      int c2 = cellautoapp.board.getsq(x2,y2);
      cellautoapp.bucketfill(x2,y2,c1,c2,10000);
      cellautoapp.cellautomainwindow.repaint();
    }
    if (cellautoapp.toollistindex == cellautoapp.PENCIL_TOOL){
      Graphics g = cellautoapp.cellautomainwindow.getGraphics();
      cellautoapp.board.setsq(x2,y2,cellautoapp.colorlistindex);
      cellautoapp.board2.setsq(x2,y2,cellautoapp.colorlistindex);
      cellautoapp.cellautomainwindow.paintsquare(g,x2-cellautoapp.offsetx,y2-cellautoapp.offsety,cellautoapp.colorlistindex);
      
    }
    
    if (cellautoapp.toollistindex == cellautoapp.ZOOMIN_TOOL){
      cellautoapp.zoom(x2,y2,cellautoapp.ZOOM_IN);
      cellautoapp.cellautomainwindow.repaint();
    }

    if (cellautoapp.toollistindex == cellautoapp.ZOOMOUT_TOOL){
      int x = cellautoapp.offsetx;
      int y = cellautoapp.offsety;
      cellautoapp.zoom(x2,y2,cellautoapp.ZOOM_OUT);
      cellautoapp.cellautomainwindow.repaint();
    }
    
    if (cellautoapp.toollistindex == cellautoapp.FILLEDRECTANGLE_TOOL){
      cellautoapp.fillrectangle(x1,y1,x2,y2);
    }

    if (cellautoapp.toollistindex == cellautoapp.SELECT_TOOL){
        if ((x1 != x2) | (y1 != y2)){
          cellautoapp.selx1 = x1;
          cellautoapp.sely1 = y1;
          cellautoapp.selx2 = x2+1;
          cellautoapp.sely2 = y2+1;
        }else{
          cellautoapp.selx1 = 0;
          cellautoapp.sely1 = 0;
          cellautoapp.selx2 = 0;
          cellautoapp.sely2 = 0;
        }
        cellautoapp.pasteseldata();
        cellautoapp.setupsel();
        cellautoapp.cutseldata();
      
      cellautoapp.cellautomainwindow.repaint();
    }

    if (cellautoapp.toollistindex == cellautoapp.MOVE_TOOL){
      int dx = x2 - x1;
      int dy = y2 - y1;
      if (((x1 >= cellautoapp.selx) & (x1 < (cellautoapp.selx+cellautoapp.selw))) &
        ((y1 >= cellautoapp.sely) & (y1 < (cellautoapp.sely+cellautoapp.selh)))){
      //move the selection 
        cellautoapp.selx1 = cellautoapp.selx1 + dx;
        cellautoapp.sely1 = cellautoapp.sely1 + dy;
        cellautoapp.selx2 = cellautoapp.selx2 + dx;
        cellautoapp.sely2 = cellautoapp.sely2 + dy;
        cellautoapp.setupsel();
      }else{
        cellautoapp.pasteseldata();
        cellautoapp.selx1 = x2;
        cellautoapp.sely1 = y2;
        cellautoapp.selx2 = x2;
        cellautoapp.sely2 = y2;
        cellautoapp.setupsel();
      }
      cellautoapp.cellautomainwindow.repaint();
    }
    
    int dx2 = x2-cellautomainwindowc.selx;
    int dy2 = y2-cellautomainwindowc.sely;
    cellautomainwindowc.selx = x2;
    cellautomainwindowc.sely = y2;
    cellautoapp.cellautomainwindow.updateselsq(dx2,dy2);

    cellautoapp.cellautowindowframe.requestFocusInWindow();
    
    
  }
  
};  
  
//this is class that is a 32x32 block of cells
class blockc{
  int usedbitboard[];
  byte board[][];
  int popcount;
  void printblock(){
    for (int x = 0;x < 32;x++){
      for (int y = 0;y < 32;y++){
        System.out.print(board[x][y]);
      }
      System.out.println();
    }
  }
  boolean equals(blockc b){
    for (int x = 0;x < 32;x++){
      for (int y = 0;y < 32;y++){
        if (this.board[x][y] != b.board[x][y]){
          return false;
        }
      }
    }
    return true;
  }
  void clearusedbitboard(){
    for (int i = 0;i < 4;i++){
      usedbitboard[i] = 0;
    }
  }
  void fillusedbitboard(){
    for (int i = 0;i < 4;i++){
      usedbitboard[i] = -1;
    }
  }
  void clearused(int x,int y){
    int a1 = ((y << 3) + x) & 31;
    int a2 = (y >> 2);
    usedbitboard[a2] = usedbitboard[a2] & ~(1 << a1);
  }
  void clearused2(int x,int y){
    int a1 = ((y << 3) + x) & 31;
    int a2 = (y >> 2);
    usedbitboard[a2] = usedbitboard[a2] & ~(1 << a1);
  
  }
  
  void writeused(int x,int y){
    int a1 = ((y << 3) + x) & 31;
    int a2 = (y >> 2);
    usedbitboard[a2] = usedbitboard[a2] | (1 << a1);
  }
  void writeused2(int x,int y){
    int a1 = ((y << 3) + x) & 31;
    int a2 = ((y >> 2) + 2);
    usedbitboard[a2] = usedbitboard[a2] | (1 << a1);
  }
  int readused(int x,int y){
    int a1 = ((y << 3) + x) & 31;
    int a2 = (y >> 2);
    return (usedbitboard[a2] >> a1)&1;
  }
  int readused2(int x,int y){
    int a1 = ((y << 3) + x) & 31;
    int a2 = ((y >> 2) + 2);
    return (usedbitboard[a2] >> a1)&1;
  }

  blockc(int a){
    usedbitboard = new int[4];
    board = new byte[32][32];
    for (int x = 0;x < 32;x++){
      for (int y = 0;y < 32;y++){
        board[x][y] = (byte) a;
      }
    }
  }

  blockc(blockc b){
    usedbitboard = new int[4];
    board = new byte[32][32];
    for (int i = 0;i < 4;i++){
      usedbitboard[i] = b.usedbitboard[i];
    }
    for (int x = 0;x < 32;x++){
      for (int y = 0;y < 32;y++){
        board[x][y] = b.board[x][y];
      }  
    }
  }

  void copy(blockc b){
    //usedbitboard = new int[4];
    for (int i = 0;i < 4;i++){
      usedbitboard[i] = b.usedbitboard[i];
    }
    for (int x = 0;x < 32;x++){
      for (int y = 0;y < 32;y++){
        board[x][y] = b.board[x][y];
      }  
    }
  }
}  

class simpleboardc extends boardc {
  int sq[][];
  int width = 1;
  int height = 1;
  //boardc() {}
  int get_width(){
    return this.width;
  }
  int get_height(){
    return this.height;
  }

  simpleboardc(int w,int h) {
    this.width = w;
    this.height = h;
    sq = new int[this.width][this.height];
  }
  simpleboardc(boardc b) {
    this.width = b.get_width();
    this.height = b.get_height();
    sq = new int[this.width][this.height];
    this.copy(b);
  }
  void copy(boardc b){
    if (this.width != b.get_width()) {return;}
    if (this.height != b.get_height()) {return;}
    for (int x = 0;x < this.width;x++) {
      for (int y = 0;y < this.height;y++) {
        setsq(x,y,(byte) b.getsq(x,y));
      }
    }
  }
  int getsq(int x,int y){
    int x2 = 0;
    int y2 = 0;
    if ((this.width > 1) | (this.height > 1)){
      x2 = x % this.width;
      y2 = y % this.height;
      if (x2 < 0){x2 = x2 + this.width;}
      if (y2 < 0){y2 = y2 + this.height;}
    }
    return sq[x2][y2];
  }
  void setsq(int x,int y,int a){
    int x2 = 0;
    int y2 = 0;
    if ((this.width > 1) | (this.height > 1)){
      x2 = x % this.width;
      y2 = y % this.height;
      if (x2 < 0){x2 = x2 + this.width;}
      if (y2 < 0){y2 = y2 + this.height;}
    }
    sq[x2][y2] = a;
  }
  int get_background_color(){
    return 0;
  }
  int get_background_color2(int x,int y,int t){
    return 0;
  }
  public boolean equals(boardc b){
    //System.out.println("this.width " + this.width);
    //System.out.println("this.height " + this.height);

    if (this.get_width() != b.get_width()) {return false;}
    if (this.get_height() != b.get_height()) {return false;}
    for (int x = 0;x < this.get_width();x++) {
      for (int y = 0;y < this.get_height();y++) {
        if (this.getsq(x,y) != b.getsq(x,y)) {return false;}
      }
    }
    return true;
  }
}

//this class is board made of cells
class boardc {
  blockc block[][];
  byte usedblock[][];
  int width;
  int height;
  simpleboardc background_tile_sub_board = null;
  simpleboardc background_tile_sub_board2 = null;
  int dfcolor = 0;
  int dfcolor2 = 0;
  int popcount = 0;
  boolean wrapx = true;
  boolean wrapy = true;
  boardc(){
  }
  //make a new board
  boardc(int w,int h){
    width = w;
    height = h;
    wrapx = true;
    wrapy = true;
    int w2 = ((width+31) >> 5);
    int h2 = ((height+31) >> 5);
    background_tile_sub_board = new simpleboardc(1,1);
    background_tile_sub_board2 = new simpleboardc(1,1);
    block = new blockc[w2][h2];
    usedblock = new byte[w2][h2];
    for (int x = 0;x < w2;x++){
      for (int y = 0;y < h2;y++){
        block[x][y] = null;
      }
    }
  }
  
  //copy board
  boardc(boardc b){
    wrapx = b.wrapx;
    wrapy = b.wrapy;
    background_tile_sub_board = new simpleboardc(b.background_tile_sub_board);
    background_tile_sub_board2 = new simpleboardc(b.background_tile_sub_board2);

    //if (b.background_tile_sub_board != null){
    //  background_tile_sub_board = new simpleboardc(b.background_tile_sub_board);
    //}
    //if (b.background_tile_sub_board2 != null){
    //  background_tile_sub_board2 = new simpleboardc(b.background_tile_sub_board2);
    //}
    dfcolor = b.dfcolor;
    dfcolor2 = b.dfcolor2;
    popcount = b.popcount;    
    width = b.width;
    height = b.height;
    int w2 = ((width+31) >> 5);
    int h2 = ((height+31) >> 5);
    
    block = new blockc[w2][h2];
    usedblock = new byte[w2][h2];
    for (int x = 0;x < w2;x++){
      for (int y = 0;y < h2;y++){
        if (b.block[x][y] == null){
          block[x][y] = null;
        }else{
          block[x][y] = new blockc(b.block[x][y]);
        }
        usedblock[x][y] = b.usedblock[x][y];
      }
    }
    
  }
  

  //this function copies the board
  void copy(boardc b){
    int w2 = ((width+31) >> 5);
    int h2 = ((height+31) >> 5);
    background_tile_sub_board = null;
    if (b.background_tile_sub_board != null){
      background_tile_sub_board = new simpleboardc(b.background_tile_sub_board);
    }
    background_tile_sub_board2 = null;
    if (b.background_tile_sub_board2 != null){
      background_tile_sub_board2 = new simpleboardc(b.background_tile_sub_board2);
    }
    dfcolor = b.dfcolor;
    dfcolor2 = b.dfcolor2;
    popcount = b.popcount;    
    for (int x = 0;x < w2;x++){
      for (int y = 0;y < h2;y++){
        if (b.block[x][y] != null){
          if (block[x][y] == null){
            block[x][y] = new blockc(b.block[x][y]);
          }else{
            block[x][y].copy(b.block[x][y]);
          }
          usedblock[x][y] = b.usedblock[x][y];
        }
      }
    }
  }
  //boolean equals(){
  
  //}
  int get_width(){
    return this.width;
  }
  int get_height(){
    return this.height;
  }
  
  //this function checks if a row is empty
  boolean emptyline(int r){
    boolean b = true;
    for (int i = 0;i < width;i++){
      int sq = getsq(i,r);
      if (sq != get_background_color(i,r)){
        b = false;
      }
    }
    return b;
  }  
  
  void readsqcrle(String str){
    //System.out.println(" str " + str);
    int l = str.length();
    int x = 0;
    int y = 0;
    int n = 0;
    int i = 0;
    char ch = 0;
    while (i < l) {
      n = 0;
      ch = str.charAt(i);
      i++;
      while ((ch >= '0') && (ch <= '9')) {
        n = (n * 10) + (ch - 48);
        ch = str.charAt(i);
        i++;
      }
      if (n == 0) {n = 1;}
      if (ch == '$') {
        y = y + n;
        x = 0;
      } else {
        if (ch == '.') {
          x = x + n;
        } else {
          for (int i2 = 0;i2 < n;i2++){
            setsq(x,y,ch-64);
            //System.out.println(" x  " + x + " y  " + y + " ch  " + ch);
            x++;
          }
        }
      }
      //i++;
    }
  }
  String writesqcrle() {
    String str = "";
    int w = 0;
    char lastState = '0';
    boolean blankLine = false;
    char state;
    int n = 0;
    //int x = 0;
    //int y = 0;
    for (int y = 0;y < height;y++) {
      blankLine = true;
      for (int x = 0;x < width;x++) {
        if (getsq(x,y) > 0) {
          blankLine = false;
          break;
        }
      }
      if (blankLine) {
	if (lastState == '$') {n++;}
	else{
	  lastState = '$';
	  n = 1;
	}
        continue;           
      } else {
        for (int x = width - 1;x >= 0;x--){
          if (getsq(x,y) > 0) {
            w = x;
            break;
          }
        }
        for (int x = 0;x <= w;x++) {
          state = (char)(getsq(x,y) + 64);
          if (state == '@') {state = '.';}
          if (n == 0) {
            lastState = state;
	    n = 1;
	  } else if (state == lastState) {
            n++;
          } else {
            if (n > 1) {
              str = str + n;
	    }  
            str = str + lastState;             
	    if (str.length() >= 80) {
              str = str + "\n #L ";
	    }

            lastState = state;
            n = 1;
          }
        }
        if (lastState == '$'){n++; }
        else {
          if (n > 1) {
            str = str + n;
          }  
          str = str + lastState;             
          if (str.length() >= 67) {
            str = str + "\n #L ";
	  }          
          lastState = '$';
          n = 1;
        }
      }
    }
    return str;
  }
  //this function reads a run length encoded string into a row
  void readrle(int r,String str){
    int l = str.length();
    int a0 = 0;
    int a1 = 0;
    int a2 = 0;
    int a3 = 0;
    
    if (r < 0){return;}
    if (r >= height){return;}
    for (int i = 0;i < l;i++){
      char ch = str.charAt(i);
      if ((ch >= 'a')& (ch <= 'z')){
        if (a0 == 0){
          for (int i2 = 0;i2 < a2;i2++){
            if (a3 < width){
              setsq(a3,r,a1);
              //if (a1 == 1){
              //  int db = getsq(a3,r);
              //}
              a3++;
            }
          }
          a1 = ch - 97;
          
          a0 = 1;
          a2 = 0;
        }else{
          a0 = 0;
          a1 = (a1 << 4) + (ch - 97);
          a2 = 0;
        }
      }
      if ((ch >= '0') & (ch <= '9')){
        a2 = (a2*10) + (ch - 48);
      }
    }
    for (int i2 = 0;i2 < a2;i2++){
      if (a3 < width){
        setsq(a3,r,a1);
        a3++;
      }
    }
    
  }
  
  //this function writes a row to a new run length encoded string
  String writerle(int r){
    StringBuffer str = new StringBuffer();
    int a0 = getsq(0,r);
    int a1 = getsq(0,r);
    int a2 = 0;
    for (int i = 0;i < width;i++){
      a1 = getsq(i,r);
      if (a0 != a1){
        char ch1 = (char) ((a0 >> 4) + 97);
        char ch2 = (char) ((a0 & 15) + 97);
        str.append(ch1);
        str.append(ch2);
        str.append(a2);
        a2 = 1;
      }else{
        a2++;
      }
      a0 = a1;
    }

    char ch1 = (char) ((a0 >> 4) + 97);
    char ch2 = (char) ((a0 & 15) + 97);
    str.append(ch1);
    str.append(ch2);
    str.append(a2);
    return str.toString();
  }
  //getsq reads a cell from the board
  //Parameters:
  //  x: the cell's x offset
  //  y: the cell's y offset
  //Returns:
  //  the cell's state
  int getsq(int x,int y){
    int a0 = 0;
    while (x < 0){
      if (wrapx == false) {return get_background_color(x,y);}
      x = x + width;
      a0 = a0 ^ 1;
    }
    while (y < 0){
      if (wrapy == false) {return get_background_color(x,y);}
      y = y + height;
      a0 = a0 ^ 2;
    }
    while (x >= width){
      if (wrapx == false) {return get_background_color(x,y);}
      x = x - width;
      a0 = a0 ^ 1;
    }
    while (y >= height){
      if (wrapy == false) {return get_background_color(x,y);}
      y = y - height;
      a0 = a0 ^ 2;
    }
    if ((a0 & 1) == 1){
      if ((cellautoapp.symmetrybits & cellautoapp.HORIZONTAL_SYMMETRY) == cellautoapp.HORIZONTAL_SYMMETRY){
        if ((cellautoapp.symmetrybits & cellautoapp.INCLUDE_VERTICAL_LINE) == cellautoapp.INCLUDE_VERTICAL_LINE){
          x = width - x;
        }else{
          x = (width - x) - 1;
        }
      }
    }
    if ((a0 & 2) == 2){
      if ((cellautoapp.symmetrybits & cellautoapp.VERTICAL_SYMMETRY) == cellautoapp.VERTICAL_SYMMETRY){
        if ((cellautoapp.symmetrybits & cellautoapp.INCLUDE_HORIZONTAL_LINE) == cellautoapp.INCLUDE_HORIZONTAL_LINE){
          y = height - y;
        }else{
          y = (height - y) - 1;
        }
      }
    }
    //while (x < 0){x = x + width;}
    //while (y < 0){y = y + height;}
    //while (x >= width){x = x - width;}
    //while (y >= height){y = y - height;}
    blockc b = block[x >> 5][y >> 5];
    if (b == null){
      return get_background_color(x,y);
    }else{
      int sq = b.board[x & 31][y & 31];
      if (sq < 0){sq = sq + 256;}
      return sq;
    }
    
  }
  int readused(int x,int y) {
    blockc bl = this.block[x >> 5][y >> 5];
    if (bl != null) {
      return bl.readused((x & 31) >> 2,(y & 31) >> 2);
    }
    return 0;
  }
  //int get_background_color(int x,int y,int t){
  //  if ((background_tile_width == 1) & (background_tile_height == 1)){
  //    return background_tile_color[0][0][t];
  //  } else {
  //    return background_tile_color[x % background_tile_width][y % background_tile_height][t];
  //  }
  //}
  int get_background_color(int x,int y) {
    return get_background_color2(x,y,0);
  }
  int get_background_color2(int x,int y,int t){
    simpleboardc sub = background_tile_sub_board;
    if (t == 1) {sub = background_tile_sub_board2;}
    if (sub != null) {
      //System.out.println(" w " + sub.get_width() + " h " + sub.get_width());
      //if ((sub.get_width() == 1) & (sub.get_height() == 1)) {
      //  return sub.getsq(0,0);
      //} else {
      //  return sub.getsq(x % sub.get_width(),y % sub.get_height());
      //}
      return sub.getsq(x,y);
    } else {
      if (t == 1) { return dfcolor2; }
      return dfcolor;
    }
  }
  int get_background_color3(int t) {
    simpleboardc sub = background_tile_sub_board;
    if (t == 1) {sub = background_tile_sub_board2;}
    if (sub != null) {
      return sub.getsq(0,0);
    } else {
      if (t == 1) { return dfcolor2; }
      return dfcolor;
    }
    
  }
  int get_background_color4() {
    int colorcount[] = new int[256];
    int bestcolor = 0;
    int bestcount = 0;
    for (int x = 0;x < width;x++) {
      for (int y = 0;y < height;y++) {
        int sq = getsq(x,y);
        //if (sq < numcolors) {
          colorcount[sq] = colorcount[sq] + 1;
        //}
      }
    }
    for (int c = 0;c < 256;c++) {
      if (colorcount[c] > bestcount) {
        bestcount = colorcount[c];
        bestcolor = c;
      }
    }
    return bestcolor;
  }
  int get_background_color5(int x,int y,int t) {
    int a = get_background_color2(x,y,t);
    if (a >= 128) {a = a - 256;}
    return a;
  }
  void clearusedbitboard(){
    int w2 = ((width+31) >> 5);
    int h2 = ((height+31) >> 5);
    for (int x = 0;x < w2;x++){
      for (int y = 0;y < h2;y++){
        if (block[x][y] != null){
          block[x][y].clearusedbitboard();
          usedblock[x][y] = 0;
        }
      }
    }
  }
  public boolean equals(boardc b){
    if (this.get_width() != b.get_width()) {return false;}
    if (this.get_height() != b.get_height()) {return false;}
    
    int w2 = ((this.get_width()+31) >> 5);
    int h2 = ((this.get_height()+31) >> 5);
    for (int x = 0;x < w2;x++){
      for (int y = 0;y < h2;y++){
        if (this.is_block_empty(this.block[x][y],x << 5,y << 5) == false){
          if (b.is_block_empty(b.block[x][y],x << 5,y << 5) == false){
            if (this.block[x][y].equals(b.block[x][y]) == false) { return false; }
          } else { 
            return false;
          }
        } else {
          if (b.is_block_empty(b.block[x][y],x << 5,y << 5) == false){
            return false;
          }
        }
      }
    }
    return true;
  }
  boolean is_block_empty(blockc b,int x,int y){
    if (b == null) {return true;}
    for (int x2 = 0;x2 < 32;x2++){
      for (int y2 = 0;y2 < 32;y2++){
        if (b.board[x2][y2] != this.get_background_color(x+x2,y+y2)) {
          return false;
        }
      }
    }
    return true;
  }

  blockc make_new_block(int x,int y){
    simpleboardc sub = background_tile_sub_board;
    blockc b = new blockc(dfcolor);
    if (sub != null){
     
      int x3 = x % sub.get_width();
      for (int x2 = 0;x2 < 32;x2++){
        int y3 = y % sub.get_height();
        for (int y2 = 0;y2 < 32;y2++){
          b.board[x2][y2] = (byte) sub.getsq(x3,y3);
          y3 = y3 + 1;
          if (y3 == sub.get_height()){y3 = 0;}
        }
        x3 = x3 + 1;
        if (x3 == sub.get_width()){x3 = 0;}
      }
    }
    return b;
  }

  //setsq writes a cell to the board
  //and also keeps track of what blocks are active
  //Parameters:
  //  x: the cell's x offset
  //  y: the cell's y offset
  //  a: the cell's new state
  void setsq(int x,int y,int a){
    int a0 = 0;
    while (x < 0){
      if (wrapx == false) {return;}
      x = x + width;
      a0 = a0 ^ 1;
    }
    while (y < 0){
      if (wrapy == false) {return;}
      y = y + height;
      a0 = a0 ^ 2;
    }
    while (x >= width){
      if (wrapx == false) {return;}
      x = x - width;
      a0 = a0 ^ 1;
    }
    while (y >= height){
      if (wrapy == false) {return;}
      y = y - height;
      a0 = a0 ^ 2;
    }
    if ((a0 & 1) == 1){
      if ((cellautoapp.symmetrybits & cellautoapp.HORIZONTAL_SYMMETRY) == cellautoapp.HORIZONTAL_SYMMETRY){
        if ((cellautoapp.symmetrybits & cellautoapp.INCLUDE_VERTICAL_LINE) == cellautoapp.INCLUDE_VERTICAL_LINE){
          x = width - x;
        }else{
          x = (width - x) - 1;
        }
      }
    }
    if ((a0 & 2) == 2){
      if ((cellautoapp.symmetrybits & cellautoapp.VERTICAL_SYMMETRY) == cellautoapp.VERTICAL_SYMMETRY){
        if ((cellautoapp.symmetrybits & cellautoapp.INCLUDE_HORIZONTAL_LINE) == cellautoapp.INCLUDE_HORIZONTAL_LINE){
          y = height - y;
        }else{
          y = (height - y) - 1;
        }
      }
    }
    blockc b = block[x >> 5][y >> 5];
    if (b == null){
      if (a == get_background_color(x,y)){return;}
      block[x >> 5][y >> 5] = make_new_block(x & 0xFFFFFFE0,y & 0xFFFFFFE0);
      b = block[x >> 5][y >> 5];
    }
    
    if (b.board[x & 31][y & 31] == get_background_color2(x,y,1)){
      if (a != get_background_color(x,y)){
        popcount++;
        b.popcount++;
      }
    }else{
      if (a == get_background_color(x,y)){
        popcount--;
        b.popcount--;
      }
    }

    if ((b.board[x & 31][y & 31] != get_background_color2(x,y,1)) | (a != get_background_color(x,y))){
      if (b.board[x & 31][y & 31] != ((byte) a)){
        useblock(b,x,y);
      }
    }
    if (a >= 128){a = a - 256;}

    b.board[x & 31][y & 31] = ((byte) a);
  }
  int getpopcountofblock(int x,int y) {
    int a0 = 0;
    while (x < 0){
      if (wrapx == false) {return 0;}
      x = x + width;
      a0 = a0 ^ 1;
    }
    while (y < 0){
      if (wrapy == false) {return 0;}
      y = y + height;
      a0 = a0 ^ 2;
    }
    while (x >= width){
      if (wrapx == false) {return 0;}
      x = x - width;
      a0 = a0 ^ 1;
    }
    while (y >= height){
      if (wrapy == false) {return 0;}
      y = y - height;
      a0 = a0 ^ 2;
    }
    if ((a0 & 1) == 1){
      if ((cellautoapp.symmetrybits & cellautoapp.HORIZONTAL_SYMMETRY) == cellautoapp.HORIZONTAL_SYMMETRY){
        if ((cellautoapp.symmetrybits & cellautoapp.INCLUDE_VERTICAL_LINE) == cellautoapp.INCLUDE_VERTICAL_LINE){
          x = width - x;
        }else{
          x = (width - x) - 1;
        }
      }
    }
    if ((a0 & 2) == 2){
      if ((cellautoapp.symmetrybits & cellautoapp.VERTICAL_SYMMETRY) == cellautoapp.VERTICAL_SYMMETRY){
        if ((cellautoapp.symmetrybits & cellautoapp.INCLUDE_HORIZONTAL_LINE) == cellautoapp.INCLUDE_HORIZONTAL_LINE){
          y = height - y;
        }else{
          y = (height - y) - 1;
        }
      }
    }

    blockc b = block[x >> 5][y >> 5];
    if (b == null) {
      return 0;
    }
    return b.popcount;
  }
  void usenonstillblocks(boardc b2){
    int w2 = ((width+31) >> 5);
    int h2 = ((height+31) >> 5);
    for (int x = 0;x < w2;x++){
      for (int y = 0;y < h2;y++){
        if (block[x][y] != null){
          for (int x2 = 0;x2 < 8;x2++){
            for (int y2 = 0;y2 < 8;y2++){
              int a0 = 0;
              for (int x3 = 0;x3 < 4;x3++){
                for (int y3 = 0;y3 < 4;y3++){
                  int a1 = block[x][y].board[(x2 << 2)+x3][(y2 << 2)+y3];
                  int a2 = 0;
                  if (b2 != null){
                    if (b2.block[x][y] != null){
                      a2 = b2.block[x][y].board[(x2 << 2)+x3][(y2 << 2)+y3];
                    } else {
                      a2 = get_background_color((x << 5)+(x2 << 2)+x3,(y << 5)+(y2 << 2)+y3);
                    }
                  } else {a2 = 0;}
                  if (a1 != a2){
                    a0 = 1;
                  }
                }
              }
              if (a0 == 1){
                useblock(block[x][y],(x << 5)+(x2 << 2),(y << 5)+(y2 << 2));
              }
            }
          }
        }
      }
    }
  }
  void count_states_into_array(int c[]){
    for (int x = 0;x < width;x++) {
      for (int y = 0;y < height;y++) {
        int n = getsq(x,y);
        c[n] = c[n] + 1;
      }
    }    
  }
  void changecellstates(int s1,int s2) {
    if (s1 == s2) {return;}
    if (s1 >= 128){s1 = s1 - 256;}
    if (s2 >= 128){s2 = s2 - 256;}
    
    int w2 = ((width+31) >> 5);
    int h2 = ((height+31) >> 5);
    for (int x = 0;x < w2;x++){
      for (int y = 0;y < h2;y++){
        int a2 = 0;
        blockc b = block[x][y];
        if (b != null){
          for (int x2 = 0;x2 < 32;x2++) {
            for (int y2 = 0;y2 < 32;y2++) {
              int a1 = b.board[x2][y2];          
              if (a1 == s1) {
                b.board[x2][y2] = (byte) s2;
              }
            }
          }
        }
      }
    }
  }
  void usenonemptyblocks(){
    int w2 = ((width+31) >> 5);
    int h2 = ((height+31) >> 5);
    for (int x = 0;x < w2;x++){
      for (int y = 0;y < h2;y++){
        int a2 = 0;
        if (block[x][y] != null){
          for (int x2 = 0;x2 < 8;x2++){
            for (int y2 = 0;y2 < 8;y2++){
              int a0 = 0;
              for (int x3 = 0;x3 < 4;x3++){
                for (int y3 = 0;y3 < 4;y3++){
                  int a1 = block[x][y].board[(x2 << 2)+x3][(y2 << 2)+y3];
                  int bg = get_background_color((x << 5)+(x2 << 2)+x3,(y << 5)+(y2 << 2)+y3);
                  if (a1 != bg){
                    a0 = 1;
                    a2 = 1;
                  }
                }
              }
              if (a0 == 1){
                useblock(block[x][y],(x << 5)+(x2 << 2),(y << 5)+(y2 << 2));
              }
            }
          }
        }
      }
    }
  }
  //useblock makes a 4x4 block of cells active
  //it also makes the neighbor blocks active
  void useblock(blockc b,int x,int y){
    int x2 = (x >> 2);
    int y2 = (y >> 2);
    if ((b.readused2(x2 & 7,y2 & 7) == 0)){
      int w2 = ((width+3) >> 2);
      int h2 = ((height+3) >> 2);
      int bs = ((cellautoapp.cellauto131.bordersize+3) >> 2);
      if ((width & 3) != 0){
        if (x2 == 0){bs++;}
        if (x2 >= (w2-2)){bs++;}
      }
      if ((height & 3) != 0){
        if (y2 == 0){bs++;}
        if (y2 >= (h2-2)){bs++;}
      }
      for (int dx = -bs;dx <= bs;dx++){
        for (int dy = -bs;dy <= bs;dy++){
          int x3 = x2+dx;
          int y3 = y2+dy;
          if (x3 < 0){x3 = x3 + w2;}
          if (y3 < 0){y3 = y3 + h2;}
          if (x3 >= w2){x3 = x3 - w2;}
          if (y3 >= h2){y3 = y3 - h2;}
          blockc b2 = block[x3 >> 3][y3 >> 3];
          if (b2 == null){
            //block[x3 >> 3][y3 >> 3] = new blockc(dfcolor);
            block[x3 >> 3][y3 >> 3] = make_new_block(x & 0xFFFFFFE0,y & 0xFFFFFFE0);
            b2 = block[x3 >> 3][y3 >> 3];
          }
          usedblock[x3 >> 3][y3 >> 3] = 1;
          b2.writeused(x3 & 7,y3 & 7);
        }
      }
    }
    b.writeused2(x2 & 7,y2 & 7);
  }
};
class actlisc implements ActionListener {   
  public void actionPerformed(ActionEvent e) {
    if (cellautothreadc.running == true){
      cellautoapp.stop();
      cellautothreadc.done = true;
    }
    if (cellautoapp.verbose == true) {
      System.out.println("action");
    }
    String action = e.getActionCommand();
    if (cellautoapp.verbose == true) {
      System.out.println(action);
    }
    if (action.equals("menuaddstates")) {
      if (cellautoapp.addmanystatesdialog == null) {
        cellautoapp.addmanystatesdialog = new addmanystatesdialogc("add a bunch of states");
        cellautoapp.addmanystatesdialog.setBounds(0,0,300,150);
      }
      cellautoapp.addmanystatesdialog.setVisible(true);
    }
    if (action.equals("manystatesaddbuttonclick")) {
      cellautoapp.addmanystatesdialog.addstates();
    }
    if (action.equals("manystatesclosebuttonclick")) {
      cellautoapp.addmanystatesdialog.setVisible(false);
    }
    if (action.equals("simple_file_type_ok_button")) {
      if (cellautoapp.simple_file_type_option_dailogbox != null) {
        cellautoapp.simple_file_type_option_dailogbox.okbuttonclick();
      }
    }
    if (action.equals("simple_file_type_cancel_button")) {
      if (cellautoapp.simple_file_type_option_dailogbox != null) {
        cellautoapp.simple_file_type_option_dailogbox.cancelbuttonclick();
      }
    }
    if (action.equals("menu_make_rule_table_wider")) {
      cellautoapp.cellauto131.makeruletablewider();
      cellautoapp.edittablewindow.repaint();
    }
    if (action.equals("neighborhoodvalues_applybuttonclick")) {
      int bs = cellautoapp.cellauto131.bordersize;
      cellautoapp.neighborhoodvaluesdialog[bs-1].updatebordervalues();
    }
    if (action.equals("neighborhoodvalues_closebuttonclick")) {
      int bs = cellautoapp.cellauto131.bordersize;
      cellautoapp.neighborhoodvaluesdialog[bs-1].setVisible(false);
    }
    if (action.equals("menuneighborhoodvalues")) {
      int bs = cellautoapp.cellauto131.bordersize;
      if (bs > 4) {bs = 4;}
      if (cellautoapp.neighborhoodvaluesdialog[bs-1] == null){
        cellautoapp.neighborhoodvaluesdialog[bs-1] = new neighborhoodvaluesdialogc("neighborhood values",(cellautoapp.cellauto131.bordersize * 2)+1);
        cellautoapp.neighborhoodvaluesdialog[bs-1].setBounds(0,0,400,200);
      }
      cellautoapp.neighborhoodvaluesdialog[bs-1].getbordervalues();
      cellautoapp.neighborhoodvaluesdialog[bs-1].setVisible(true);
    }
    if (action.equals("menuenterneighborhoodsize")){
      int i = (cellautoapp.cellauto131.bordersize * 2)+1;
      String str2 =  Integer.toString(i);
      String str = JOptionPane.showInputDialog("what should the neighborhood width or size be?",str2);
      if (str != null) {
        try {
        int i2 = Integer.valueOf(str.trim()).intValue();
          if (((i2 & 1) == 1) & (i2 > 2) & (i2 < 10)) {
            cellautoapp.cellauto131.resizeborder((i2-1) >> 1);
            if (cellautoapp.infowindow != null){
              cellautoapp.infowindow.updateinfo();
            }
          } else {
            JOptionPane.showMessageDialog(cellautoapp.cellautowindowframe,new JLabel("neighborhood width or size should be a odd number between 2 and 10"),"error",JOptionPane.ERROR_MESSAGE);  
          }
        } catch (NumberFormatException e2) {
            e2.printStackTrace();
            JOptionPane.showMessageDialog(cellautoapp.cellautowindowframe,new JLabel("invalid number"),"error",JOptionPane.ERROR_MESSAGE);  
        }
      }
    }
    if (action.equals("menushowinfowindow")) {
      if (cellautoapp.infowindow == null){
        cellautoapp.infowindow = new infowindowc("info");
        cellautoapp.infowindow.setBounds(0,0,400,200);
      }
      cellautoapp.infowindow.setVisible(true);
      cellautoapp.infowindow.updateinfo();
    }
    if (action.equals("menushowkeylist")) {
      cellautoapp.keylistdescriptionwindow.setVisible(true);
      cellautoapp.keylistdescriptionwindow.show_keys();
    }
    if (action.equals("keylistokbuttonclick")) {
      cellautoapp.keylistdescriptionwindow.setVisible(false);
    }
    if (action.equals("keylistcancelbuttonclick")) {
      cellautoapp.keylistdescriptionwindow.setVisible(false);
    }
    if (action.equals("periodcheckercheckbuttonclick")) {
      cellautoapp.periodcheckerdialog.checkobject();
    }
    if (action.equals("periodcheckerclosebuttonclick")) {
      cellautoapp.periodcheckerdialog.setVisible(false);
    }    
    if (action.equals("neighborhoodvalues_applybuttonclick")) {
      System.out.println("apply");
    }
    if (action.equals("neighborhoodvalues_clearbuttonclick")) {
      System.out.println("clear");
    }
    if (action.equals("rule_family_browser_select_rule_family")) {
      cellautoapp.rulefamilybrowser.select_rule_family();
      if (cellautoapp.infowindow != null){cellautoapp.infowindow.updateinfo();}
    }
    if (action.equals("rule_family_browser_close")) {
      cellautoapp.rulefamilybrowser.setVisible(false);
    }
    if (action.equals("file_browser_load_list")) {
      cellautoapp.filebrowser.loadlist();
    }
    if (action.equals("file_browser_load_file")) {
      cellautoapp.filebrowser.loadfile();
      
    }
    if (action.equals("statistics_window_refresh")) {
      cellautoapp.statistics_window.refresh_button_click();
    }
    if (action.equals("statistics_window_close")) {
      cellautoapp.statistics_window.close_button_click();
    }
    if (action.equals("statistics_window_show")) {
      if (cellautoapp.statistics_window == null) {
        cellautoapp.statistics_window = new statistics_windowc("statistics");
        cellautoapp.statistics_window.setBounds(0,0,200,400);
      }
      cellautoapp.statistics_window.setVisible(true);
      cellautoapp.statistics_window.refresh_button_click();
    }
    if (action.equals("menucopyruletable")) {
      cellautoapp.copy_ruletable_to_clipboard();
      System.out.println("copy rule table");
    }
    if (action.equals("menupasteruletable")) {
      cellautoapp.paste_ruletable_from_clipboard();
      System.out.println("paste rule table");
      cellautoapp.edittablewindow.edittablepanel.repaint();
      cellautoapp.colorbox.colorboxpanel.repaint();
    }
    
    if (action.equals("menuresizeruletable")) {
      String str = "";
      try {
      String str2 = Integer.toString(cellautoapp.cellauto131.tablewidth);
      str = JOptionPane.showInputDialog("what should the width of the rule table?",str2);
      if (str != null) {
        int tablewidth = Integer.valueOf(str.trim()).intValue();
        str2 = Integer.toString(cellautoapp.cellauto131.tableheight);
        str = JOptionPane.showInputDialog("what should the height of the rule table?",str2);
        if (str != null) {
          int tableheight = Integer.valueOf(str.trim()).intValue();

          cellautoapp.cellauto131.resizetable(tablewidth,tableheight);
          cellautoapp.edittablewindow.vscroll.setMaximum(cellautoapp.cellauto131.tableheight);
          cellautoapp.edittablewindow.hscroll.setMaximum(cellautoapp.cellauto131.tablewidth);
          cellautoapp.edittablewindow.edittablepanel.repaint();
          if (cellautoapp.infowindow != null){cellautoapp.infowindow.updateinfo();}
        }
      }
      } catch (NumberFormatException e2) {
        e2.printStackTrace();
        JOptionPane.showMessageDialog(cellautoapp.cellautowindowframe,new JLabel("invalid number"),"error",JOptionPane.ERROR_MESSAGE);  
      }
    }
    if (action.equals("menufillwithcolor")) {
      for (int x = 0;x < cellautoapp.selw;x++) {
        for (int y = 0;y < cellautoapp.selh;y++) {
          cellautoapp.seldata[x][y] = cellautoapp.colorlistindex;
        }
      }
      cellautoapp.cellautomainwindow.repaint();
    }
    if (action.equals("menuclearinsideselection")) {
      int option = JOptionPane.showConfirmDialog(cellautoapp.cellautowindowframe,new JLabel("clear the selection?"),"question",JOptionPane.YES_NO_OPTION,JOptionPane.QUESTION_MESSAGE);
      if (option == JOptionPane.YES_OPTION) { 
        cellautoapp.saveboard();
        for (int x = 0;x < cellautoapp.selw;x++) {
          for (int y = 0;y < cellautoapp.selh;y++) {
            cellautoapp.seldata[x][y] = 0;
          }
        }
      }
      cellautoapp.cellautomainwindow.repaint();
    }
    if (action.equals("menuclearoutsideselection")) {
      int option = JOptionPane.showConfirmDialog(cellautoapp.cellautowindowframe,new JLabel("clear outside the selection?"),"question",JOptionPane.YES_NO_OPTION,JOptionPane.QUESTION_MESSAGE);
      if (option == JOptionPane.YES_OPTION) { 
        cellautoapp.saveboard();
        cellautoapp.board = new boardc(cellautoapp.board.width,cellautoapp.board.height);
        cellautoapp.board2 = new boardc(cellautoapp.board);
        if (cellautoapp.cellauto131.rulefamily != null) {
          cellautoapp.board.background_tile_sub_board = new simpleboardc(
          cellautoapp.cellauto131.rulefamily.get_background_tile_width(),
          cellautoapp.cellauto131.rulefamily.get_background_tile_height());
        } else {
          cellautoapp.board.background_tile_sub_board = new simpleboardc(1,1);
        }
        cellautoapp.updatestatusbar();
        cellautoapp.cellautomainwindow.repaint();
      }
    }
    if (action.equals("menurulefamilyoptions")) {
      if (cellautoapp.cellauto131.rulefamily != null) {
        cellautoapp.cellauto131.rulechange = 2;
        cellautoapp.cellauto131.rulefamily.showoptions();
      } else {
        JOptionPane.showMessageDialog(cellautoapp.cellautowindowframe,new JLabel("this rule family does not have a options window"),"error",JOptionPane.ERROR_MESSAGE);  
      }
    }
    
    if (action.equals("trydiffpostakebackbuttonclick")) {
      cellautoapp.trydiffpositionswindow.takebackbuttonclick();
    }
    if (action.equals("trydiffposmovebuttonclick")) {
      cellautoapp.trydiffpositionswindow.movebuttonclick();
    }

    if (action.equals("trydiffpostrybuttonclick")) {
      cellautoapp.trydiffpositionswindow.trybuttonclick();
    }
    if (action.equals("trydiffpostryandmovebuttonclick")) {
      cellautoapp.trydiffpositionswindow.tryandmovebuttonclick(0);
    
    }
    if (action.equals("genenewbuttonclick")) {
      cellautoapp.genewindow.newrandomgenes2();
    }
    if (action.equals("geneopenbuttonclick")) {
      cellautoapp.genewindow.opengene();
    }
    if (action.equals("genesavebuttonclick")) {
      cellautoapp.genewindow.savegene();
    }
    if (action.equals("genekeepbuttonclick")) {
      cellautoapp.genewindow.keepgenebuttonclick();
    }
    if (action.equals("genereplacebuttonclick")) {
      cellautoapp.genewindow.replacegenebuttonclick();
    }
    if (action.equals("trydiffposclosebuttonclick")) {
      cellautoapp.trydiffpositionswindow.closebuttonclick();
      cellautoapp.trydiffpositionswindow.setVisible(false);
    }

    if (action.equals("menugenes")) {
      if (cellautoapp.genewindow == null){
        cellautoapp.genewindow = new genewindowc("genes");
      }
      cellautoapp.genewindow.setVisible(true);
    }

    if (action.equals("menutrydiffpositions")) {
      if (cellautoapp.trydiffpositionswindow == null) {
        cellautoapp.trydiffpositionswindow = new trydiffpositionswindowc("try different positions for the selection");
      }
      cellautoapp.trydiffpositionswindow.setVisible(true);
    }
    if (action.equals("menudescription")) {
      cellautoapp.editdescriptionwindow.text.setText(cellautoapp.cellauto131.description);
      cellautoapp.editdescriptionwindow.setVisible(true);
    }
    if (action.equals("descriptionokbuttonclick")) {
      cellautoapp.editdescriptionwindow.okbuttonclick();
    }
    if (action.equals("descriptioncancelbuttonclick")) {
      cellautoapp.editdescriptionwindow.cancelbuttonclick();
    }
    if (action.equals("menuoptions")) {
      cellautoapp.optionsdialog.getoptions();
      cellautoapp.optionsdialog.setVisible(true);
    }
    if (action.equals("optionsokbuttonclick")) {
      cellautoapp.optionsdialog.updateoptions();
      cellautoapp.optionsdialog.setVisible(false);
    }
    if (action.equals("optionscancelbuttonclick")) {
      cellautoapp.optionsdialog.setVisible(false);
    }
    if (action.equals("newgameokbuttonclick")) {
      cellautoapp.newgamedialog.newgame();
      cellautoapp.newgamedialog.setVisible(false);
    }
    if (action.equals("newgameapplybuttonclick")) {
      cellautoapp.newgamedialog.newgame();
    }
    if (action.equals("newgameclearbuttonclick")) {
      cellautoapp.newgamedialog.clear();
    }
    if (action.equals("newgamecancelbuttonclick")) {
      cellautoapp.newgamedialog.setVisible(false);
    }
    
    if (action.equals("useselectionbuttonclick")) {
      cellautoapp.newgamedialog.useselection();
    }
    if (action.equals("statecolorbuttonclick")) {
      cellautoapp.addeditstatedialog.selectcolor();
    }
    if (action.equals("stateupdatebuttonclick")) {
      cellautoapp.addeditstatedialog.update();
    }
    if (action.equals("stateclosebuttonclick")) {
      cellautoapp.addeditstatedialog.setVisible(false);
    }
    
    if (action.equals("menuaddstate")) {
      //cellautoapp.addeditstatedialog.setVisible(true);
      cellautoapp.addeditstatedialog.addstate();
    }
    if (action.equals("menueditstate")) {
      cellautoapp.addeditstatedialog.setVisible(true);
      cellautoapp.addeditstatedialog.selectstate(cellautoapp.colorlistindex);
    }
    if (action.equals("menushowperiodchecker")) {
      cellautoapp.periodcheckerdialog.setVisible(true);
      cellautoapp.periodcheckerdialog.defaultlabeltext();
    }    
    if (action.equals("menu_edit_table_grid_spacing")) {
      if (cellautoapp.table_grid_spacing_dialog == null) {
        cellautoapp.table_grid_spacing_dialog = new table_grid_spacing_dialogc("edit rule table grid spacing");
        cellautoapp.table_grid_spacing_dialog.setBounds(0,0,200,150);
      }
      cellautoapp.table_grid_spacing_dialog.get_grid_spacing();
      cellautoapp.table_grid_spacing_dialog.setVisible(true);
    }
    if (action.equals("gridspacing_okbuttonclick")) {
      cellautoapp.table_grid_spacing_dialog.update_grid_spacing();
      cellautoapp.table_grid_spacing_dialog.setVisible(false);
      cellautoapp.edittablewindow.edittablepanel.repaint();
    }
    if (action.equals("gridspacing_cancelbuttonclick")) {
      cellautoapp.table_grid_spacing_dialog.setVisible(false);
    }
    if (action.equals("menushowedittablewindow")) {
      cellautoapp.edittablewindow.setVisible(true);
    }
    if (action.equals("menushowfilebrowser")) {
      if (cellautoapp.filebrowser == null) {
        cellautoapp.filebrowser = new filebrowserc();
        cellautoapp.filebrowser.setBounds(0,0,200,400);
      }
      cellautoapp.filebrowser.setVisible(true);
    }
    if (action.equals("menushowrulefamilybrowser")) {
      cellautoapp.rulefamilybrowser.setVisible(true);
    }
    if (action.equals("menushowcolorbox")) {
      cellautoapp.colorbox.setVisible(true);
    }
    if (action.equals("menushowtoolbox")) {
      cellautoapp.toolbox.setVisible(true);
    }
    if (action.equals("menunew")) {
      cellautoapp.newgamedialog.setVisible(true);
    }
    if (action.equals("menuopen")) {
      cellautoapp.open2();
    }
    if (action.equals("menusave")) {
      cellautoapp.save2();
    }
    if (action.equals("menuexit")) {
      try {
        System.exit(0);
      } catch(SecurityException err) {
        System.out.println("can not exit");
      }
    }
    if (action.equals("rule_table_randomize_buttonclick")) {
      //cellautoapp.randomizeruletable();
      cellautoapp.randomize_rule_table_dialog.randomize_buttonclick();
    }
    if (action.equals("rule_table_close_buttonclick")) {
      cellautoapp.randomize_rule_table_dialog.setVisible(false);
    }
    if (action.equals("rule_table_new_seed_buttonclick")) {
      cellautoapp.randomize_rule_table_dialog.new_seed_buttonclick();
    }
    if (action.equals("menurandtable")) {
      cellautoapp.show_randomize_rule_table_dialog();
    }
    if (action.equals("menufilltable")) {
      cellautoapp.cellauto131.filllookuptableused();
      cellautoapp.cellautomainwindow.repaint();
      cellautoapp.edittablewindow.repaint();
    }
    if (action.equals("menucleartable")) {
      String str = "";
      try {
      str = JOptionPane.showInputDialog("how many generations to calculate?");
      if (str != null) {
        int n = Integer.valueOf(str.trim()).intValue();
        cellautoapp.cellauto131.clearlookuptableused();
        if (cellautoapp.cellauto131.rulefamily != null){
          cellautoapp.cellauto131.setlookuptableused(0,0,1);
        }
        cellautoapp.calc(n,false);
        cellautoapp.cellautomainwindow.repaint();
        cellautoapp.edittablewindow.repaint();
      }
      } catch (NumberFormatException e2) {
        e2.printStackTrace();
        JOptionPane.showMessageDialog(cellautoapp.cellautowindowframe,new JLabel("invalid number"),"error",JOptionPane.ERROR_MESSAGE);  
      }
    }
    if (action.equals("menucut")) {
      cellautoapp.cuttoclipboard();
      cellautoapp.cellautomainwindow.repaint();
    }
    if (action.equals("menucopy")) {
      cellautoapp.copytoclipboard();
      cellautoapp.cellautomainwindow.repaint();
    }
    if (action.equals("menupaste")) {
      cellautoapp.pastefromclipboard();
      cellautoapp.cellautomainwindow.repaint();
    }
    
    if (action.equals("menurandom")) {
      cellautoapp.randomize_selection();
      cellautoapp.cellautomainwindow.repaint();
    }
    if (action.equals("menutableoffset")) {
      String str = "";
      try {
      String str2 = Integer.toString(cellautoapp.cellauto131.tableoffset);
      str = JOptionPane.showInputDialog("what should the table offset be?",str2);
      if (str != null) {
        int n = Integer.valueOf(str.trim()).intValue();
        cellautoapp.cellauto131.tableoffset = n;
        if (cellautoapp.infowindow != null){cellautoapp.infowindow.updateinfo();}
      }
      } catch (NumberFormatException e2) {
        e2.printStackTrace();
        JOptionPane.showMessageDialog(cellautoapp.cellautowindowframe,new JLabel("invalid number"),"error",JOptionPane.ERROR_MESSAGE);  
      }
    }
    if (action.equals("menuflipx")) {
      cellautoapp.flipx();
    }
    if (action.equals("menuflipy")) {
      cellautoapp.flipy();
      
    }
    if (action.equals("menurotatec")) {
      
      cellautoapp.rotatec();
    }
    if (action.equals("menurotatecc")) {
      cellautoapp.rotatecc();
      
    }
    
    
  }
}


class keylisc implements KeyListener{
  
  public void keyPressed(KeyEvent e){
    if (cellautoapp.verbose == true) {
      System.out.println("key press");
    }
    int a = e.getKeyCode();
    char ch = e.getKeyChar();  
    String s = e.getKeyText(a);
    ch = Character.toLowerCase(ch);
    if (cellautothreadc.running == true){
      boolean b = true;
      if (a == KeyEvent.VK_UP){b = false;}
      if (a == KeyEvent.VK_DOWN){b = false;}
      if (a == KeyEvent.VK_LEFT){b = false;}
      if (a == KeyEvent.VK_RIGHT){b = false;}
      if ((ch == '+')|(ch == '=')) {b = false;}
      if ((ch == '-')|(ch == '_')) {b = false;}
      if (e.isShiftDown() == true) {b = true;}
      if (e.isControlDown() == true) {b = true;}
      if (b == true) {
        //if ((ch == cellautokeys.calc_key)|(ch == cellautokeys.calc_key2)){
          //cellautothreadc t = cellautothreadc.current_thread;
          //t.numgenerations = cellautoapp.timestep2;
          //if (ch == cellautokeys.calc_key2){t.numgenerations = cellautoapp.timestep;}
          //cellautothreadc.done = true;
          //cellautoapp.stop();
          
          //return;
        //} else {
          cellautothreadc.done = true;
          cellautoapp.stop();
          return;
        //}
      }
    }

    if (e.isControlDown()){//System.out.println("control is down");
      if (s.equals(cellautokeys.rule_family_options_ctrl_key)) {
        if (cellautoapp.cellauto131.rulefamily != null) {
          cellautoapp.cellauto131.rulechange = 2;
          cellautoapp.cellauto131.rulefamily.showoptions();
        } else {
          JOptionPane.showMessageDialog(cellautoapp.cellautowindowframe,new JLabel("this rule family does not have a options window"),"error",JOptionPane.ERROR_MESSAGE);  
        }        
      }
      if (s.equals(cellautokeys.table_tool_option_ctrl_key)) {
        cellautoapp.table_tool_show_a_generation_ahead = !cellautoapp.table_tool_show_a_generation_ahead;
        cellautoapp.cellautomainwindow.repaint();
        cellautoapp.updatestatusbar();
      }
      if (s.equals(cellautokeys.random_table_ctrl_key)) {
        //cellautoapp.randomizeruletable();
        cellautoapp.show_randomize_rule_table_dialog();
        //cellautoapp.randomizeruletable();
        //cellautoapp.edittablewindow.repaint();        

      }
      if (s.equals(cellautokeys.random_selection_ctrl_key)) {
        cellautoapp.randomize_selection();
        cellautoapp.cellautomainwindow.repaint();
      }

      if (s.equals(cellautokeys.open_ctrl_key)) {
        cellautoapp.open2();
      }
      if (s.equals(cellautokeys.save_ctrl_key)){
        cellautoapp.save2();
      }
      if (s.equals(cellautokeys.add_state_ctrl_key)){
        cellautoapp.addeditstatedialog.addstate();
      }
      if (s.equals(cellautokeys.edit_state_ctrl_key)){
        cellautoapp.addeditstatedialog.setVisible(true);
        cellautoapp.addeditstatedialog.selectstate(cellautoapp.colorlistindex);      
      }
      
      if (s.equals(cellautokeys.cut_ctrl_key)){
        cellautoapp.cuttoclipboard();
        cellautoapp.cellautomainwindow.repaint();
      }
      if (s.equals(cellautokeys.copy_ctrl_key)){
        cellautoapp.copytoclipboard();
        cellautoapp.cellautomainwindow.repaint();
      }
      if (s.equals(cellautokeys.paste_ctrl_key)){
        cellautoapp.pastefromclipboard();
        cellautoapp.cellautomainwindow.repaint();
      }
      if (s.equals(cellautokeys.flipy_ctrl_key)){
        cellautoapp.flipy();
        cellautoapp.cellautomainwindow.repaint();
      }
      if (s.equals(cellautokeys.flipx_ctrl_key)){
        cellautoapp.flipx();
        cellautoapp.cellautomainwindow.repaint();
      }
      if (s.equals(cellautokeys.rotatec_ctrl_key)){
        cellautoapp.rotatec();
        cellautoapp.cellautomainwindow.repaint();
      }
      if (s.equals(cellautokeys.rotatecc_ctrl_key)){
        cellautoapp.rotatecc();
        cellautoapp.cellautomainwindow.repaint();
      }
      if (s.equals(cellautokeys.seletionoption_ctrl_key)){
        cellautoapp.dropselectionbeforerunning = !cellautoapp.dropselectionbeforerunning;
        cellautoapp.optionsdialog.dropselectioncheckbox.setSelected(cellautoapp.dropselectionbeforerunning);
        cellautoapp.updatestatusbar();
      }
      if (s.equals(cellautokeys.options_ctrl_key)){
        cellautoapp.optionsdialog.setVisible(true);
      }
      if (s.equals(cellautokeys.color_picker_tool_ctrl_key)){
        cellautoapp.toollistindex = cellautoapp.COLOR_PICKER_TOOL;
        cellautoapp.updatestatusbar();
      }    
    }else{
      if (ch == cellautokeys.find_selection_key){
        cellautoapp.find_selection();
      }

      if (ch == cellautokeys.pencil_tool_key){
        cellautoapp.toollistindex = cellautoapp.PENCIL_TOOL;
        cellautoapp.updatestatusbar();
      }
      if (ch == cellautokeys.select_tool_key){
        cellautoapp.toollistindex = cellautoapp.SELECT_TOOL;
        cellautoapp.updatestatusbar();
      }                                                              
      if (ch == cellautokeys.move_tool_key){
        cellautoapp.toollistindex = cellautoapp.MOVE_TOOL;
        cellautoapp.updatestatusbar();
      }
      if (ch == cellautokeys.zoom_in_tool_key){
        cellautoapp.toollistindex = cellautoapp.ZOOMIN_TOOL;
        cellautoapp.updatestatusbar();
      }
      if (ch == cellautokeys.zoom_out_tool_key){
        cellautoapp.toollistindex = cellautoapp.ZOOMOUT_TOOL;
        cellautoapp.updatestatusbar();
      }
      
      if ((ch == '+')|(ch == '=')){
        int x = cellautoapp.offsetx + (cellautoapp.cellautomainwindow.getWidth()/(cellautomainwindowc.sqsize*2));
        int y = cellautoapp.offsety + (cellautoapp.cellautomainwindow.getHeight()/(cellautomainwindowc.sqsize*2));

        cellautoapp.zoom(x,y,cellautoapp.ZOOM_IN);
        cellautoapp.cellautomainwindow.repaint();
      }

      if ((ch == '-')|(ch == '_')){
        int x = cellautoapp.offsetx + (cellautoapp.cellautomainwindow.getWidth()/(cellautomainwindowc.sqsize*2));
        int y = cellautoapp.offsety + (cellautoapp.cellautomainwindow.getHeight()/(cellautomainwindowc.sqsize*2));


        cellautoapp.zoom(x,y,cellautoapp.ZOOM_OUT);
        cellautoapp.cellautomainwindow.repaint();
      }
      
      if (ch == cellautokeys.next_tool_key){
        //select the next tool
        cellautoapp.toollistindex = (cellautoapp.toollistindex - 1 + cellautoapp.numtools) % cellautoapp.numtools;
        cellautoapp.updatestatusbar();
      }
      if (ch == cellautokeys.prev_tool_key){
        //select the prev tool
        cellautoapp.toollistindex = (cellautoapp.toollistindex + 1 + cellautoapp.numtools) % cellautoapp.numtools;
        cellautoapp.updatestatusbar();
        
      }
      
      if (ch == cellautokeys.prev_color_key){
        //select the prev color
        int selcolor = cellautoapp.colorbox.colorboxpanel.selcolor;
        int offset = cellautoapp.colorbox.colorboxpanel.offset;
        int numcolorsperrow = colorboxpanelc.numcolorsperrow;

        selcolor = (selcolor - 1 + cellautoapp.cellauto131.numcolors) % cellautoapp.cellauto131.numcolors;
        cellautoapp.colorlistindex = selcolor;
        if (cellautoapp.addeditstatedialog.isVisible() == true){
          cellautoapp.addeditstatedialog.selectstate(cellautoapp.colorlistindex);
        }
        int cd = selcolor - (offset*numcolorsperrow); 
        if (cd < 0){
            cellautoapp.colorbox.scrollbar.setValue(selcolor / numcolorsperrow);
        }
        if (colorboxc.colorboxautoscroll == true){
          if (cd >= (numcolorsperrow*2)){
            if (selcolor >= numcolorsperrow){
              cellautoapp.colorbox.scrollbar.setValue((selcolor / numcolorsperrow)-1);
            }else{
              cellautoapp.colorbox.scrollbar.setValue(0);
            }
          }
        }
        cellautoapp.colorbox.colorboxpanel.selcolor = selcolor;
        cellautoapp.colorbox.colorboxpanel.repaint();
        cellautoapp.updatestatusbar();
      }
      if (ch == cellautokeys.next_color_key){
        //select the next color
        int selcolor = cellautoapp.colorbox.colorboxpanel.selcolor;
        int offset = cellautoapp.colorbox.colorboxpanel.offset;
        int numcolorsperrow = colorboxpanelc.numcolorsperrow;
        
        selcolor = (selcolor + 1) % cellautoapp.cellauto131.numcolors;
        cellautoapp.colorlistindex = selcolor;
        if (cellautoapp.addeditstatedialog.isVisible() == true){
          cellautoapp.addeditstatedialog.selectstate(cellautoapp.colorlistindex);
        }
        cellautoapp.colorbox.colorboxpanel.repaint();
        int cd = selcolor - (offset*numcolorsperrow); 
        if (cd < 0){
            cellautoapp.colorbox.scrollbar.setValue(selcolor / numcolorsperrow);
        }
        if (colorboxc.colorboxautoscroll == true){
          if (cd >= (numcolorsperrow*2)){
            if (selcolor >= numcolorsperrow){
              cellautoapp.colorbox.scrollbar.setValue((selcolor / numcolorsperrow)-1);
            }else{
              cellautoapp.colorbox.scrollbar.setValue(0);
            }
          }
        }
        cellautoapp.colorbox.colorboxpanel.selcolor = selcolor;
        cellautoapp.updatestatusbar();
      }
      if (ch == cellautokeys.xor_mode_key) {
        cellautoapp.xor_mode = !cellautoapp.xor_mode;        
        cellautoapp.updatestatusbar();
      }
      if (ch == cellautokeys.pan_mode_key){
        cellautoapp.panmode = !cellautoapp.panmode;
        cellautoapp.updatestatusbar();
        Graphics g = cellautoapp.cellautomainwindow.getGraphics();
        int x = (cellautomainwindowc.selx)-cellautoapp.offsetx;
        int y = (cellautomainwindowc.sely)-cellautoapp.offsety;
        int sq = cellautoapp.board.getsq(cellautomainwindowc.selx,cellautomainwindowc.sely);
        cellautoapp.cellautomainwindow.paintsquare(g,x,y,sq);
        if (cellautoapp.panmode == false){
          cellautoapp.cellautomainwindow.paintsmallsquare(g,x,y,sq,Color.black,Color.white);
        }
      }
      if (ch == ' '){
        if (cellautoapp.panmode == false){
          if (cellautoapp.toollistindex == cellautoapp.ZOOMIN_TOOL){
            cellautoapp.zoom(cellautomainwindowc.selx,cellautomainwindowc.sely,cellautoapp.ZOOM_IN);
          }
          if (cellautoapp.toollistindex == cellautoapp.ZOOMOUT_TOOL){
            cellautoapp.zoom(cellautomainwindowc.selx,cellautomainwindowc.sely,cellautoapp.ZOOM_OUT);
          }
          if (cellautoapp.toollistindex == cellautoapp.FILL_TOOL){
            int x = cellautomainwindowc.selx;
            int y = cellautomainwindowc.sely;
            int c1 = cellautoapp.colorlistindex;
            int c2 = cellautoapp.board.getsq(x,y);
            cellautoapp.bucketfill(x,y,c1,c2,10000);
            cellautoapp.cellautomainwindow.repaint();
          }
          
          if (cellautoapp.toollistindex == cellautoapp.TABLE_TOOL){
            int i = cellautoapp.colorlistindex;
            int x = cellautomainwindowc.selx;
            int y = cellautomainwindowc.sely;
            int a1 = cellautoapp.board.getsq(x,y);
            int a2 = cellautoapp.cellauto131.getneighborvalue(cellautoapp.board,x,y);
            cellautoapp.cellauto131.setlookuptable(a2,a1,i);
            cellautoapp.cellautomainwindow.repaint();
          }
          if (cellautoapp.toollistindex == cellautoapp.PENCIL_TOOL){
            int i = cellautoapp.colorlistindex;
            int x = cellautomainwindowc.selx;
            int y = cellautomainwindowc.sely;
            cellautoapp.board.setsq(x,y,i);
            cellautoapp.board2.setsq(x,y,i);
            Graphics g = cellautoapp.cellautomainwindow.getGraphics();
            cellautoapp.cellautomainwindow.paintsquare(g,x-cellautoapp.offsetx,y-cellautoapp.offsety,i);
            cellautoapp.cellautomainwindow.paintsmallsquare(g,x-cellautoapp.offsetx,y-cellautoapp.offsety,i,Color.black,Color.white);
            
          }
          if ((cellautoapp.toollistindex == cellautoapp.FILLEDRECTANGLE_TOOL)|
            (cellautoapp.toollistindex == cellautoapp.RECTANGLE_TOOL)|
          (cellautoapp.toollistindex == cellautoapp.FILLEDCIRCLE_TOOL)|
          (cellautoapp.toollistindex == cellautoapp.CIRCLE_TOOL)|
          (cellautoapp.toollistindex == cellautoapp.LINE_TOOL)){
          if (cellautomainwindowc.selnum == 1){
            cellautomainwindowc.selx2 = cellautomainwindowc.selx;
            cellautomainwindowc.sely2 = cellautomainwindowc.sely;
          }else{
            int x1 = cellautomainwindowc.selx;
            int y1 = cellautomainwindowc.sely;
            int x2 = cellautomainwindowc.selx2;
            int y2 = cellautomainwindowc.sely2;
            if (cellautoapp.toollistindex == cellautoapp.FILLEDRECTANGLE_TOOL){
              cellautoapp.fillrectangle(x1,y1,x2,y2);
            }
            if (cellautoapp.toollistindex == cellautoapp.RECTANGLE_TOOL){
              cellautoapp.drawrectangle(x1,y1,x2,y2);
            }
            if (cellautoapp.toollistindex == cellautoapp.FILLEDCIRCLE_TOOL){
              cellautoapp.fillcircle(x1,y1,x2,y2);
            }
            if (cellautoapp.toollistindex == cellautoapp.CIRCLE_TOOL){
              cellautoapp.drawcircle(x1,y1,x2,y2);
            }
            if (cellautoapp.toollistindex == cellautoapp.LINE_TOOL){
              cellautoapp.drawline(x1,y1,x2,y2);
            }
            Graphics g = cellautoapp.cellautomainwindow.getGraphics();
            int sq = cellautoapp.board.getsq(cellautomainwindowc.selx,cellautomainwindowc.sely);
            cellautoapp.cellautomainwindow.paintsmallsquare(g,x2-cellautoapp.offsetx,y2-cellautoapp.offsety,sq,Color.black,Color.white);
          
          }
          cellautomainwindowc.selnum = (cellautomainwindowc.selnum % 2) + 1;
          }
          if (cellautoapp.toollistindex == cellautoapp.MOVE_TOOL){
            cellautoapp.calc(1,true);
          }
          if (cellautoapp.toollistindex == cellautoapp.SELECT_TOOL){
            if (cellautomainwindowc.selnum == 1){
              cellautomainwindowc.selx2 = cellautomainwindowc.selx;
              cellautomainwindowc.sely2 = cellautomainwindowc.sely;
            }else{
              cellautoapp.selx1 = cellautomainwindowc.selx;
              cellautoapp.sely1 = cellautomainwindowc.sely;
              cellautoapp.selx2 = cellautomainwindowc.selx2;
              cellautoapp.sely2 = cellautomainwindowc.sely2;
              cellautoapp.pasteseldata();
              cellautoapp.setupsel();
              cellautoapp.cutseldata();
              cellautoapp.cellautomainwindow.repaint();
            }
            cellautomainwindowc.selnum = (cellautomainwindowc.selnum % 2) + 1;
          }
        }
      }
      if (ch == cellautokeys.redo_key){
        cellautoapp.redo();
      }
      if (ch == cellautokeys.undo_key){
        cellautoapp.undo();
      }
      if (ch == cellautokeys.save_and_clear_key){
        cellautoapp.saveboard(cellautoapp.SAVE_TO_UNDO_STACK);
        if (cellautoapp.save_and_clear_key_adds_random_cells == true){
          cellautoapp.newgamedialog.newgame();
        }else{
          cellautoapp.board = new boardc(cellautoapp.board.width,cellautoapp.board.height);
          cellautoapp.board2 = new boardc(cellautoapp.board);
        }
        cellautoapp.updatestatusbar();
        cellautoapp.cellautomainwindow.repaint();
      }
      if (ch == cellautokeys.save_to_stack_key){
        boardstate.s = 1;
        cellautoapp.updatestatusbar();
      }
      if (ch == ' '){
        if (cellautoapp.panmode == true){
          cellautoapp.calc(1,true);
        }
      }
      if ((ch == cellautokeys.calc_key)|(ch == cellautokeys.calc_key2)){
        int n = cellautoapp.timestep2;
        if (ch == cellautokeys.calc_key2){n = cellautoapp.timestep;}
        cellautoapp.calc(n,false);
      }
      if (a == KeyEvent.VK_ENTER) {
        if (cellautothreadc.running == true){
          cellautoapp.stop();
        } else {
          cellautoapp.run();
        }
      }
      if (e.isShiftDown() & (cellautoapp.selw > 0) & (cellautoapp.selh > 0)){
        if (a == KeyEvent.VK_UP){//move up
          cellautoapp.sely1 = cellautoapp.sely1 - 1;
          cellautoapp.sely2 = cellautoapp.sely2 - 1;
        }
        if (a == KeyEvent.VK_DOWN){//move down
          cellautoapp.sely1 = cellautoapp.sely1 + 1;
          cellautoapp.sely2 = cellautoapp.sely2 + 1;
        }
        if (a == KeyEvent.VK_LEFT){//move left
          cellautoapp.selx1 = cellautoapp.selx1 - 1;
          cellautoapp.selx2 = cellautoapp.selx2 - 1;
        }
        if (a == KeyEvent.VK_RIGHT){//move right
          cellautoapp.selx1 = cellautoapp.selx1 + 1;
          cellautoapp.selx2 = cellautoapp.selx2 + 1;
        }
        cellautoapp.setupsel();

        cellautoapp.cellautomainwindow.repaint();
        
      } else {
        if (a == KeyEvent.VK_UP){//move up
          if (cellautoapp.panmode == true){
            cellautoapp.offsety = cellautoapp.offsety - cellautoapp.movestep;
          } else {
            cellautomainwindowc.sely = cellautomainwindowc.sely - 1;
          }
          cellautoapp.cellautomainwindow.updateselsq(0,-1);
          
        }
        if (a == KeyEvent.VK_DOWN){//move down
          if (cellautoapp.panmode == true){
            cellautoapp.offsety = cellautoapp.offsety + cellautoapp.movestep;
          } else{
            cellautomainwindowc.sely = cellautomainwindowc.sely + 1;
          }
          cellautoapp.cellautomainwindow.updateselsq(0,1);
          
        }
        if (a == KeyEvent.VK_LEFT){//move left
          if (cellautoapp.panmode == true){
            cellautoapp.offsetx = cellautoapp.offsetx - cellautoapp.movestep;
          } else{
            cellautomainwindowc.selx = cellautomainwindowc.selx - 1;
          }
          cellautoapp.cellautomainwindow.updateselsq(-1,0);
          
        }
        if (a == KeyEvent.VK_RIGHT){//move right
          if (cellautoapp.panmode == true){
            cellautoapp.offsetx = cellautoapp.offsetx + cellautoapp.movestep;
          } else {  
            cellautomainwindowc.selx = cellautomainwindowc.selx + 1;
          }
          cellautoapp.cellautomainwindow.updateselsq(1,0);
        }
      }
    }
    if (cellautoapp.verbose == true) {
      System.out.println(" key " + s + "  key code " + a + "  key char " + ch);
    }
  }
  public void keyReleased(KeyEvent e){
    if (cellautoapp.verbose == true) {
      System.out.println("key release");
    }
  }
  public void keyTyped(KeyEvent e){
    if (cellautoapp.verbose == true) {
      System.out.println("key type");
    }
  }
}


class winlisc implements WindowListener{
  public void windowActivated(WindowEvent e){
    if (cellautoapp.verbose == true) {
      System.out.println("Activated event");
    }
    cellautoapp.cellautowindowframe.requestFocusInWindow();
    //cellautoapp.cellautomainwindow.setFocusTraversalKeysEnabled(true);
    cellautoapp.cellautomainwindow.repaint();
    
  }
  public  void windowClosed(WindowEvent e){
    if (cellautoapp.verbose == true) {
      System.out.println("Close event");
    }
  }
  public void windowClosing(WindowEvent e){
    if (cellautoapp.verbose == true) {
      System.out.println("Closing event");
    }
    try{
      System.exit(0);
    }catch(SecurityException err){
      System.out.println("can not exit");
    }
  }
  public void windowDeactivated(WindowEvent e){
    if (cellautoapp.verbose == true) {
      System.out.println("Deactivated event");
    }
  }
  public void windowDeiconified(WindowEvent e){
    if (cellautoapp.verbose == true) {
      System.out.println("Deiconified event");
    }
  }
  public void windowIconified(WindowEvent e){
    if (cellautoapp.verbose == true) {
      System.out.println("Iconified event");
    }
  }
  public void windowOpened(WindowEvent e){
    if (cellautoapp.verbose == true) {
      System.out.println("Opened event");
    }
    cellautoapp.cellautomainwindow.repaint();
  }
  
}
class trydiffpositionswindowc extends JFrame{
  JLabel currentxlabel;
  JTextField currentxedit;
  JLabel currentylabel;
  JTextField currentyedit;
  JLabel currenttlabel;
  JTextField currenttedit;

  JLabel minxlabel;
  JTextField minxedit;
  JLabel minylabel;
  JTextField minyedit;
  JLabel mintlabel;
  JTextField mintedit;

  JLabel maxxlabel;
  JTextField maxxedit;
  JLabel maxylabel;
  JTextField maxyedit;
  JLabel maxtlabel;
  JTextField maxtedit;

 
  JLabel dummylabel1;
  JLabel dummylabel2;
  JLabel dummylabel3;
  JLabel dummylabel4;
  JLabel dummylabel5;
  JLabel dummylabel6;
  
  

  JLabel generationslabel;
  JTextField generationsedit;
  JButton trybutton;
  JButton tryandmovebutton;
  JButton tryandmovebutton2;   
  JButton movebutton;
  
  
  JButton takebackbutton;

  JButton closebutton;
  Stack posstack;
  Container mainpanel;
  JLabel statusbar;
  int state = 1;
  
  
  int undostackpos = -1;
  trydiffpositionswindowc(String Title){
    super(Title);
    state = 1;
    GridLayout gl = new GridLayout(6,5);
    mainpanel = this.getContentPane();
    mainpanel.setLayout(gl);
    statusbar = new JLabel();
    statusbar.setText("status bar");

    currentxlabel = new JLabel();
    currentxlabel.setText("current x");
    mainpanel.add(currentxlabel);

    currentylabel = new JLabel();
    currentylabel.setText("current y");
    mainpanel.add(currentylabel);

    currenttlabel = new JLabel();
    currenttlabel.setText("current t");
    mainpanel.add(currenttlabel);

    generationslabel = new JLabel();
    generationslabel.setText("generations");
    mainpanel.add(generationslabel);

    dummylabel1 = new JLabel();
    mainpanel.add(dummylabel1);
    
    currentxedit = new JTextField();
    currentxedit.setText("0");
    mainpanel.add(currentxedit);

    currentyedit = new JTextField();
    currentyedit.setText("0");
    mainpanel.add(currentyedit);

    currenttedit = new JTextField();
    currenttedit.setText("0");
    mainpanel.add(currenttedit);

    generationsedit = new JTextField();
    generationsedit.setText("20");
    mainpanel.add(generationsedit);

    dummylabel2 = new JLabel();
    mainpanel.add(dummylabel2);

    

    minxlabel = new JLabel();
    minxlabel.setText("min x");
    mainpanel.add(minxlabel);

    minylabel = new JLabel();
    minylabel.setText("min y");
    mainpanel.add(minylabel);

    mintlabel = new JLabel();
    mintlabel.setText("min t");
    mainpanel.add(mintlabel);




    tryandmovebutton2 = new JButton();
    tryandmovebutton2.setText("try and move b");
    tryandmovebutton2.setActionCommand("trydiffpostryandmovebuttonclick2");
    tryandmovebutton2.addActionListener(cellautoapp.actlis);
    mainpanel.add(tryandmovebutton2);
    

    
    trybutton = new JButton();
    trybutton.setText("try");
    trybutton.setActionCommand("trydiffpostrybuttonclick");
    trybutton.addActionListener(cellautoapp.actlis);
    mainpanel.add(trybutton);

    
    
    
    minxedit = new JTextField();
    minxedit.setText("0");
    mainpanel.add(minxedit);

    minyedit = new JTextField();
    minyedit.setText("0");
    mainpanel.add(minyedit);

    mintedit = new JTextField();
    mintedit.setText("0");
    mainpanel.add(mintedit);

    tryandmovebutton = new JButton();
    tryandmovebutton.setText("try and move f");
    tryandmovebutton.setActionCommand("trydiffpostryandmovebuttonclick");
    tryandmovebutton.addActionListener(cellautoapp.actlis);
    mainpanel.add(tryandmovebutton);
    


    takebackbutton = new JButton();
    takebackbutton.setText("take back");
    takebackbutton.setActionCommand("trydiffpostakebackbuttonclick");
    takebackbutton.addActionListener(cellautoapp.actlis);
    mainpanel.add(takebackbutton);

    


    
    maxxlabel = new JLabel();
    maxxlabel.setText("max x");
    mainpanel.add(maxxlabel);

    maxylabel = new JLabel();
    maxylabel.setText("max y");
    mainpanel.add(maxylabel);

    maxtlabel = new JLabel();
    maxtlabel.setText("max t");
    mainpanel.add(maxtlabel);

    closebutton = new JButton();
    closebutton.setText("close");
    closebutton.setActionCommand("trydiffposclosebuttonclick");
    closebutton.addActionListener(cellautoapp.actlis);
    mainpanel.add(closebutton);


    movebutton = new JButton();
    movebutton.setText("move");
    movebutton.setActionCommand("trydiffposmovebuttonclick");
    movebutton.addActionListener(cellautoapp.actlis);
    mainpanel.add(movebutton);



    maxxedit = new JTextField();
    maxxedit.setText("0");
    mainpanel.add(maxxedit);

    maxyedit = new JTextField();
    maxyedit.setText("0");
    mainpanel.add(maxyedit);

    maxtedit = new JTextField();
    maxtedit.setText("0");
    mainpanel.add(maxtedit);

    dummylabel5 = new JLabel();
    mainpanel.add(dummylabel5);

    dummylabel6 = new JLabel();
    mainpanel.add(dummylabel6);
    
    this.pack();

  }
  void updatestatusbar(){
  }
  void popbuttonclick(){
    state = 1;
    updatestatusbar();
  }
  void closebuttonclick(){
    
    if (cellautoapp.undodata.size() > 0){
      cellautoapp.restoreboard(cellautoapp.RESTORE_FROM_UNDO_STACK);
    }
    cellautoapp.updatestatusbar();
    cellautoapp.cellautomainwindow.repaint();
    updatestatusbar();
  }

  void pushbuttonclick(){
    state = 1;
  }
  
  void takebackbuttonclick(){
    if (cellautoapp.undodata.size() > 0){
      cellautoapp.restoreboard(cellautoapp.RESTORE_FROM_UNDO_STACK);
    }
    cellautoapp.updatestatusbar();
    cellautoapp.cellautomainwindow.repaint();
  }
  void movebuttonclick(){
    int x = Integer.parseInt(currentxedit.getText());
    int y = Integer.parseInt(currentyedit.getText());
    cellautoapp.saveboard(cellautoapp.SAVE_TO_UNDO_STACK);
    if (cellautoapp.cellauto131.rulechange > 0){
      cellautoapp.board.usenonemptyblocks();
      cellautoapp.cellauto131.rulechange--;
    }
    cellautoapp.selx1 = cellautoapp.selx1 + x;
    cellautoapp.sely1 = cellautoapp.sely1 + y;
    cellautoapp.selx2 = cellautoapp.selx2 + x;
    cellautoapp.sely2 = cellautoapp.sely2 + y;
    cellautoapp.setupsel();
    cellautoapp.updatestatusbar();
    cellautoapp.cellautomainwindow.repaint();
  
  }
  void trybuttonclick(){
    int numgenerations = Integer.parseInt(generationsedit.getText());
    int x = Integer.parseInt(currentxedit.getText());
    int y = Integer.parseInt(currentyedit.getText());
    int t = Integer.parseInt(currenttedit.getText());

    state = 0;
    cellautoapp.saveboard(cellautoapp.SAVE_TO_UNDO_STACK);
    cellautoapp.redodata.clear();
    if (cellautoapp.cellauto131.rulechange > 0){
      cellautoapp.board.usenonemptyblocks();
      cellautoapp.cellauto131.rulechange--;
    }
    cellautoapp.selx1 = cellautoapp.selx1 + x;
    cellautoapp.sely1 = cellautoapp.sely1 + y;
    cellautoapp.selx2 = cellautoapp.selx2 + x;
    cellautoapp.sely2 = cellautoapp.sely2 + y;
    cellautoapp.setupsel();

    for (int i = 0;i < numgenerations;i++){
      if (i == t){
        cellautoapp.pasteseldata();
        cellautoapp.selx1 = 0;
        cellautoapp.sely1 = 0;
        cellautoapp.selx2 = 0;
        cellautoapp.sely2 = 0;
        cellautoapp.setupsel();
      }
      boardc tmp = cellautoapp.board;
      cellautoapp.board = cellautoapp.cellauto131.calc3(cellautoapp.board,cellautoapp.board2);
      cellautoapp.board2 = tmp;
    }
    cellautoapp.generation = cellautoapp.generation + numgenerations;
    cellautoapp.updatestatusbar();
    cellautoapp.cellautomainwindow.repaint();

  }
  void tryandmovebuttonclick(int tt){
    int x = Integer.parseInt(currentxedit.getText());
    int y = Integer.parseInt(currentyedit.getText());
    int t = Integer.parseInt(currenttedit.getText());
    int minx = Integer.parseInt(minxedit.getText());
    int miny = Integer.parseInt(minyedit.getText());
    int mint = Integer.parseInt(mintedit.getText());
    int maxx = Integer.parseInt(maxxedit.getText());
    int maxy = Integer.parseInt(maxyedit.getText());
    int maxt = Integer.parseInt(maxtedit.getText());
    if (tt == 0){
    x = x + 1;
    if (x > maxx){
      x = minx;
      y = y + 1;
      if (y > maxy){
        y = miny;
        t = t + 1;
        if (t > maxt){
          t = mint;
        }
      }
    }
    }
    if (tt == 1){
    x = x - 1;
    if (x < minx){
      x = maxx;
      y = y - 1;
      if (y < miny){
        y = maxy;
        t = t - 1;
        if (t > mint){
          t = maxt;
        }
      }
    }
    }
    currentxedit.setText(Integer.toString(x));
    currentyedit.setText(Integer.toString(y));
    currenttedit.setText(Integer.toString(t));
    trybuttonclick();
  }
}

class statistics_windowc extends JFrame {
  JList listbox;
  JButton button1;
  JButton button2;
  JCheckBox selectionbox;
  JLabel infolabel;
  JScrollPane listboxscroller;
  DefaultListModel list;  
  statistics_windowc(String Title) {
    super(Title);
    list = new DefaultListModel();
    listbox = new JList(list);
    listboxscroller = new JScrollPane(listbox);
    selectionbox = new JCheckBox("get statistics from selection");
    infolabel = new JLabel("info");
    button1 = new JButton("refresh");
    button1.setActionCommand("statistics_window_refresh");
    button1.addActionListener(cellautoapp.actlis);

    button2 = new JButton("close");
    button2.setActionCommand("statistics_window_close");
    button2.addActionListener(cellautoapp.actlis);
    SpringLayout spl = new SpringLayout();
    this.getContentPane().setLayout(spl);
    spl.putConstraint(SpringLayout.EAST,listboxscroller,-2,SpringLayout.EAST,this.getContentPane());
    spl.putConstraint(SpringLayout.WEST,listboxscroller,2,SpringLayout.WEST,this.getContentPane());
    spl.putConstraint(SpringLayout.SOUTH,listboxscroller,-70,SpringLayout.SOUTH,this.getContentPane());
    spl.putConstraint(SpringLayout.NORTH,listboxscroller,2,SpringLayout.NORTH,this.getContentPane());
    spl.putConstraint(SpringLayout.NORTH,selectionbox,0,SpringLayout.SOUTH,listboxscroller);
    spl.putConstraint(SpringLayout.NORTH,infolabel,0,SpringLayout.SOUTH,selectionbox);
    spl.putConstraint(SpringLayout.NORTH,button1,0,SpringLayout.SOUTH,infolabel);
    spl.putConstraint(SpringLayout.NORTH,button2,0,SpringLayout.SOUTH,infolabel);
    //spl.putConstraint(SpringLayout.SOUTH,button1,0,SpringLayout.SOUTH,this.getContentPane());
    //spl.putConstraint(SpringLayout.SOUTH,button2,0,SpringLayout.SOUTH,this.getContentPane());
    spl.putConstraint(SpringLayout.WEST,button1,0,SpringLayout.WEST,this.getContentPane());
    spl.putConstraint(SpringLayout.WEST,button2,0,SpringLayout.EAST,button1);
    this.getContentPane().add(listboxscroller);
    this.getContentPane().add(selectionbox);
    this.getContentPane().add(infolabel);
    this.getContentPane().add(button1);
    this.getContentPane().add(button2);
    //list.add("test");
    this.pack();    
  }
  void refresh_button_click() {
    //System.out.println("refresh");
    
    int c[] = new int[256];
    int n = cellautoapp.cellauto131.getnumcolors();
    int n2 = 0;
    if ((selectionbox.isSelected()) & (cellautoapp.selw > 0) & (cellautoapp.selh > 0)) {
      cellautoapp.count_seldata_into_array(c);
      n2 = cellautoapp.selw * cellautoapp.selh;
    } else {
      cellautoapp.board.count_states_into_array(c);
      n2 = cellautoapp.board.get_width() * cellautoapp.board.get_height();
    }
    int n3 = n2 - c[0];
    infolabel.setText("total states: " + n2 + "  alive states: " + n3);
    list.clear();
    for (int a = 0;a < n;a++) {
      float f = ((float) c[a]) * 100;
      if (n2 == 0) {
      f = 100;
      } else {
      f = f / ((float) n2); 
      }
      int a2 = (int) f;
      list.addElement("state " + a + ": " + c[a] + "  " + a2 + "%");
    }
  }
  void close_button_click() {
    //System.out.println("close");
    this.setVisible(false);
  }
}

class infowindowc extends JFrame {
  JLabel label[];
  int numlabels;
  infowindowc(String Title) {
    super(Title);
    GridLayout gl = new GridLayout(7,2);
    this.getContentPane().setLayout(gl);
    numlabels = 14;
    label = new JLabel[numlabels];
    for (int i = 0;i < numlabels;i++){
      label[i] = new JLabel();
      this.getContentPane().add(label[i]);
    }
  }
  //if (cellautoapp.infowindow != null){cellautoapp.infowindow.updateinfo();}

  void updateinfo() {
    int n = (cellautoapp.undodata.size() + boardstate.s);
    int n2 = cellautoapp.redodata.size();
    label[0].setText("undo: " + n);
    label[1].setText("redo: " + n2);
    label[2].setText("generation: " + cellautoapp.generation);
    label[3].setText("pop count: " + cellautoapp.board.popcount);
    label[4].setText("color: " + cellautoapp.colorlistindex);
    label[5].setText("tool: " + cellautoapp.toolname[cellautoapp.toollistindex]);
    if (cellautoapp.panmode == true) {
      label[6].setText("pan mode is on ");
    } else {
      label[6].setText("pan mode is off ");
    }
    if (cellautoapp.dropselectionbeforerunning == true) {
      label[7].setText("drop selection ");
    } else {
      label[7].setText("keep selection ");
    }
    
    label[8].setText("board size: " + cellautoapp.board.width + "x" + cellautoapp.board.height);
    int bs = (cellautoapp.cellauto131.bordersize * 2) + 1;
    label[9].setText("neighborhood size: " + bs + "x" + bs);
    label[10].setText("rule table size: " + cellautoapp.cellauto131.tablewidth + "x" + cellautoapp.cellauto131.tableheight);
    if ((cellautoapp.selw > 0) & (cellautoapp.selh > 0)) {
      label[11].setText("selection: ("  + cellautoapp.selx + "," + cellautoapp.sely + "," + cellautoapp.selw + "," + cellautoapp.selh + ")");
    } else {
      label[11].setText("selection: NA");
    }
    if (cellautoapp.cellauto131.rulefamily == null) {
      label[12].setText("rule family: default");
    } else {
      String name = cellautoapp.cellauto131.rulefamily.getname();
      label[12].setText("rule family: " + name);
    }
    label[13].setText("table offset: " + cellautoapp.cellauto131.tableoffset);
  }
}
class cellautomainwindowc extends JPanel{
  static int sqsize = 20;
  winlisc winlis;
  static int selx = 0;
  static int sely = 0;
  static int selx2 = 0;
  static int sely2 = 0;
  static int selnum = 1;
  static boolean debugmode = false;
  static Color gridcolor = Color.blue;
  static Color gridcolor2 = Color.cyan;
  static Color gridcolor3 = Color.cyan;
  static Color gridcolor4 = Color.cyan;
  static Color gridcolor5 = Color.cyan;
  static Color nextrow_linecolor = Color.white;
  cellautomainwindowc(){
    winlis = new winlisc();
    this.setBounds(0,0,400,400);
  }  
  
  //paintsquare draws a square that is a cell
  void paintsquare(Graphics g,int x,int y,int a){
    int a2 = 0;
    if ((cellautoapp.gridon) & (sqsize >= cellautoapp.gridminsize)){a2 = 1;}
    
    g.setColor(cellautoapp.cellauto131.getcellvaluecolor(a));
    g.fillRect((x*sqsize)+a2,(y*sqsize)+a2,sqsize-a2,sqsize-a2);
  }
  
  //paintsmallsquare draws a small square on top of a cell 
  void paintsmallsquare(Graphics g,int x,int y,int a,Color c1,Color c2){
    Color c3 = cellautoapp.cellauto131.getcellvaluecolor(a);
    int c4 = c3.getRed() + c3.getGreen() + c3.getBlue();
    if (c4 >= 384){
      //the color of the cell is light
      //so draw a small black square
      g.setColor(c1);
    } else{
      //the color of the cell is dark
      //so draw a small white square
      g.setColor(c2);
    }
    g.fillRect((x*sqsize)+(sqsize/4),(y*sqsize)+(sqsize/4),sqsize/2,sqsize/2);                
    
  }
  
  //this function moves and redraws the square that is moved with the keyboard
  void updateselsq(int dx,int dy){
    int w2 = this.getWidth() / sqsize;
    int h2 = this.getHeight() / sqsize;
    int p = 0;
    Color b = new Color(0,0,0);
    Color w = new Color(255,255,255);
    //System.out.println("updateselsq  panmode " + cellautoapp.panmode + " dx " + dx + " dy " + dy);
    if (cellautoapp.panmode == false){
      if (cellautoapp.toollistindex == cellautoapp.MOVE_TOOL){
        if (cellautoapp.selw > 0){
          if (cellautoapp.selh > 0){
            cellautoapp.selx1 = cellautoapp.selx1 + dx;
            cellautoapp.sely1 = cellautoapp.sely1 + dy;
            cellautoapp.selx2 = cellautoapp.selx2 + dx;
            cellautoapp.sely2 = cellautoapp.sely2 + dy;
            cellautoapp.setupsel();
          }
        }
        cellautoapp.cellautomainwindow.repaint();
      }

      if (cellautomainwindowc.selx < cellautoapp.offsetx){
        cellautoapp.offsetx = cellautomainwindowc.selx;p = 1;
      }

      if (cellautomainwindowc.sely < cellautoapp.offsety){
        cellautoapp.offsety = cellautomainwindowc.sely;p = 1;
      }

      if (cellautomainwindowc.selx >= (cellautoapp.offsetx+w2)){
        cellautoapp.offsetx = (cellautomainwindowc.selx - w2) + 1;p = 1;
      }    

      if (cellautomainwindowc.sely >= (cellautoapp.offsety+h2)){
        cellautoapp.offsety = (cellautomainwindowc.sely - h2) + 1;p = 1;
      }

      Graphics g = cellautoapp.cellautomainwindow.getGraphics();
      int x = (selx-dx)-cellautoapp.offsetx;
      int y = (sely-dy)-cellautoapp.offsety;
      int sq = cellautoapp.board.getsq(selx-dx,sely-dy);
      if ((((selx-dx) >= cellautoapp.selx) & ((selx-dx) < (cellautoapp.selx+cellautoapp.selw))) &
        (((sely-dy) >= cellautoapp.sely) & ((sely-dy) < (cellautoapp.sely+cellautoapp.selh)))){
      int a = cellautoapp.seldata[(selx-dx)-cellautoapp.selx][(sely-dy)-cellautoapp.sely];
        }
        //System.out.println(" x " + x + " y " + y + " sq " + sq);
        paintsquare(g,x,y,sq);
        if (selnum == 2){
          if ((selx-dx) == selx2){
            if ((sely-dy) == sely2){
              paintsmallsquare(g,x,y,sq,b,w);
            }
          }
        }

        x = selx-cellautoapp.offsetx;
        y = sely-cellautoapp.offsety;
        sq = cellautoapp.board.getsq(selx,sely);
        //System.out.println(" x " + x + " y " + y + " sq " + sq);

        paintsmallsquare(g,x,y,sq,b,w);
        if (p == 1){
          cellautoapp.cellautomainwindow.repaint();
        }
    }else{
      cellautoapp.cellautomainwindow.repaint();
    }    
  }
  
  //this function adjusts the pattern
  void adjustpattern() {
    int bestx = 0;
    int besty = 0;
    int w = cellautoapp.board.width;
    int h = cellautoapp.board.height;
    int w2 = this.getWidth() / sqsize;
    int h2 = this.getHeight() / sqsize;
  
    int popcount = 0;
    int best_popcount = 0;
    if ((cellautoapp.symmetrybits & cellautoapp.HORIZONTAL_SYMMETRY) == cellautoapp.HORIZONTAL_SYMMETRY){w = w * 2;}
    if ((cellautoapp.symmetrybits & cellautoapp.INCLUDE_VERTICAL_LINE) == cellautoapp.INCLUDE_VERTICAL_LINE){w = w + 1;}
    if ((cellautoapp.symmetrybits & cellautoapp.VERTICAL_SYMMETRY) == cellautoapp.VERTICAL_SYMMETRY){h = h * 2;}
    if ((cellautoapp.symmetrybits & cellautoapp.INCLUDE_HORIZONTAL_LINE) == cellautoapp.INCLUDE_HORIZONTAL_LINE){h = h + 1;}
    int row_popcount[] = new int[(h >> 5)+8];

    for (int x = 0;x < (((w2+16) >> 5));x++) {
      for (int y = 0;y < ((h >> 5)+1);y++) {
        if (cellautoapp.board.getpopcountofblock(x << 5,y << 5) != 0) {
          row_popcount[y] = row_popcount[y] + 1;
        }
      }
    }

    for (int y = 0;y < (h2 >> 5);y++) {
      popcount = popcount + row_popcount[y];
    }
    for (int x = 0;x <= (w >> 5);x++) {
      for (int y = 0;y <= (h >> 5);y++) {
        if (popcount > best_popcount) {
          bestx = x << 5;
          besty = y << 5;
          best_popcount = popcount;
        }
        popcount = popcount - row_popcount[y];
        if (cellautoapp.board.getpopcountofblock(x << 5,y << 5) != 0) {
          row_popcount[y] = row_popcount[y] - 1;
        }
        if (cellautoapp.board.getpopcountofblock((x + ((w2 + 16) >> 5)) << 5,y << 5) != 0) {
          row_popcount[y] = row_popcount[y] + 1;
        }
        popcount = popcount + row_popcount[(y+(h2 >> 5)) % ((h >> 5)+1)];
      }
    }
    cellautoapp.offsetx = bestx;
    cellautoapp.offsety = besty;
  }

  //this function draws the board
  protected void paintComponent(Graphics g){ 
    Color b = new Color(0,0,0);
    Color w = new Color(255,255,255);
    int w2 = this.getWidth() / sqsize;
    int h2 = this.getHeight() / sqsize;
    int w3 = cellautoapp.board.width;
    int h3 = cellautoapp.board.height;    
    //int bg = cellautoapp.board.get_background_color3(0);
    int bg_height = cellautoapp.board.background_tile_sub_board.height;
    int bg_width = cellautoapp.board.background_tile_sub_board.width;
    int bg = cellautoapp.board.get_background_color(cellautoapp.offsetx % bg_width,cellautoapp.offsety % bg_height);
    //int bg = cellautoapp.board.get_background_color(0,0);
    Color bg_color2 = cellautoapp.cellauto131.getcellvaluecolor(bg);
    
    for (int y = 0;y < bg_height;y++) {
      int x3 = cellautoapp.offsetx % bg_width;
      int y3 = cellautoapp.offsety % bg_height;
      bg = cellautoapp.board.get_background_color(0,y+y3);
      Color bg_color3 = cellautoapp.cellauto131.getcellvaluecolor(bg);
      for (int x = 0;x < bg_width;x++) {
        bg = cellautoapp.board.get_background_color(x+x3,y+y3);
        Color bg_color = cellautoapp.cellauto131.getcellvaluecolor(bg);
        g.setColor(bg_color);
        if ((x == 0) & (y == 0)) {
          g.fillRect(0,0,this.getWidth(),this.getHeight());
        } else if (x == 0) {
          int y2 = y;
          while (y2 <= h2) {
            //if (bg_color.equals(bg_color2) == false) {
              g.fillRect(0,(y2*sqsize),this.getWidth(),sqsize);          
            //}
            y2 = y2 + bg_height;
          }
        } else if (y == 0) {
          int x2 = x;
          while (x2 <= w2) { 
            //if (bg_color.equals(bg_color3) == false) {
              g.fillRect((x2*sqsize),0,sqsize,this.getHeight());          
            //}
            x2 = x2 + bg_width;
          }
        } else {
          int x2 = x;
          int y2 = y;
          while (y2 <= h2) {
            x2 = x;
            while (x2 <= w2) { 
              //if (bg_color.equals(bg_color3) == false) {
                g.fillRect((x2*sqsize),(y2*sqsize),sqsize,sqsize);          
              //}
              x2 = x2 + bg_width;
            }
            y2 = y2 + bg_height;
          }
        
        }
      }
    }

    //cellautoapp.board.updateusedblocks();
    if (cellautoapp.toollistindex == cellautoapp.TABLE_TOOL){
      if (cellautoapp.cellauto131.lookuptableallused == false){
        //cellautoapp.edittablewindow.repaint();
        for (int x = 0;x < cellautoapp.cellauto131.tablewidth;x++){
          for (int y = 0;y < cellautoapp.cellauto131.tableheight;y++){
            if (cellautoapp.cellauto131.getlookuptableused(x,y) == -1){
              cellautoapp.cellauto131.setlookuptableused(x,y,0);
            }
          }
        }
      }
    }
    for (int x = 0;x <= w2;x++){
      for (int y = 0;y <= h2;y++){
        int x2 = x + cellautoapp.offsetx;
        int y2 = y + cellautoapp.offsety;
        boolean inselectionboolean = false;
        if (((x2 >= cellautoapp.selx) & (x2 < (cellautoapp.selx+cellautoapp.selw))) &
           ((y2 >= cellautoapp.sely) & (y2 < (cellautoapp.sely+cellautoapp.selh)))){
          inselectionboolean = true;
        }
        if (cellautoapp.toollistindex == cellautoapp.TABLE_TOOL){
          //if the table tool is selected and table_tool_show_a_generation_ahead option is true 
          //then draw each of cell's entry in the rule table based on their value and their neighbors
          int a0 = 0;
          int a1 = cellautoapp.board.getsq(x2,y2);
          int a2 = 0;
          a2 = cellautoapp.cellauto131.getneighborvalue(cellautoapp.board,x2,y2);
          a0 = cellautoapp.cellauto131.getlookuptable(a2,a1);
          if (cellautoapp.table_tool_show_a_generation_ahead == false){
            a0 = a1;
          }
          if (inselectionboolean){
              int a = cellautoapp.seldata[(x2-cellautoapp.selx)%cellautoapp.selw][(y2-cellautoapp.sely)%cellautoapp.selh];
              if (cellautoapp.transparentselection == true){
                if (a != cellautoapp.board.get_background_color(x2,y2)){
                  a0 = a;
                }
              }
          }
          if (a0 != cellautoapp.board.get_background_color(x2,y2)){
            paintsquare(g,x,y,a0);
          }
          if (cellautoapp.cellauto131.lookuptableallused == false){
            int a3 = cellautoapp.cellauto131.getlookuptableused(a2,a1);
            if (a3 <= 0){
              paintsmallsquare(g,x,y,a0,b,w);
              cellautoapp.cellauto131.setlookuptableused(a2,a1,-1);
            }
          }   
          
        }else{
            if (inselectionboolean){
              //draw cells in selection
              int a = cellautoapp.seldata[(x2-cellautoapp.selx)%cellautoapp.selw][(y2-cellautoapp.sely)%cellautoapp.selh];
              if (cellautoapp.transparentselection == true){
                if (a == cellautoapp.board.get_background_color(x2,y2)){
                  a = cellautoapp.board.getsq(x2,y2);
                }
              }
  
              if (a != cellautoapp.board.get_background_color(x,y)) {
                paintsquare(g,x,y,a);
              }
            }else{
              //draw cells in the board
              int a = cellautoapp.board.getsq(x2,y2);
              
              if (a != cellautoapp.board.get_background_color(x2,y2)){
                paintsquare(g,x,y,a);
              }else{
              }
              if (cellautomainwindowc.debugmode == true){
                //shows which blocks are being used on the screen
  
                int x3 = x2 >> 2;
                int y3 = y2 >> 2;
                int w4 = w3 >> 2;
                int h4 = h3 >> 2;
                while (x3 < 0){x3 = x3 + w4;}
                while (y3 < 0){y3 = y3 + h4;}
                while (x3 >= w4){x3 = x3 - w4;}
                while (y3 >= h4){y3 = y3 - h4;}
                blockc b2 = cellautoapp.board.block[x3 >> 3][y3 >> 3];
                if (b2 != null){
                  if (b2.readused(x3 & 7,y3 & 7) == 1){
                    paintsmallsquare(g,x,y,a,b,w);
                  }
                }
              }
           }
        }
      }
    }
    
    if (cellautoapp.board.wrapx == false) {
      int y = -cellautoapp.offsety;
      int b1 = 0;
      int b2 = w2+1;
      if ((y >= 0) & (y <= h2)) {
        g.setColor(gridcolor4);
        g.drawLine(b1*sqsize,y*sqsize,b2*sqsize,y*sqsize);
      }
      y = y + cellautoapp.board.width;
      if ((y >= 0) & (y <= h2)) {
        g.setColor(gridcolor4);
        g.drawLine(b1*sqsize,y*sqsize,b2*sqsize,y*sqsize);
      }
    }
    if (cellautoapp.board.wrapy == false) {
      int x = -cellautoapp.offsetx;
      int b1 = 0;
      int b2 = h2+1;
      if ((x >= 0) & (x <= w2)) {
        g.setColor(gridcolor4);
        g.drawLine(x*sqsize,b1*sqsize,x*sqsize,b2*sqsize);
      }
      x = x + cellautoapp.board.height;
      if ((x >= 0) & (x <= w2)) {
        g.setColor(gridcolor4);
        g.drawLine(x*sqsize,b1*sqsize,x*sqsize,b2*sqsize);
      }
    }
    //draw the grid
    if ((cellautoapp.gridon) & (sqsize >= cellautoapp.gridminsize)){
      for (int x = 0;x <= (w2 / 8);x++){
        for (int x2 = 0;x2 < 4;x2++){
          int x3 = (x*8)+x2;
          int x4 = x3 + cellautoapp.offsetx;
          if ((x4 % 4) == 0){g.setColor(gridcolor2);}
          else{g.setColor(gridcolor);}
          int b1 = -cellautoapp.offsety;
          int b2 = cellautoapp.board.height-cellautoapp.offsety;
          if ((cellautoapp.board.wrapx == true) & (cellautoapp.board.wrapy == true)) {
            b1 = 0;
            b2 = h2+2;
            if ((x3+4) <= w2){
              g.drawRect(x3*sqsize,(b1-1)*sqsize,4*sqsize,b2*sqsize);
            }else{
              g.drawLine(x3*sqsize,b1*sqsize,x3*sqsize,b2*sqsize);
            }
          } else {
            if (cellautoapp.board.wrapy == true) {
              b1 = 0;
              b2 = h2+2;
            } else {
              if (b1 < 0) {b1 = 0;}
              if (b2 > (h2+2)) {b2 = h2+2;}
            }
            if (((x3+cellautoapp.offsetx) >= 0) | (cellautoapp.board.wrapx == true)) {
              if (((x3+cellautoapp.offsetx) <= cellautoapp.board.width) | (cellautoapp.board.wrapx == true)) {
                 g.drawLine(x3*sqsize,b1*sqsize,x3*sqsize,b2*sqsize);
              }
            }
            if (((x3+cellautoapp.offsetx+4) >= 0) | (cellautoapp.board.wrapx == true)) {
              if (((x3+cellautoapp.offsetx+4) <= cellautoapp.board.width) | (cellautoapp.board.wrapx == true)) {
                 g.drawLine((x3+4)*sqsize,b1*sqsize,(x3+4)*sqsize,b2*sqsize);
              }
            }
          }
        }
      }
      for (int y = 0;y <= (h2 / 8);y++) {
        for (int y2 = 0;y2 < 4;y2++) {
          int y3 = (y*8)+y2;
          int y4 = y3 + cellautoapp.offsety;

          if ((y4 % 4) == 0) {g.setColor(gridcolor2);}
          else {g.setColor(gridcolor);}
            
          int b1 = -cellautoapp.offsetx;
          int b2 = cellautoapp.board.width-cellautoapp.offsetx;

          if ((cellautoapp.board.wrapx == true) & (cellautoapp.board.wrapy == true)) {
            b1 = 0;
            b2 = w2+2;
          
            if ((y3+4) <= h2) {
              g.drawRect((b1-1)*sqsize,y3*sqsize,b2*sqsize,4*sqsize);
            } else {
              g.drawLine(b1*sqsize,y3*sqsize,b2*sqsize,y3*sqsize);
            }
          } else {
            if (cellautoapp.board.wrapx == true) {
              b1 = 0;
              b2 = w2+2;
            } else {
              if (b1 < 0) {b1 = 0;}
              if (b2 > (w2+2)) {b2 = w2+2;}
            }
            if (((y3+cellautoapp.offsety) >= 0) | (cellautoapp.board.wrapy == true)) {
              if (((y3+cellautoapp.offsety) <= cellautoapp.board.height) | (cellautoapp.board.wrapy == true)) {
                 g.drawLine(b1*sqsize,y3*sqsize,b2*sqsize,y3*sqsize);
              }
            }
            if (((y3+cellautoapp.offsety+4) >= 0) | (cellautoapp.board.wrapy == true)) {
              if (((y3+cellautoapp.offsety+4) <= cellautoapp.board.height) | (cellautoapp.board.wrapy == true)) {
                 g.drawLine(b1*sqsize,(y3+4)*sqsize,b2*sqsize,(y3+4)*sqsize);
              }
            }
            
          }
        }
      }
      int x3 = 0;
      int y3 = 0;
      
      if (cellautoapp.grid_highlighting_use_powers_of_4 == true){
        if (cellautoapp.offsetx < 0){
          x3 = 0-(cellautoapp.offsetx%16);
        }else{
          x3 = 16-(cellautoapp.offsetx%16);
        }
        for (int x = x3;x < w2;x = x + 16){
          int x2 = cellautoapp.offsetx+x;
          if ((x2 % 64) == 0){g.setColor(gridcolor4);}
          else{g.setColor(gridcolor3);}
          g.drawLine(x*sqsize,0,x*sqsize,(h2+2)*sqsize);
        }
        if (cellautoapp.offsety < 0){
          y3 = 0-(cellautoapp.offsety%16);
        }else{
          y3 = 16-(cellautoapp.offsety%16);
        }
        for (int y = y3;y < h2;y = y + 16){
          int y2 = cellautoapp.offsety+y;
          if ((y2 % 64) == 0){g.setColor(gridcolor4);}
          else{g.setColor(gridcolor3);}
          g.drawLine(0,y*sqsize,(w2+2)*sqsize,y*sqsize);
        }
      }else{      
        if (cellautoapp.offsetx < 0){
          x3 = 0-(cellautoapp.offsetx%20);
        }else{
          x3 = 20-(cellautoapp.offsetx%20);
        }
        for (int x = x3;x < w2;x = x + 20){
          int x2 = cellautoapp.offsetx+x;
          if ((x2 % 100) == 0){g.setColor(gridcolor4);}
          else{g.setColor(gridcolor3);}
          g.drawLine(x*sqsize,0,x*sqsize,(h2+2)*sqsize);
        }
        if (cellautoapp.offsety < 0){
          y3 = 0-(cellautoapp.offsety%20);
        }else{
          y3 = 20-(cellautoapp.offsety%20);
        }
        for (int y = y3;y < h2;y = y + 20){
          int y2 = cellautoapp.offsety+y;
          if ((y2 % 100) == 0){g.setColor(gridcolor4);}
          else{g.setColor(gridcolor3);}
          g.drawLine(0,y*sqsize,(w2+2)*sqsize,y*sqsize);
        }
        if (cellautoapp.offsetx < 0){
          x3 = 0-(cellautoapp.offsetx%w3);
        }else{
          x3 = w3-(cellautoapp.offsetx%w3);
        }
        for (int x = x3;x < w2;x = x + w3){
          g.setColor(gridcolor5);
          g.drawLine(x*sqsize,0,x*sqsize,(h2+2)*sqsize);
        }
        if (cellautoapp.offsety < 0){
          y3 = 0-(cellautoapp.offsety%h3);
        }else{
          y3 = h3-(cellautoapp.offsety%h3);
        }
        for (int y = y3;y < h2;y = y + h3){
          g.setColor(gridcolor5);
          g.drawLine(0,y*sqsize,(w2+2)*sqsize,y*sqsize);
        }
      }
    }
    
    if (cellautoapp.calc_one_row == true) {
      int i = 0;
      if (cellautoapp.board.wrapy == true) {
        i = cellautoapp.offsety - (cellautoapp.offsety % cellautoapp.board.height) - cellautoapp.board.height;
      }
      while (i <= ((cellautoapp.offsety + h2) + ((cellautoapp.offsety + h2) % cellautoapp.board.height) + cellautoapp.board.height)){
        int y3 = (cellautoapp.generation % cellautoapp.board.height) - cellautoapp.offsety + 1 + i;
        if ((y3 >= 0) & (y3 <= h2)) {
          g.setColor(nextrow_linecolor);
          if (sqsize >= 2) {
            g.drawLine(0,y3*sqsize,(w2+2)*sqsize,y3*sqsize);
          }
          if (sqsize >= 6) {
            g.drawLine(0,(y3*sqsize)+1,(w2+2)*sqsize,(y3*sqsize)+1);
          }
        }
        if (cellautoapp.board.wrapy == false) {break;}
        i = i + cellautoapp.board.height;
      }
    }
    
    
    //draw the square that move by the keyboard
    if (cellautoapp.panmode == false){
      int x = selx-cellautoapp.offsetx;
      int y = sely-cellautoapp.offsety;
      int a = cellautoapp.board.getsq(selx,sely);
      paintsmallsquare(g,x,y,a,b,w);
      if (selnum == 2){
        int x2 = selx2-cellautoapp.offsetx;
        int y2 = sely2-cellautoapp.offsety;
        int a2 = cellautoapp.board.getsq(selx2,sely2);
        paintsmallsquare(g,x2,y2,a2,b,w);
      }
    }
    cellautoapp.setupsel();
    
    //draw the outline of the selection;
    if (cellautoapp.selw > 0){
      if (cellautoapp.selh > 0){
        g.setColor(Color.red);
        g.drawRect(((cellautoapp.selx-cellautoapp.offsetx))*sqsize,((cellautoapp.sely-cellautoapp.offsety))*sqsize,(cellautoapp.selw)*sqsize,(cellautoapp.selh)*sqsize);
      }
    }

    if (cellautoapp.toollistindex == cellautoapp.TABLE_TOOL){
      if (cellautoapp.cellauto131.lookuptableallused == false){
        cellautoapp.edittablewindow.repaint();
      }
    }
    cellautoapp.updatestatusbar();
  }
};

class colorboxadjlisc implements AdjustmentListener{
  public void adjustmentValueChanged(AdjustmentEvent e) {
    int i = e.getValue();
    cellautoapp.colorbox.colorboxpanel.offset = i;
    
    cellautoapp.colorbox.colorboxpanel.repaint();
    
  }
}
class colorboxkeylisc implements KeyListener{
  public void keyPressed(KeyEvent e){
    int a = e.getKeyCode();
    char ch = e.getKeyChar();  
    if (ch == cellautokeys.prev_color_key){
      cellautoapp.colorbox.colorboxpanel.selcolor = (cellautoapp.colorbox.colorboxpanel.selcolor - 1 + cellautoapp.cellauto131.numcolors) % cellautoapp.cellauto131.numcolors;
      cellautoapp.colorlistindex = cellautoapp.colorbox.colorboxpanel.selcolor;
      cellautoapp.colorbox.colorboxpanel.repaint();
      cellautoapp.updatestatusbar();
    }
    if (ch == cellautokeys.next_color_key){
      cellautoapp.colorbox.colorboxpanel.selcolor = (cellautoapp.colorbox.colorboxpanel.selcolor + 1) % cellautoapp.cellauto131.numcolors;
      cellautoapp.colorlistindex = cellautoapp.colorbox.colorboxpanel.selcolor;
      cellautoapp.colorbox.colorboxpanel.repaint();
      cellautoapp.updatestatusbar();
    }
  }
  public void keyReleased(KeyEvent e){
    
  }
  public void keyTyped(KeyEvent e){
  }
}

class colorboxc extends JFrame{
  colorboxpanelc colorboxpanel;
  JScrollBar scrollbar;
  colorboxadjlisc adjlis;
  static boolean colorboxautoscroll = true;
  colorboxc(String Title){
    super(Title);
    colorboxpanel = new colorboxpanelc();
    scrollbar = new JScrollBar(JScrollBar.VERTICAL);
    scrollbar.setMinimum(0);
    scrollbar.setMaximum(64);
    scrollbar.setVisibleAmount(0);
    adjlis = new colorboxadjlisc();
    scrollbar.addAdjustmentListener(adjlis);
    SpringLayout spl = new SpringLayout();         
    this.getContentPane().setLayout(spl);
    spl.putConstraint(SpringLayout.WEST,scrollbar,0,SpringLayout.EAST,colorboxpanel);
    spl.putConstraint(SpringLayout.SOUTH,colorboxpanel,0,SpringLayout.SOUTH,this.getContentPane());
    spl.putConstraint(SpringLayout.SOUTH,scrollbar,0,SpringLayout.SOUTH,colorboxpanel);
    spl.putConstraint(SpringLayout.NORTH,scrollbar,0,SpringLayout.NORTH,this.getContentPane());
    spl.putConstraint(SpringLayout.NORTH,colorboxpanel,0,SpringLayout.NORTH,this.getContentPane());

    this.getContentPane().add(colorboxpanel);
    this.getContentPane().add(scrollbar);
    
    keylisc keylis = new keylisc();
    colorboxpanel.addKeyListener(keylis);
    scrollbar.addKeyListener(keylis);
    colorboxpanel.setFocusable(true);
  }
}
class colorboxpanelmouselisc implements MouseListener{
  public void mouseClicked(MouseEvent e){}
  public void mouseEntered(MouseEvent e){}
  public void mouseExited(MouseEvent e){}
  public void mousePressed(MouseEvent e){
    int x = e.getX() / colorboxpanelc.sqsize;
    int y = e.getY() / colorboxpanelc.sqsize;
    //y = y + cellautoapp.colorbox.colorboxpanel.offset;
    int i2 = (((cellautoapp.colorbox.colorboxpanel.offset+y)*colorboxpanelc.numcolorsperrow)+x);
    if (i2 < cellautoapp.cellauto131.numcolors){
      //select the color
      cellautoapp.colorbox.colorboxpanel.selcolor = i2;
    }
    cellautoapp.colorlistindex = cellautoapp.colorbox.colorboxpanel.selcolor;
    if (cellautoapp.addeditstatedialog.isVisible() == true){
      cellautoapp.addeditstatedialog.selectstate(cellautoapp.colorlistindex);
    }
    cellautoapp.colorbox.colorboxpanel.repaint();
    cellautoapp.updatestatusbar();
  }
  public void mouseReleased(MouseEvent e){
    
  }
  
}
class colorboxpanelc extends JPanel{
  colorboxpanelmouselisc mouselis;
  int offset;
  static int selcolor;
  static int sqsize = 32;
  static int numcolorsperrow = 16;
  colorboxpanelc(){
    mouselis = new colorboxpanelmouselisc();
    addMouseListener(mouselis);
    selcolor = 0;
    offset = 0;
  }
  public Dimension getPreferredSize(){
    return new Dimension(colorboxpanelc.sqsize*numcolorsperrow,colorboxpanelc.sqsize*2);
  }
  
  //this function paints the color box
  protected void paintComponent(Graphics g){ 
     super.paintComponent(g);
     Rectangle r = this.getBounds();
     int w = r.width;
     int h = r.height;
     //int numcolorrows = h / colorboxpanelc.sqsize;
     int numcolorrows = 2;
     
    //draw the colors using rectangles
    for (int y = 0;y < numcolorrows;y++){
      for (int x = 0;x < numcolorsperrow;x++){
        if ((((offset+y)*numcolorsperrow)+x) < cellautoapp.cellauto131.numcolors) {
          g.setColor(cellautoapp.cellauto131.getcellvaluecolor(((offset+y)*numcolorsperrow)+x));
        }else{
          g.setColor(Color.gray);
        }
        g.fillRect(x*colorboxpanelc.sqsize,y*colorboxpanelc.sqsize,colorboxpanelc.sqsize,colorboxpanelc.sqsize);
        
      }
    }
    
    //draw a outline around the selected color
    int selcolorx = selcolor % numcolorsperrow;
    int selcolory = selcolor / numcolorsperrow;
    if ((selcolory-offset) >= 0){
      if ((selcolory-offset) < numcolorrows){
        g.setColor(new Color(255,0,0));
        for (int i = 0;i < 2;i++){
          g.drawRect((selcolorx*colorboxpanelc.sqsize)+i,((selcolory-offset)*colorboxpanelc.sqsize)+i,colorboxpanelc.sqsize-(i*2),colorboxpanelc.sqsize-(i*2));
        }
      }
    }
    
    //draw the grid 
    g.setColor(Color.blue);
    for (int x = 1;x < numcolorsperrow;x++){
      g.drawLine(x*sqsize,0,x*sqsize,numcolorrows*sqsize);
    }
    for (int y = 1;y < numcolorrows;y++){
      g.drawLine(0,y*sqsize,numcolorsperrow*sqsize,y*sqsize);
    }
  }  
}
class toolboxactlisc implements ActionListener{
  public void actionPerformed(ActionEvent e) {
    String action = e.getActionCommand();
    System.out.println("action" + action);
    if (action.equals("rectangle")){
      cellautoapp.toollistindex = cellautoapp.RECTANGLE_TOOL;
    }
    if (action.equals("fillrectangle")){
      cellautoapp.toollistindex = cellautoapp.FILLEDRECTANGLE_TOOL;
    }
    if (action.equals("select")){
      cellautoapp.toollistindex = cellautoapp.SELECT_TOOL;
    }
    if (action.equals("move")){
      cellautoapp.toollistindex = cellautoapp.MOVE_TOOL;
    }
    if (action.equals("table")){
      cellautoapp.toollistindex = cellautoapp.TABLE_TOOL;
    }
    if (action.equals("circle")){
      cellautoapp.toollistindex = cellautoapp.CIRCLE_TOOL;
    }
    if (action.equals("fillcircle")){
      cellautoapp.toollistindex = cellautoapp.FILLEDCIRCLE_TOOL;
    }
    if (action.equals("zoomin")){
      cellautoapp.toollistindex = cellautoapp.ZOOMIN_TOOL;
    }
    if (action.equals("zoomout")){
      cellautoapp.toollistindex = cellautoapp.ZOOMOUT_TOOL;
    }
    if (action.equals("line")){
      cellautoapp.toollistindex = cellautoapp.LINE_TOOL;
    }
    if (action.equals("pencil")){
      cellautoapp.toollistindex = cellautoapp.PENCIL_TOOL;
    }
    if (action.equals("fill")){
      cellautoapp.toollistindex = cellautoapp.FILL_TOOL;
    }
    
    cellautoapp.updatestatusbar();
    cellautoapp.cellautomainwindow.repaint();
  }
}
class toolboxc extends JFrame{
  JToggleButton pencilbutton;
  JToggleButton linebutton;
  JToggleButton rectanglebutton;
  JToggleButton fillrectanglebutton;
  JToggleButton circlebutton;
  JToggleButton fillcirclebutton;
  JToggleButton zoominbutton;
  JToggleButton zoomoutbutton;
  JToggleButton selectbutton;
  JToggleButton movebutton;
  JToggleButton tablebutton;
  JToggleButton fillbutton;
  
  toolboxactlisc actlis;
  ButtonGroup b;  
  toolboxc(String Title){
    super(Title);
    actlis = new toolboxactlisc();
    b = new ButtonGroup();
    GridLayout gl = new GridLayout(2,6);
    this.getContentPane().setLayout(gl);
    ImageIcon icon = null;
    
    icon = cellautoapp.createImageIcon("toolbar/zoomin.png","zooms in");
    zoominbutton = new JToggleButton(icon);
    zoominbutton.addActionListener(actlis);
    zoominbutton.setActionCommand("zoomin");
    //this.getContentPane().add(zoominbutton);
    b.add(zoominbutton);
    
    icon = cellautoapp.createImageIcon("toolbar/zoomout.png","zooms out");
    zoomoutbutton = new JToggleButton(icon);
    zoomoutbutton.addActionListener(actlis);
    zoomoutbutton.setActionCommand("zoomout");
    //this.getContentPane().add(zoomoutbutton);
    b.add(zoomoutbutton);
    
    
    icon = cellautoapp.createImageIcon("toolbar/line.png","draws a line");
    linebutton = new JToggleButton(icon);
    linebutton.addActionListener(actlis);
    linebutton.setActionCommand("line");
    //this.getContentPane().add(linebutton);
    b.add(linebutton);
    
    icon = cellautoapp.createImageIcon("toolbar/pencil.png","use pencil");
    pencilbutton = new JToggleButton(icon);
    pencilbutton.addActionListener(actlis);
    pencilbutton.setActionCommand("pencil");
    //this.getContentPane().add(pencilbutton);
    b.add(pencilbutton);
    
    
    icon = cellautoapp.createImageIcon("toolbar/circle.png","draw a circle");
    circlebutton = new JToggleButton(icon);
    circlebutton.addActionListener(actlis);
    circlebutton.setActionCommand("circle");
    //this.getContentPane().add(circlebutton);
    b.add(circlebutton);
    
    icon = cellautoapp.createImageIcon("toolbar/filledcircle.png","draw a filled circle");
    fillcirclebutton = new JToggleButton(icon);
    fillcirclebutton.addActionListener(actlis);
    fillcirclebutton.setActionCommand("fillcircle");
    //this.getContentPane().add(fillcirclebutton);
    b.add(fillcirclebutton);
    
    icon = cellautoapp.createImageIcon("toolbar/rectangle.png","draw a rectangle");
    rectanglebutton = new JToggleButton(icon);
    rectanglebutton.addActionListener(actlis);
    rectanglebutton.setActionCommand("rectangle");
    //this.getContentPane().add(rectanglebutton);
    b.add(rectanglebutton);
    
    icon = cellautoapp.createImageIcon("toolbar/filledrectangle.png","draw a filled rectangle");
    fillrectanglebutton = new JToggleButton(icon);
    fillrectanglebutton.addActionListener(actlis);
    fillrectanglebutton.setActionCommand("fillrectangle");
    b.add(fillrectanglebutton);
    
    icon = cellautoapp.createImageIcon("toolbar/select.png","select cells");
    selectbutton = new JToggleButton(icon);
    selectbutton.addActionListener(actlis);
    selectbutton.setActionCommand("select");
    b.add(selectbutton);
    
    icon = cellautoapp.createImageIcon("toolbar/move.png","move cells");
    movebutton = new JToggleButton(icon);
    movebutton.addActionListener(actlis);
    movebutton.setActionCommand("move");
    b.add(movebutton);
    
    icon = cellautoapp.createImageIcon("toolbar/table.png","edit table");
    tablebutton = new JToggleButton(icon);
    tablebutton.addActionListener(actlis);
    tablebutton.setActionCommand("table");
    //this.getContentPane().add(tablebutton);
    b.add(tablebutton);
    
    icon = cellautoapp.createImageIcon("toolbar/bucketfill.png","bucket fill");
    fillbutton = new JToggleButton(icon);
    fillbutton.addActionListener(actlis);
    fillbutton.setActionCommand("fill");
    //this.getContentPane().add(fillbutton);
    b.add(fillbutton);
    
    
    this.getContentPane().add(zoominbutton);
    this.getContentPane().add(linebutton);
    this.getContentPane().add(circlebutton);
    this.getContentPane().add(rectanglebutton);
    this.getContentPane().add(selectbutton);
    this.getContentPane().add(tablebutton);
    this.getContentPane().add(zoomoutbutton);
    this.getContentPane().add(pencilbutton);
    this.getContentPane().add(fillcirclebutton);
    this.getContentPane().add(fillrectanglebutton);
    this.getContentPane().add(movebutton);
    this.getContentPane().add(fillbutton);
    
    
    
    this.pack();
  }
}
class edittablekeylisc implements KeyListener{
  public void keyPressed(KeyEvent e){
    System.out.println("key press");
    int a = e.getKeyCode();
    char ch = e.getKeyChar();  
    ch = Character.toLowerCase(ch);
    if ((ch == cellautokeys.calc_key)|(ch == cellautokeys.calc_key2)){
      int n = 1;
      if (ch == cellautokeys.calc_key2){n = cellautoapp.timestep;}
      cellautoapp.calc(n,false);
    }
    if (ch == cellautokeys.prev_color_key){
      cellautoapp.colorbox.colorboxpanel.selcolor = (cellautoapp.colorbox.colorboxpanel.selcolor - 1 + cellautoapp.cellauto131.numcolors) % cellautoapp.cellauto131.numcolors;
      cellautoapp.colorlistindex = cellautoapp.colorbox.colorboxpanel.selcolor;
      cellautoapp.colorbox.colorboxpanel.repaint();
      cellautoapp.updatestatusbar();
    }
    if (ch == cellautokeys.next_color_key){
      cellautoapp.colorbox.colorboxpanel.selcolor = (cellautoapp.colorbox.colorboxpanel.selcolor + 1) % cellautoapp.cellauto131.numcolors;
      cellautoapp.colorlistindex = cellautoapp.colorbox.colorboxpanel.selcolor;
      cellautoapp.colorbox.colorboxpanel.repaint();
      cellautoapp.updatestatusbar();
    }
    if (ch == cellautokeys.undo_key){
      cellautoapp.restoreboard();
      cellautoapp.updatestatusbar();
      cellautoapp.cellautomainwindow.repaint();
      cellautoapp.edittablewindow.edittablepanel.repaint();
    }
    if (ch == cellautokeys.save_to_stack_key){
      boardstate.s = 1;
      cellautoapp.updatestatusbar();
    }
  }
  public void keyReleased(KeyEvent e){
    System.out.println("key release");
    
  }
  public void keyTyped(KeyEvent e){
    System.out.println("key type");
  }
}
class edittablemouselisc implements MouseListener{
  public void mouseClicked(MouseEvent e){
    
  }
  public void mouseEntered(MouseEvent e){
    
  } 
  public void mouseExited(MouseEvent e){
    
  }
  public void mousePressed(MouseEvent e){
    int x = e.getX() / edittablepanelc.sqsize;
    int y = e.getY() / edittablepanelc.sqsize;
    int x2 = cellautoapp.edittablewindow.edittablepanel.offsetx;
    int y2 = cellautoapp.edittablewindow.edittablepanel.offsety;
    if ((x+x2) < cellautoapp.cellauto131.tablewidth){
      if ((y+y2) < cellautoapp.cellauto131.tableheight){
        if (cellautoapp.toollistindex == cellautoapp.COLOR_PICKER_TOOL){
          int i = cellautoapp.cellauto131.getlookuptable(x+x2,y+y2);
          cellautoapp.colorbox.colorboxpanel.selcolor = i;
          cellautoapp.colorlistindex = i;          
          if (cellautoapp.addeditstatedialog.isVisible() == true){
           cellautoapp.addeditstatedialog.selectstate(cellautoapp.colorlistindex);
          } 
          cellautoapp.updatestatusbar();
          cellautoapp.colorbox.colorboxpanel.repaint();
        } else {
          int i = cellautoapp.colorlistindex;
          if (cellautoapp.xor_mode == true) {
            int i2 = i ^ cellautoapp.cellauto131.getlookuptable(x+x2,y+y2);
            if (i2 < cellautoapp.cellauto131.numcolors) {
              cellautoapp.cellauto131.setlookuptable(x+x2,y+y2,i2);
            }
          } else {
            cellautoapp.cellauto131.setlookuptable(x+x2,y+y2,i);
          }
          if (cellautoapp.usetableshortcut53){
            String modstr = e.getMouseModifiersText(-1);
          //System.out.println("modstr " + modstr);
            if (modstr.equals("Shift")){
              while (y < cellautoapp.cellauto131.tableheight){
                y++;
                i++;
                if (i == cellautoapp.cellauto131.numcolors){
                  i = 0;
                }
                cellautoapp.cellauto131.setlookuptable(x+x2,y+y2,i);
              }
            }
          }
        }
        cellautoapp.edittablewindow.edittablepanel.repaint();
      }
    }
  }
  public void mouseReleased(MouseEvent e){
    
  } 
}

class edittableadjlisc implements AdjustmentListener{
  public void adjustmentValueChanged(AdjustmentEvent e) {
    Adjustable a = e.getAdjustable();
    int i = e.getValue();
    //System.out.println(" i  " + i);
    if (a == cellautoapp.edittablewindow.hscroll){
      cellautoapp.edittablewindow.edittablepanel.offsetx = i;
    }
    if (a == cellautoapp.edittablewindow.vscroll){
      cellautoapp.edittablewindow.edittablepanel.offsety = i;
    }
    cellautoapp.edittablewindow.edittablepanel.repaint();
  }
}

class edittablepanelc extends JPanel{
  int offsetx;
  int offsety;
  edittablemouselisc mouselis;
  //edittablekeylisc keylis;
  keylisc keylis;
  static int sqsize = 16;
  static int grid_x_spacing = 5;
  static int grid_y_spacing = 5;
  static int grid_x_spacing2 = 10;
  static int grid_y_spacing2 = 10;
  static Color gridcolor1 = Color.blue;
  static Color gridcolor2 = Color.cyan;
  static Color gridcolor3 = Color.white;
  edittablepanelc(){
    mouselis = new edittablemouselisc();
    this.addMouseListener(mouselis);
    
    
    keylis = new keylisc();
    this.addKeyListener(keylis);
    
    
    
    offsetx = 0;
    offsety = 0;
  }
  
  //paintsmallsquare draws a small square on top of a table entry
  void paintsmallsquare(Graphics g,int x,int y,int a,Color c1,Color c2,int a2){
    Color c3 = cellautoapp.cellauto131.getcellvaluecolor(a);
    int c4 = c3.getRed() + c3.getGreen() + c3.getBlue();
    if (c4 >= 384){
      g.setColor(c1);
    } else{
      g.setColor(c2);
    }
    
    if (a2 == -1){
      g.fillRect((x*sqsize)+(sqsize/4),(y*sqsize)+(sqsize/4),sqsize/2,sqsize/2);                
    }
    if (a2 == 0){
      g.fillRect((x*sqsize)+((3*sqsize)/8),(y*sqsize)+((3*sqsize)/8),sqsize/4,sqsize/4);                
    }
  }

  //this function draws the rule table
  protected void paintComponent(Graphics g){ 
    super.paintComponent(g);
    int h = (getHeight() / sqsize) + 1;
    int w = (getWidth() / sqsize) + 1;
    
    //draw the rule table
    for (int y = 0;y < h;y++){
      for (int x = 0;x < w;x++){
        if ((x+offsetx) < cellautoapp.cellauto131.tablewidth){
          if ((y+offsety) < cellautoapp.cellauto131.tableheight){
            int i = cellautoapp.cellauto131.getlookuptable(x+offsetx,y+offsety);
            g.setColor(cellautoapp.cellauto131.getcellvaluecolor(i));
            g.fillRect(x*sqsize,y*sqsize,sqsize,sqsize);
            if (cellautoapp.cellauto131.lookuptableallused == false){
              int a3 = cellautoapp.cellauto131.getlookuptableused(x+offsetx,y+offsety);
              //if (a3 == 0){
                paintsmallsquare(g,x,y,i,Color.black,Color.white,a3);
              //}
            }
          }
        }
      }
    }
    int w2 = w;
    int h2 = h;
    if (w2 >= (cellautoapp.cellauto131.tablewidth-offsetx)){
      w2 = cellautoapp.cellauto131.tablewidth-offsetx;
    }
    if (h2 >= (cellautoapp.cellauto131.tableheight-offsety)){
      h2 = cellautoapp.cellauto131.tableheight-offsety;
    }
    
    //draw the grid
    for (int x = 1;x <= w2;x++){
      g.setColor(gridcolor1);
      if (((x+offsetx) % grid_x_spacing) == 0){g.setColor(gridcolor2);}
      if (((x+offsetx) % grid_x_spacing2) == 0){g.setColor(gridcolor3);}
      g.drawLine(x*sqsize,0,x*sqsize,h2*sqsize);
    }
    for (int y = 1;y <= h2;y++){
      g.setColor(gridcolor1);
      if (((y+offsety) % grid_y_spacing) == 0){g.setColor(gridcolor2);}
      if (((y+offsety) % grid_y_spacing2) == 0){g.setColor(gridcolor3);}
      g.drawLine(0,y*sqsize,w2*sqsize,y*sqsize);
    }
    
  }  
  
  
};

class neighborhoodvaluespanelc extends JPanel {
  JTextField edit[][];
  neighborhoodvaluespanelc(int size) {
    GridLayout gl = new GridLayout(size,size);
    this.setLayout(gl);
    edit = new JTextField[size][size];
    for (int x = 0;x < size;x++) {
      for (int y = 0;y < size;y++) {
        edit[x][y] = new JTextField("0");
        this.add(edit[x][y]);
      }
    }
  }
}

class neighborhoodvaluesdialogc extends JFrame {
  neighborhoodvaluespanelc neighborhoodvaluespanel;
  JButton okbutton;
  JButton cancelbutton;
  int size;
  neighborhoodvaluesdialogc(String Title,int size) {
    super(Title);
    this.size = size;
    SpringLayout spl = new SpringLayout();  
    this.getContentPane().setLayout(spl);
    neighborhoodvaluespanel = new neighborhoodvaluespanelc(size);


    this.getContentPane().add(neighborhoodvaluespanel);
    
    okbutton = new JButton("apply");
    okbutton.setActionCommand("neighborhoodvalues_applybuttonclick");
    okbutton.addActionListener(cellautoapp.actlis);
    this.getContentPane().add(okbutton);
    cancelbutton = new JButton("close");
    cancelbutton.setActionCommand("neighborhoodvalues_closebuttonclick");
    cancelbutton.addActionListener(cellautoapp.actlis);
    this.getContentPane().add(cancelbutton);
    spl.putConstraint(SpringLayout.WEST,cancelbutton,0,SpringLayout.EAST,okbutton);
    spl.putConstraint(SpringLayout.WEST,okbutton,0,SpringLayout.WEST,this.getContentPane());
    spl.putConstraint(SpringLayout.SOUTH,okbutton,0,SpringLayout.SOUTH,this.getContentPane());
    spl.putConstraint(SpringLayout.SOUTH,cancelbutton,0,SpringLayout.SOUTH,this.getContentPane());
    spl.putConstraint(SpringLayout.EAST,neighborhoodvaluespanel,0,SpringLayout.EAST,this.getContentPane());
    spl.putConstraint(SpringLayout.WEST,neighborhoodvaluespanel,0,SpringLayout.WEST,this.getContentPane());

    spl.putConstraint(SpringLayout.SOUTH,neighborhoodvaluespanel,0,SpringLayout.NORTH,okbutton);
    spl.putConstraint(SpringLayout.NORTH,neighborhoodvaluespanel,0,SpringLayout.NORTH,this.getContentPane());

    this.pack();
  }


  //getbordervalues displays the neighbor weights
  void getbordervalues() {
    int size2 = (size - 1) / 2;
    for (int x = 0;x < size;x++) {
      for (int y = 0;y < size;y++) {
        neighborhoodvaluespanel.edit[x][y].setText(Integer.toString(cellautoapp.cellauto131.getbordervalue(x-size2,y-size2)));
      }
    }
  }

  //updatebordervalues updates the neighbor weights
  void updatebordervalues() {
    int size2 = (size - 1) / 2;
    for (int x = 0;x < size;x++) {
      for (int y = 0;y < size;y++) {
        int i = Integer.parseInt(neighborhoodvaluespanel.edit[x][y].getText().trim());
        cellautoapp.cellauto131.setbordervalue(x-size2,y-size2,i);
      }
    }
  }

}

class randomize_rule_table_dialogc extends JFrame{
  JLabel seedlabel;
  JTextField seededit;
  JButton new_seed_button;
  JLabel from_row_label;
  JTextField from_row_edit;
  JLabel to_row_label;
  JTextField to_row_edit;
  JLabel from_state_label;
  JTextField from_state_edit;
  JLabel to_state_label;
  JTextField to_state_edit;
  
  JButton randomize_button;
  JButton close_button;
  
  randomize_rule_table_dialogc(String Title) {
    super(Title);
    GridBagLayout gl = new GridBagLayout();
    this.getContentPane().setLayout(gl);
    GridBagConstraints c = new GridBagConstraints();

    c.fill = GridBagConstraints.BOTH;
    c.weightx = 1.0;
    c.weighty = 1.0;

    seedlabel = new JLabel("seed: ");
    c.gridwidth = 2;
    gl.setConstraints(seedlabel, c);
    this.getContentPane().add(seedlabel);

    seededit = new JTextField("8");
    c.gridwidth = GridBagConstraints.REMAINDER;
    gl.setConstraints(seededit, c);
    this.getContentPane().add(seededit);

    new_seed_button = new JButton("new seed");
    c.gridwidth = GridBagConstraints.REMAINDER;
    gl.setConstraints(new_seed_button, c);
    new_seed_button.setActionCommand("rule_table_new_seed_buttonclick");
    new_seed_button.addActionListener(cellautoapp.actlis);
    this.getContentPane().add(new_seed_button);

    from_row_label = new JLabel("from row: ");
    c.gridwidth = 2;
    gl.setConstraints(from_row_label, c);
    this.getContentPane().add(from_row_label);

    from_row_edit = new JTextField("0");
    c.gridwidth = GridBagConstraints.REMAINDER;
    gl.setConstraints(from_row_edit, c);
    this.getContentPane().add(from_row_edit);

    to_row_label = new JLabel("to row: ");
    c.gridwidth = 2;
    gl.setConstraints(to_row_label, c);
    this.getContentPane().add(to_row_label);

    to_row_edit = new JTextField(Integer.toString(cellautoapp.cellauto131.numcolors-1));
    c.gridwidth = GridBagConstraints.REMAINDER;
    gl.setConstraints(to_row_edit, c);
    this.getContentPane().add(to_row_edit);


    from_state_label = new JLabel("from state: ");
    c.gridwidth = 2;
    gl.setConstraints(from_state_label, c);
    this.getContentPane().add(from_state_label);

    from_state_edit = new JTextField("0");
    c.gridwidth = GridBagConstraints.REMAINDER;
    gl.setConstraints(from_state_edit, c);
    this.getContentPane().add(from_state_edit);

    to_state_label = new JLabel("to state: ");
    c.gridwidth = 2;
    gl.setConstraints(to_state_label, c);
    this.getContentPane().add(to_state_label);

    to_state_edit = new JTextField(Integer.toString(cellautoapp.cellauto131.numcolors-1));
    c.gridwidth = GridBagConstraints.REMAINDER;
    gl.setConstraints(to_state_edit, c);
    this.getContentPane().add(to_state_edit);

    
    randomize_button = new JButton("randomize");
    c.gridwidth = 2;
    gl.setConstraints(randomize_button, c);
    randomize_button.setActionCommand("rule_table_randomize_buttonclick");
    randomize_button.addActionListener(cellautoapp.actlis);
    this.getContentPane().add(randomize_button);

    close_button = new JButton("close");
    c.gridwidth = GridBagConstraints.REMAINDER;
    gl.setConstraints(close_button, c);
    close_button.setActionCommand("rule_table_close_buttonclick");
    close_button.addActionListener(cellautoapp.actlis);
    this.getContentPane().add(close_button);

    long seed = ((System.currentTimeMillis() % 10000));
    seededit.setText(Long.toString(seed));

    this.pack();
  }
  void update_dialog() {
    int i = cellautoapp.cellauto131.getnumcolors();
    cellautoapp.randomize_rule_table_dialog.to_row_edit.setText(Integer.toString(i));
    cellautoapp.randomize_rule_table_dialog.to_state_edit.setText(Integer.toString(i));
  }
  void randomize_buttonclick(){
    long seed = Long.valueOf(seededit.getText()).longValue();
    int from_row = Integer.parseInt(from_row_edit.getText());
    int to_row = Integer.parseInt(to_row_edit.getText());
    int from_state = Integer.parseInt(from_state_edit.getText());
    int to_state = Integer.parseInt(to_state_edit.getText());
    seededit.setText(Long.toString(seed+1));
    cellautoapp.rand.setSeed(seed);
    cellautoapp.randomizeruletable(from_row,to_row,from_state,to_state);
    System.out.println("randomize rule table");
    cellautoapp.edittablewindow.repaint();
  }
  void new_seed_buttonclick(){
    long seed = System.currentTimeMillis();
    seededit.setText(Long.toString(seed));
    System.out.println("randomize rule table");
  }

}
class addmanystatesdialogc extends JFrame{
  JLabel numstateslabel;
  JTextField numstatesedit;
  JLabel coloroffsetlabel;
  JTextField coloroffsetedit;
  JLabel colorsteplabel;
  JTextField colorstepedit;
  JButton addbutton;
  JButton closebutton;
  addmanystatesdialogc(String Title) {
    super(Title);
    GridBagLayout gl = new GridBagLayout();
    this.getContentPane().setLayout(gl);
    GridBagConstraints c = new GridBagConstraints();

    c.fill = GridBagConstraints.BOTH;
    c.weightx = 1.0;
    c.weighty = 1.0;

    numstateslabel = new JLabel("number of states to add: ");
    c.gridwidth = 2;
    gl.setConstraints(numstateslabel, c);
    this.getContentPane().add(numstateslabel);

    numstatesedit = new JTextField("8");
    c.gridwidth = GridBagConstraints.REMAINDER;
    gl.setConstraints(numstatesedit, c);
    this.getContentPane().add(numstatesedit);

    coloroffsetlabel = new JLabel("color offset: ");
    c.gridwidth = 2;
    gl.setConstraints(coloroffsetlabel, c);
    this.getContentPane().add(coloroffsetlabel);

    coloroffsetedit = new JTextField("512");
    c.gridwidth = GridBagConstraints.REMAINDER;
    gl.setConstraints(coloroffsetedit, c);
    this.getContentPane().add(coloroffsetedit);

    colorsteplabel = new JLabel("color step: ");
    c.gridwidth = 2;
    gl.setConstraints(colorsteplabel, c);
    this.getContentPane().add(colorsteplabel);

    colorstepedit = new JTextField("-6");
    c.gridwidth = GridBagConstraints.REMAINDER;
    gl.setConstraints(colorstepedit, c);
    this.getContentPane().add(colorstepedit);

    addbutton = new JButton("add");
    c.gridwidth = 2;
    gl.setConstraints(addbutton, c);
    addbutton.setActionCommand("manystatesaddbuttonclick");
    addbutton.addActionListener(cellautoapp.actlis);
    this.getContentPane().add(addbutton);

    closebutton = new JButton("close");
    c.gridwidth = GridBagConstraints.REMAINDER;
    gl.setConstraints(closebutton, c);
    closebutton.setActionCommand("manystatesclosebuttonclick");
    closebutton.addActionListener(cellautoapp.actlis);
    this.getContentPane().add(closebutton);
  }

  //this function adds a bunch of states
  void addstates() {
    //System.out.println("addstates");
    double color_step = Double.valueOf(colorstepedit.getText()).doubleValue();
    double color_offset = Double.valueOf(coloroffsetedit.getText()).doubleValue();
    int num_colors = Integer.valueOf(numstatesedit.getText()).intValue();;
    for (int i = 0;i < num_colors;i++) {
      int i2 = cellautoapp.cellauto131.addnewstate();
      if (i2 == -1) {
        JOptionPane.showMessageDialog(cellautoapp.cellautowindowframe,new JLabel("can not add more states, the limit is 256 states "),"error",JOptionPane.ERROR_MESSAGE);  
        break;
      }
      Color c = cellautoapp.getcolorfromhue(color_offset + (i2*color_step));
      cellautoapp.cellauto131.cellvalue[i2] = 0;
      cellautoapp.cellauto131.cellvaluecolor[i2] = c;
      for (int i3 = 0;i3 < cellautoapp.cellauto131.tablewidth;i3++) {
        int i4 = cellautoapp.cellauto131.getlookuptable(i3,cellautoapp.cellauto131.tableheight-2);
        if (i4 == 0){
          cellautoapp.cellauto131.setlookuptable(i3,cellautoapp.cellauto131.tableheight-2,cellautoapp.cellauto131.tableheight-1);
        }
      }
    }
    if (cellautoapp.randomize_rule_table_dialog != null) {
      cellautoapp.randomize_rule_table_dialog.update_dialog();
    }
    cellautoapp.updatestatusbar();
    cellautoapp.colorbox.colorboxpanel.repaint();
    cellautoapp.edittablewindow.edittablepanel.repaint();  
    cellautoapp.cellautomainwindow.repaint();
    cellautoapp.edittablewindow.vscroll.setMaximum(cellautoapp.cellauto131.tableheight);
  }
}


class addeditstatedialogc extends JFrame {
  JLabel statevaluelabel;
  JTextField statevalueedit;
  JLabel statecolorlabel;
  JButton statecolorbutton;
  JButton okbutton;
  JButton cancelbutton;
  
  //this function updates the state's color and value
  void update(){
    int i = cellautoapp.colorlistindex;
    cellautoapp.cellauto131.cellvalue[i] = Integer.parseInt(statevalueedit.getText().trim());
    cellautoapp.cellauto131.cellvaluecolor[i] = statecolorbutton.getBackground();
    cellautoapp.updatestatusbar();
    cellautoapp.colorbox.colorboxpanel.repaint();
    cellautoapp.edittablewindow.edittablepanel.repaint();  
    cellautoapp.cellautomainwindow.repaint();
  }
  
  //this function adds a new state
  void addstate() {
    int i = cellautoapp.cellauto131.addnewstate();
    if (i == -1) {
      JOptionPane.showMessageDialog(cellautoapp.cellautowindowframe,new JLabel("can not add more states, the limit is 256 states "),"error",JOptionPane.ERROR_MESSAGE);  
      return;
    }
    cellautoapp.colorlistindex = i;
    cellautoapp.colorbox.colorboxpanel.selcolor = cellautoapp.colorlistindex;
    cellautoapp.edittablewindow.vscroll.setMaximum(cellautoapp.cellauto131.tableheight);
    this.setVisible(true);
    this.selectstate(cellautoapp.colorlistindex);
    if (cellautoapp.randomize_rule_table_dialog != null) {
      cellautoapp.randomize_rule_table_dialog.update_dialog();
    }
    cellautoapp.updatestatusbar();
    cellautoapp.colorbox.colorboxpanel.repaint();
    cellautoapp.edittablewindow.edittablepanel.repaint();  
    cellautoapp.cellautomainwindow.repaint();
  }

  //this function selects a state
  void selectstate(int i){
    if (cellautoapp.verbose == true){
      System.out.println("select state " + i);
    }
    statevaluelabel.setText("state " + i + " value");
    statevalueedit.setText(Integer.toString(cellautoapp.cellauto131.cellvalue[i]));
    statecolorlabel.setText("state " + i + " color");
    statecolorbutton.setBackground(cellautoapp.cellauto131.cellvaluecolor[i]);
  }

  //this function selects the state's color
  void selectcolor(){
    Color c = JColorChooser.showDialog(this,"state color",statecolorbutton.getBackground());
    if (c != null){
      statecolorbutton.setBackground(c);
    }
  }
  addeditstatedialogc(String Title){
    super(Title);
    GridBagLayout gl = new GridBagLayout();
    this.getContentPane().setLayout(gl);
    GridBagConstraints c = new GridBagConstraints();

    c.fill = GridBagConstraints.BOTH;
    c.weightx = 1.0;
    c.weighty = 1.0;

    statevaluelabel = new JLabel();
    statevaluelabel.setText("state 0 value");
    c.gridwidth = 2;
    gl.setConstraints(statevaluelabel, c);
    this.getContentPane().add(statevaluelabel);
    
    statevalueedit = new JTextField();
    statevalueedit.setText("0");
    c.gridwidth = GridBagConstraints.REMAINDER;
    gl.setConstraints(statevalueedit, c);
    this.getContentPane().add(statevalueedit);


    statecolorlabel = new JLabel();
    statecolorlabel.setText("state 0 color");
    c.gridwidth = 2;
    gl.setConstraints(statecolorlabel, c);
    this.getContentPane().add(statecolorlabel);
    
    statecolorbutton = new JButton();
    statecolorbutton.setText("");
    statecolorbutton.setBackground(new Color(0,255,0));
    statecolorbutton.setActionCommand("statecolorbuttonclick");
    statecolorbutton.addActionListener(cellautoapp.actlis);

    c.gridwidth = GridBagConstraints.REMAINDER;
    gl.setConstraints(statecolorbutton, c);
    this.getContentPane().add(statecolorbutton);
    
    
    okbutton = new JButton();
    okbutton.setText("update");
    okbutton.setActionCommand("stateupdatebuttonclick");
    okbutton.addActionListener(cellautoapp.actlis);
    c.gridwidth = 2;
    gl.setConstraints(okbutton, c);
    this.getContentPane().add(okbutton);

    cancelbutton = new JButton();
    cancelbutton.setText("close");
    cancelbutton.setActionCommand("stateclosebuttonclick");
    cancelbutton.addActionListener(cellautoapp.actlis);
    c.gridwidth = GridBagConstraints.REMAINDER;
    gl.setConstraints(cancelbutton, c);
    this.getContentPane().add(cancelbutton);

    this.pack();
    
  }
}


class optionsdialogc extends JFrame {
  JCheckBox showgridcheckbox;
  JCheckBox transparentselectioncheckbox;
  JCheckBox selectionsavexycheckbox;
  JCheckBox dropselectioncheckbox;
  JCheckBox saveandclearcheckbox;
  JLabel timesteplabel;
  JTextField timestepedit;

  JLabel sparsenesslabel;
  JTextField sparsenessedit;
  JCheckBox sparsenesscheckbox;

  JLabel simulator_delay_label;
  JTextField simulator_delay_edit;
  JCheckBox repaint_every_generation_checkbox;
  
  JCheckBox wrapxcheckbox;
  JCheckBox wrapycheckbox;
  JCheckBox unused_entries_checkbox;
  
  JButton okbutton;
  JButton cancelbutton;
  optionsdialogc(String Title) {
    super(Title);
    GridBagLayout gl = new GridBagLayout();
    this.getContentPane().setLayout(gl);
    GridBagConstraints c = new GridBagConstraints();

    c.fill = GridBagConstraints.BOTH;
    c.weightx = 1.0;
    c.weighty = 1.0;

    showgridcheckbox = new JCheckBox();
    showgridcheckbox.setText("show grid");
    c.gridwidth = GridBagConstraints.REMAINDER;
    gl.setConstraints(showgridcheckbox, c);
    this.getContentPane().add(showgridcheckbox);
    


    transparentselectioncheckbox = new JCheckBox();
    transparentselectioncheckbox.setText("selection is transparent");
    c.gridwidth = GridBagConstraints.REMAINDER;
    gl.setConstraints(transparentselectioncheckbox, c);
    this.getContentPane().add(transparentselectioncheckbox);
    
    selectionsavexycheckbox = new JCheckBox();
    selectionsavexycheckbox.setText("save x and y offsets of selection");
    c.gridwidth = GridBagConstraints.REMAINDER;
    gl.setConstraints(selectionsavexycheckbox, c);
    this.getContentPane().add(selectionsavexycheckbox);

    dropselectioncheckbox = new JCheckBox();
    dropselectioncheckbox.setText("drop selection before running ctrl-" + cellautokeys.seletionoption_ctrl_key.toLowerCase());
    c.gridwidth = GridBagConstraints.REMAINDER;
    gl.setConstraints(dropselectioncheckbox, c);
    this.getContentPane().add(dropselectioncheckbox);

    
    saveandclearcheckbox = new JCheckBox();
    saveandclearcheckbox.setText("save_and_clear_key adds random cells");
    c.gridwidth = GridBagConstraints.REMAINDER;
    gl.setConstraints(saveandclearcheckbox, c);
    this.getContentPane().add(saveandclearcheckbox);
    
    wrapxcheckbox = new JCheckBox();
    wrapxcheckbox.setText("warp x edges");
    c.gridwidth = GridBagConstraints.REMAINDER;
    gl.setConstraints(wrapxcheckbox, c);
    this.getContentPane().add(wrapxcheckbox);

    wrapycheckbox = new JCheckBox();
    wrapycheckbox.setText("warp y edges");
    c.gridwidth = GridBagConstraints.REMAINDER;
    gl.setConstraints(wrapycheckbox, c);
    this.getContentPane().add(wrapycheckbox);
        
    timesteplabel = new JLabel();
    timesteplabel.setText("generations to calculate");
    c.gridwidth = GridBagConstraints.REMAINDER;
    gl.setConstraints(timesteplabel, c);
    this.getContentPane().add(timesteplabel);

    
    timestepedit = new JTextField();
    timestepedit.setText("1");
    c.gridwidth = GridBagConstraints.REMAINDER;
    gl.setConstraints(timestepedit, c);
    this.getContentPane().add(timestepedit);
 

    sparsenesslabel = new JLabel();
    sparsenesslabel.setText("random rule table sparseness percent 0..100");
    c.gridwidth = GridBagConstraints.REMAINDER;
    gl.setConstraints(sparsenesslabel, c);
    this.getContentPane().add(sparsenesslabel);
  
    sparsenessedit = new JTextField();
    sparsenessedit.setText("0");
    c.gridwidth = GridBagConstraints.REMAINDER;
    gl.setConstraints(sparsenessedit, c);
    this.getContentPane().add(sparsenessedit);
    
    sparsenesscheckbox = new JCheckBox();
    sparsenesscheckbox.setText("clear rule table first");
    c.gridwidth = GridBagConstraints.REMAINDER;
    gl.setConstraints(sparsenesscheckbox, c);
    this.getContentPane().add(sparsenesscheckbox);

    unused_entries_checkbox = new JCheckBox();
    unused_entries_checkbox.setText("randomize only unused table entries");
    c.gridwidth = GridBagConstraints.REMAINDER;
    gl.setConstraints(unused_entries_checkbox, c);
    this.getContentPane().add(unused_entries_checkbox);


    simulator_delay_label = new JLabel();
    simulator_delay_label.setText("simulator delay");
    c.gridwidth = 2;
    gl.setConstraints(simulator_delay_label, c);
    this.getContentPane().add(simulator_delay_label);
  
    simulator_delay_edit = new JTextField();
    simulator_delay_edit.setText("0");
    c.gridwidth = GridBagConstraints.REMAINDER;
    gl.setConstraints(simulator_delay_edit, c);
    this.getContentPane().add(simulator_delay_edit);
    


    repaint_every_generation_checkbox = new JCheckBox();
    repaint_every_generation_checkbox.setText("repaint every generation");
    c.gridwidth = GridBagConstraints.REMAINDER;
    gl.setConstraints(repaint_every_generation_checkbox, c);
    this.getContentPane().add(repaint_every_generation_checkbox);
    
    
    

    okbutton = new JButton();
    okbutton.setText("ok");
    okbutton.setActionCommand("optionsokbuttonclick");
    okbutton.addActionListener(cellautoapp.actlis);
    c.gridwidth = 2;
    gl.setConstraints(okbutton, c);
    this.getContentPane().add(okbutton);

    cancelbutton = new JButton();
    cancelbutton.setText("cancel");
    cancelbutton.setActionCommand("optionscancelbuttonclick");
    cancelbutton.addActionListener(cellautoapp.actlis);
    c.gridwidth = GridBagConstraints.REMAINDER;
    gl.setConstraints(cancelbutton, c);
    this.getContentPane().add(cancelbutton);

    this.pack();
  }
  //this function displays the options
  void getoptions(){
    unused_entries_checkbox.setSelected(cellautoapp.randomize_only_unused_entries);
    wrapxcheckbox.setSelected(cellautoapp.board.wrapx);
    wrapycheckbox.setSelected(cellautoapp.board.wrapy);
    showgridcheckbox.setSelected(cellautoapp.gridon);
    transparentselectioncheckbox.setSelected(cellautoapp.transparentselection);
    selectionsavexycheckbox.setSelected(cellautoapp.selectionsavexy);
    dropselectioncheckbox.setSelected(cellautoapp.dropselectionbeforerunning);
    saveandclearcheckbox.setSelected(cellautoapp.save_and_clear_key_adds_random_cells);
    timestepedit.setText(Integer.toString(cellautoapp.timestep));
    simulator_delay_edit.setText(Integer.toString(cellautoapp.simulator_delay));
    if (cellautoapp.random_rule_table_sparseness > 0.0) {
      if (cellautoapp.random_rule_table_sparseness < 100.0) {
        sparsenessedit.setText(Double.toString(cellautoapp.random_rule_table_sparseness));
      } else {
        sparsenessedit.setText("100");
      }
    } else {
      sparsenessedit.setText("0");
    }
    sparsenesscheckbox.setSelected(cellautoapp.random_rule_table_clear);
    repaint_every_generation_checkbox.setSelected(cellautoapp.repaint_every_generation);
  }
  //this function updates the options
  void updateoptions(){
    cellautoapp.randomize_only_unused_entries = unused_entries_checkbox.isSelected();
    cellautoapp.random_rule_table_sparseness = Double.valueOf(sparsenessedit.getText().trim()).doubleValue();
    cellautoapp.timestep = Integer.parseInt(timestepedit.getText().trim());
    cellautoapp.board.wrapx = wrapxcheckbox.isSelected();
    cellautoapp.board.wrapy = wrapycheckbox.isSelected();
    cellautoapp.board2.wrapx = cellautoapp.board.wrapx;
    cellautoapp.board2.wrapy = cellautoapp.board.wrapy;
    cellautoapp.gridon = showgridcheckbox.isSelected();
    cellautoapp.transparentselection = transparentselectioncheckbox.isSelected();
    cellautoapp.selectionsavexy = selectionsavexycheckbox.isSelected();
    cellautoapp.dropselectionbeforerunning = dropselectioncheckbox.isSelected();
    cellautoapp.save_and_clear_key_adds_random_cells = saveandclearcheckbox.isSelected();
    cellautoapp.random_rule_table_clear = sparsenesscheckbox.isSelected();
    cellautoapp.simulator_delay = Integer.parseInt(simulator_delay_edit.getText().trim());
    cellautoapp.repaint_every_generation = repaint_every_generation_checkbox.isSelected();
  }
}


class genewindowc extends JFrame{
  int numgenes;
  int genewidth;
  int geneheight;
  
  byte ruletablegene[][][];
  int selgene;
  

  JLabel statuslabel;
  JLabel numgeneslabel;
  JTextField numgenesedit;

  JButton newbutton;
  JButton openbutton;
  JButton savebutton;
  JButton keepbutton;
  JButton replacebutton;
  
  JPanel panel1;
  JPanel panel2;
  JPanel panel3;
  JPanel panel4;
  JPanel panel5;
  genewindowc(String Title){
    super(Title);
    GridLayout gl = new GridLayout(5,1);
    this.getContentPane().setLayout(gl);


    panel1 = new JPanel();
    GridLayout gl2 = new GridLayout(1,2);
    panel1.setLayout(gl2);
    numgeneslabel = new JLabel("number of genes:");
    numgenesedit = new JTextField("               ");
    panel1.add(numgeneslabel);
    panel1.add(numgenesedit);
    this.getContentPane().add(panel1);

    panel2 = new JPanel();
    newbutton = new JButton("new random genes");
    panel2.add(newbutton);
    this.getContentPane().add(panel2);
    newbutton.setActionCommand("genenewbuttonclick");
    newbutton.addActionListener(cellautoapp.actlis);


    panel3 = new JPanel();
    openbutton = new JButton("open");
    savebutton = new JButton("save");
    panel3.add(openbutton);
    panel3.add(savebutton);
    this.getContentPane().add(panel3);
    openbutton.setActionCommand("geneopenbuttonclick");
    openbutton.addActionListener(cellautoapp.actlis);

    savebutton.setActionCommand("genesavebuttonclick");
    savebutton.addActionListener(cellautoapp.actlis);
    
    
    panel4 = new JPanel();
    keepbutton = new JButton("keep");
    replacebutton = new JButton("replace");
    panel4.add(keepbutton);
    panel4.add(replacebutton);
    this.getContentPane().add(panel4);
    keepbutton.setActionCommand("genekeepbuttonclick");
    keepbutton.addActionListener(cellautoapp.actlis);

    replacebutton.setActionCommand("genereplacebuttonclick");
    replacebutton.addActionListener(cellautoapp.actlis);

    panel5 = new JPanel();
    numgeneslabel = new JLabel("selected gene: 0 genes: 0");
    panel5.add(numgeneslabel);
    this.getContentPane().add(panel5);

    
    this.pack();
  }
  void updatestatuslabel(){
    numgeneslabel.setText("selected gene: " + selgene + "genes: " + numgenes);
  }
  void opengene(){
    try {
      int z = 0;
      int x = 0;
      int y = 0;
      FileDialog f = new FileDialog(cellautoapp.cellautowindowframe,"gene open",FileDialog.LOAD);
      f.show();
      String filename = f.getDirectory() + f.getFile();
      int l = filename.length();
      if (l > 0){
        BufferedReader r = new BufferedReader(new FileReader(filename));
        String line = r.readLine();
        while (line != null){
          String ss[] = line.split(",");
          for (int i = 0;i < ss.length;i++){
            ss[i] = ss[i].trim();
          }
          String st = ss[0];
          if (st.equals("cleargeneruletable")){
            int nr = Integer.valueOf(ss[1]).intValue();
            int w = Integer.valueOf(ss[2]).intValue();
            int h = Integer.valueOf(ss[3]).intValue();
            int s = Integer.valueOf(ss[4]).intValue();
            numgenes = nr;
            genewidth = w;
            geneheight = h;
            selgene = s;
          }
          
          if (st.equals("generuletable")){
            int i = 1;
            if (y >= geneheight){
              y = 0;
              z++;
            }
            x = 0;
            while (i < ss.length){
              int i2 = Integer.valueOf(ss[i]).intValue();
              if (x < genewidth){
                ruletablegene[z][x][y] = (byte) i2;
              }
              x++;
              i++;
            }
            x = 0;
            y++;
          }
          line = r.readLine();
        }
      
      }
      cellautoapp.updatestatusbar();
      cellautoapp.colorbox.colorboxpanel.repaint();
      cellautoapp.edittablewindow.edittablepanel.repaint();
      updatestatuslabel();
    } catch (java.io.IOException e){
            e.printStackTrace();
    }
  }
  void savegene(){
    try {
      FileDialog f = new FileDialog(cellautoapp.cellautowindowframe,"gene save",FileDialog.SAVE);
      f.show();
      String filename = f.getDirectory() + f.getFile();
      int l = filename.length();
      if (l > 0){
        PrintWriter p = new PrintWriter(new BufferedWriter(new FileWriter(filename,true)));
        p.println("cleargeneruletable," + numgenes + "," + genewidth + "," + geneheight + "," + selgene);
        int w = genewidth;
        int h = geneheight;
        for (int r = 0;r < numgenes;r++){
          for (int y = 0;y < h;y++){
            p.print("generuletable");
            for (int x = 0;x < w;x++){
              int i = ruletablegene[r][x][y];
              p.print("," + i);
            }
            p.println();
          }
          p.println();
        }
        p.close();
      }
    } catch (java.io.IOException e){
            e.printStackTrace();
    }
  }

  void newrandomgenes2(){
    int numgenes = Integer.parseInt(numgenesedit.getText().trim());
    newrandomgenes(numgenes);
    updatestatuslabel();
  }
  void newrandomgenes(int nr){
    numgenes = nr;
    int w = cellautoapp.cellauto131.tablewidth;
    int h = cellautoapp.cellauto131.tableheight;
    ruletablegene = new byte[nr][w][h];
    genewidth = w;
    geneheight = h;
    int numcolors = cellautoapp.cellauto131.numcolors;
    for (int r = 0;r < nr;r++){
      for (int x = 0;x < w;x++){
        for (int y = 0;y < h;y++){
          int a = cellautoapp.rand.nextInt(numcolors);
          ruletablegene[r][x][y] = (byte) a; 
        }
      }
      ruletablegene[r][0][0] = 0;
    }
    selgene = 0;
    updateruletable();
  }
  void replacegene(){
    int parent1 = cellautoapp.rand.nextInt(numgenes);
    int parent2 = cellautoapp.rand.nextInt(numgenes);
    for (int x = 0;x < genewidth;x++){
      for (int y = 0;y < geneheight;y++){
        int a = cellautoapp.rand.nextInt(2);
        if (a == 0){
          ruletablegene[selgene][x][y] = ruletablegene[parent1][x][y];
        }
        if (a == 1){
          ruletablegene[selgene][x][y] = ruletablegene[parent2][x][y];
        }
      }
    }
    selgene = ((selgene + 1) % numgenes);
  }
  void replacegenebuttonclick(){
    saveruletable();
    replacegene();
    updateruletable();
    cellautoapp.newgamedialog.newgame();
    updatestatuslabel();
  }
  void keepgenebuttonclick(){
    saveruletable();
    selgene = ((selgene + 1) % numgenes);
    updateruletable();
    cellautoapp.newgamedialog.newgame();
    updatestatuslabel();
  }
  void saveruletable(){
    int w = genewidth;
    int h = geneheight;
    int e = 0;
    if (w != cellautoapp.cellauto131.tablewidth){e = 1;}
    if (h != cellautoapp.cellauto131.tableheight){e = 1;}
    if (e == 1){
      //JOptionPane.showMessageDialog(cellautoapp.cellautowindowframe,new JLabel("gene size is not equal to rule table size"),"error",JOptionPane.ERROR_MESSAGE);      
      System.out.println("gene size is not equal to rule table size");
      return;
    }
    for (int x = 0;x < w;x++){
      for (int y = 0;y < h;y++){
        int a = cellautoapp.cellauto131.getlookuptable(x,y);
        ruletablegene[selgene][x][y] = (byte) a;
      }
    }
    //cellautoapp.edittablewindow.repaint();
    
  }
  void updateruletable(){
    int w = genewidth;
    int h = geneheight;
    int e = 0;
    if (w != cellautoapp.cellauto131.tablewidth){e = 1;}
    if (h != cellautoapp.cellauto131.tableheight){e = 1;}
    if (e == 1){
      //JOptionPane.showMessageDialog(cellautoapp.cellautowindowframe,new JLabel("gene size is not equal to rule table size"),"error",JOptionPane.ERROR_MESSAGE);      
      System.out.println("gene size is not equal to rule table size");
      return;
    }
    for (int x = 0;x < w;x++){
      for (int y = 0;y < h;y++){
        int a = ruletablegene[selgene][x][y];
        cellautoapp.cellauto131.setlookuptable(x,y,a);
      }
    }
    cellautoapp.edittablewindow.repaint();
  }
}


class cellautothreadc extends Thread {
  static public boolean running = false;
  static public boolean done = false;
  public int numgenerations = 0;
  public boolean repaint_every_generation = true;
  public long delay = 1000;
  
  static boolean undoevent = false;
  cellautothreadc(int n,boolean b,long d) {
    numgenerations = n;
    repaint_every_generation = b;
    delay = d;
    done = false;
    running = true;
  }
  public void run() {
    if (cellautoapp.verbose == true) {
      System.out.println("start");
    }
    done = false;
    running = true;
    long time1 = System.currentTimeMillis();
    long time2 = 0;
    while (numgenerations > 0) {
      try {
        cellautoapp.calc(1,repaint_every_generation);
        time2 = System.currentTimeMillis();
        long sleep_time = delay - (time2 - time1);
        if (sleep_time < 1) {sleep_time = 1;}
        sleep(sleep_time);
        time1 = System.currentTimeMillis();
      } catch (InterruptedException e) {
        e.printStackTrace();
      }
      if (done == true) {break;}
      numgenerations--;
    }
    running = false;
    if (undoevent == true) {
      cellautoapp.undo();      
      undoevent = false;
    }
    cellautoapp.cellautomainwindow.repaint();
    if (cellautoapp.cellauto131.lookuptableallused == false) {
      cellautoapp.edittablewindow.repaint();
    }
    if (cellautoapp.verbose == true) {
      System.out.println("done");
    }
  }
}
class rulefamilybrowserc extends JFrame {
  JList listbox;
  JButton button1;
  JButton button2;
  JScrollPane listboxscroller;
  Vector list;
  rulefamilybrowserc(String name){
    super(name);
    list = abstractcellautorulefamily.getrulefamilylist();
    listbox = new JList(list);
    listboxscroller = new JScrollPane(listbox);
    button1 = new JButton("select rule family");
    button1.setActionCommand("rule_family_browser_select_rule_family");
    button1.addActionListener(cellautoapp.actlis);

    button2 = new JButton("close");
    button2.setActionCommand("rule_family_browser_close");
    button2.addActionListener(cellautoapp.actlis);
    SpringLayout spl = new SpringLayout();
    this.getContentPane().setLayout(spl);
    spl.putConstraint(SpringLayout.EAST,listboxscroller,-2,SpringLayout.EAST,this.getContentPane());
    spl.putConstraint(SpringLayout.WEST,listboxscroller,2,SpringLayout.WEST,this.getContentPane());
    spl.putConstraint(SpringLayout.SOUTH,listboxscroller,-32,SpringLayout.SOUTH,this.getContentPane());
    spl.putConstraint(SpringLayout.NORTH,listboxscroller,2,SpringLayout.NORTH,this.getContentPane());
    spl.putConstraint(SpringLayout.NORTH,button1,0,SpringLayout.SOUTH,listboxscroller);
    spl.putConstraint(SpringLayout.NORTH,button2,0,SpringLayout.SOUTH,listboxscroller);
    spl.putConstraint(SpringLayout.SOUTH,button1,0,SpringLayout.SOUTH,this.getContentPane());
    spl.putConstraint(SpringLayout.SOUTH,button2,0,SpringLayout.SOUTH,this.getContentPane());
    spl.putConstraint(SpringLayout.WEST,button1,0,SpringLayout.WEST,this.getContentPane());
    spl.putConstraint(SpringLayout.WEST,button2,0,SpringLayout.EAST,button1);
    this.getContentPane().add(listboxscroller);
    this.getContentPane().add(button1);
    this.getContentPane().add(button2);
    this.pack();
    
  }
  void select_rule_family() {
     cellautoapp.calc_one_row = false;
     int i = listbox.getSelectedIndex();
     String name = (String) list.get(i);
     cellautoapp.cellauto131.rulefamily = abstractcellautorulefamily.getrulefamily(name);
     if (cellautoapp.cellauto131.rulefamily != null){
       cellautoapp.cellauto131.filllookuptableused();
       cellautoapp.cellautomainwindow.repaint();
       cellautoapp.edittablewindow.repaint();       
     } 
     //b.background_tile_sub_board2 = new simpleboardc(b.background_tile_sub_board);

  }
}


class filebrowserc extends JFrame implements MouseListener {
  JList listbox;
  JButton button1;
  JButton button2;
  JScrollPane listboxscroller;
  String directory;
  DefaultListModel list;
  ZipFile zip = null;
  filebrowserc() {
    super("file browser");
    list = new DefaultListModel();
    listbox = new JList(list);
    listboxscroller = new JScrollPane(listbox);
    button1 = new JButton("load list");
    button1.setActionCommand("file_browser_load_list");
    button1.addActionListener(cellautoapp.actlis);

    button2 = new JButton("load file");
    button2.setActionCommand("file_browser_load_file");
    button2.addActionListener(cellautoapp.actlis);
    SpringLayout spl = new SpringLayout();
    this.getContentPane().setLayout(spl);

    spl.putConstraint(SpringLayout.EAST,listboxscroller,-2,SpringLayout.EAST,this.getContentPane());
    spl.putConstraint(SpringLayout.WEST,listboxscroller,2,SpringLayout.WEST,this.getContentPane());
    spl.putConstraint(SpringLayout.SOUTH,listboxscroller,-32,SpringLayout.SOUTH,this.getContentPane());
    spl.putConstraint(SpringLayout.NORTH,listboxscroller,2,SpringLayout.NORTH,this.getContentPane());
    spl.putConstraint(SpringLayout.NORTH,button1,0,SpringLayout.SOUTH,listboxscroller);
    spl.putConstraint(SpringLayout.NORTH,button2,0,SpringLayout.SOUTH,listboxscroller);
    spl.putConstraint(SpringLayout.SOUTH,button1,0,SpringLayout.SOUTH,this.getContentPane());
    spl.putConstraint(SpringLayout.SOUTH,button2,0,SpringLayout.SOUTH,this.getContentPane());
    spl.putConstraint(SpringLayout.WEST,button1,0,SpringLayout.WEST,this.getContentPane());
    spl.putConstraint(SpringLayout.WEST,button2,0,SpringLayout.EAST,button1);
    this.getContentPane().add(listboxscroller);
    this.getContentPane().add(button1);
    this.getContentPane().add(button2);
    listbox.addMouseListener(this);
    this.pack();
  }
  //loadzipfile loads a zip file
  //Parameters: 
  //  filename: what zip file to load
  void loadzipfile(String filename) {
    try {
      zip = new ZipFile(filename);
      list.clear();
      Enumeration e = zip.entries();
      while(e.hasMoreElements()) {
        ZipEntry entry = (ZipEntry) e.nextElement();
        list.addElement(entry.getName());
      }    
    } catch (IOException e) {
      e.printStackTrace();
    }
  }

  //loadlist asks the user to select a file that has
  //a list of pattern files or a zip file then loads that file
  void loadlist() {
    String line;
    System.out.println("load list \n");
    try {
      FileDialog f = new FileDialog(this,"open list",FileDialog.LOAD);
      f.show();
      if (f.getFile() != null) {
        String filename = f.getDirectory() + f.getFile();
        String type = cellautoapp.getfiletype(filename);
        directory = f.getDirectory();
        if (type.equals("zip")){
          loadzipfile(filename);
        } else {
          BufferedReader r = new BufferedReader(new FileReader(filename));
          line = r.readLine();
          int e = 1;
          if (line != null) {
            line = line.trim();
            line = line.toLowerCase();
            if (line.equals("cell_auto_list")) {e = 0;}
          }
          if (e == 0) {
            zip = null;
            line = r.readLine();
            list.clear();
            while (line != null) {
              list.addElement(line);
              line = r.readLine();
            }
          }else{
            JOptionPane.showMessageDialog(cellautoapp.cellautowindowframe,new JLabel("the first line that says cell_auto_list is not found"),"error",JOptionPane.ERROR_MESSAGE);
          }
          r.close();
        }
      }
    } catch (IOException e) {
      e.printStackTrace();
    }
  }

  //loadfile loads a file that is in the list
  void loadfile() {
    try {
      System.out.println("load file \n");
      int i = listbox.getSelectedIndex();
      if (zip == null){
        String filename = directory + list.get(i);
        cellautoapp.open(filename);
      } else {
        String filename = (String) list.get(i);
        String filetype = cellautoapp.getfiletype(filename);
        ZipEntry e = zip.getEntry(filename);       
        if (filetype.equals("sqc")) {
          int r = cellautoapp.opensqc(new BufferedReader(new InputStreamReader(zip.getInputStream(e))));
          if (r == -1){
            cellautoapp.opentext(new BufferedReader(new InputStreamReader(zip.getInputStream(e))));
          }
        } else {
          cellautoapp.opentext(new BufferedReader(new InputStreamReader(zip.getInputStream(e))));
        }
      }
      cellautoapp.cellautowindowframe.requestFocusInWindow();
      cellautoapp.cellautomainwindow.repaint();
      cellautoapp.board2 = new boardc(cellautoapp.board);
      cellautoapp.colorbox.colorboxpanel.repaint();
      cellautoapp.edittablewindow.edittablepanel.repaint();
      cellautoapp.cellauto131.filename = (String) list.get(i);
      cellautoapp.updatestatusbar();
    } catch (IOException e) {
      e.printStackTrace();
    }
  }
  public void mouseClicked(MouseEvent e) {
    if (e.getClickCount() == 2) {
      loadfile();
    }
  }
  public void mouseEntered(MouseEvent e) {}
  public void mouseExited(MouseEvent e) {}
  public void mousePressed(MouseEvent e) {}
  public void mouseReleased(MouseEvent e) {}
}
class table_grid_spacing_dialogc extends JFrame {
  JLabel grid_x_spacing_label;
  JTextField grid_x_spacing_edit;
  JLabel grid_y_spacing_label;
  JTextField grid_y_spacing_edit;

  JLabel grid_x_spacing2_label;
  JTextField grid_x_spacing2_edit;
  JLabel grid_y_spacing2_label;
  JTextField grid_y_spacing2_edit;
  
  JButton okbutton;
  JButton cancelbutton;
  
  table_grid_spacing_dialogc(String Title) {
    this.setTitle(Title);
    GridBagLayout gl = new GridBagLayout();
    this.getContentPane().setLayout(gl);
    GridBagConstraints cc = new GridBagConstraints();
    cc.fill = GridBagConstraints.BOTH;
    cc.weightx = 1.0;
    cc.weighty = 1.0;

    grid_x_spacing_label = new JLabel("x spacing");
    cc.gridwidth = 1;
    gl.setConstraints(grid_x_spacing_label, cc);
    this.getContentPane().add(grid_x_spacing_label);    

    grid_x_spacing_edit = new JTextField("5");
    cc.gridwidth = GridBagConstraints.REMAINDER;
    gl.setConstraints(grid_x_spacing_edit, cc);
    this.getContentPane().add(grid_x_spacing_edit);    
    

    grid_y_spacing_label = new JLabel("y spacing");
    cc.gridwidth = 1;
    gl.setConstraints(grid_y_spacing_label, cc);
    this.getContentPane().add(grid_y_spacing_label);    

    grid_y_spacing_edit = new JTextField("5");
    cc.gridwidth = GridBagConstraints.REMAINDER;
    gl.setConstraints(grid_y_spacing_edit, cc);
    this.getContentPane().add(grid_y_spacing_edit);    

    
    grid_x_spacing2_label = new JLabel("x spacing 2");
    cc.gridwidth = 1;
    gl.setConstraints(grid_x_spacing2_label, cc);
    this.getContentPane().add(grid_x_spacing2_label);    

    grid_x_spacing2_edit = new JTextField("5");
    cc.gridwidth = GridBagConstraints.REMAINDER;
    gl.setConstraints(grid_x_spacing2_edit, cc);
    this.getContentPane().add(grid_x_spacing2_edit);    

    grid_y_spacing2_label = new JLabel("y spacing 2");
    cc.gridwidth = 1;
    gl.setConstraints(grid_y_spacing2_label, cc);
    this.getContentPane().add(grid_y_spacing2_label);    

    grid_y_spacing2_edit = new JTextField("5");
    cc.gridwidth = GridBagConstraints.REMAINDER;
    gl.setConstraints(grid_y_spacing2_edit, cc);
    this.getContentPane().add(grid_y_spacing2_edit);    

    okbutton = new JButton("ok");
    okbutton.setActionCommand("gridspacing_okbuttonclick");
    okbutton.addActionListener(cellautoapp.actlis);
    cc.gridwidth = 1;
    gl.setConstraints(okbutton, cc);
    this.getContentPane().add(okbutton);

    cancelbutton = new JButton("cancel");
    cancelbutton.setActionCommand("gridspacing_cancelbuttonclick");
    cancelbutton.addActionListener(cellautoapp.actlis);
    cc.gridwidth = GridBagConstraints.REMAINDER;
    gl.setConstraints(cancelbutton, cc);
    this.getContentPane().add(cancelbutton);        

    this.pack();
  }
  void get_grid_spacing() {
    grid_x_spacing_edit.setText(Integer.toString(edittablepanelc.grid_x_spacing));
    grid_y_spacing_edit.setText(Integer.toString(edittablepanelc.grid_y_spacing));
    grid_x_spacing2_edit.setText(Integer.toString(edittablepanelc.grid_x_spacing2));
    grid_y_spacing2_edit.setText(Integer.toString(edittablepanelc.grid_y_spacing2));
  }
  void update_grid_spacing() {
    edittablepanelc.grid_x_spacing = Integer.valueOf(grid_x_spacing_edit.getText()).intValue();
    edittablepanelc.grid_y_spacing = Integer.valueOf(grid_y_spacing_edit.getText()).intValue();
    edittablepanelc.grid_x_spacing2 = Integer.valueOf(grid_x_spacing2_edit.getText()).intValue();
    edittablepanelc.grid_y_spacing2 = Integer.valueOf(grid_y_spacing2_edit.getText()).intValue();
  }
}
class newgamedialogc extends JFrame {
  JLabel boardlabel;
  JLabel widthlabel;
  JTextField widthedit;
  JLabel heightlabel;
  JTextField heightedit;
  
  JLabel rectanglelabel;
  JLabel seedlabel;
  JTextField seededit;
  JLabel rectoffsetxlabel;
  JTextField rectoffsetxedit;
  JLabel rectoffsetylabel;
  JTextField rectoffsetyedit;
  JLabel rectwidthlabel;
  JTextField rectwidthedit;
  JLabel rectheightlabel;
  JTextField rectheightedit;
  JLabel numcolorslabel;
  JTextField numcolorsedit;
  
  JButton selectionbutton;
  JButton okbutton;
  JButton applybutton;
  JButton cancelbutton;
  JButton clearbutton;
  JLabel horizontalsymmetrylabel;
  JCheckBox horizontalsymmetrycheckBox;
  JLabel verticalsymmetrylabel;
  JCheckBox verticalsymmetrycheckBox;
  JCheckBox addcellscheckBox;
  JCheckBox iscirclecheckBox;
  JLabel symmetrylabel;
  JComboBox symmetrycombobox;
  static int HORIZONTAL_SYMMETRY = cellautoapp.HORIZONTAL_SYMMETRY;
  static int VERTICAL_SYMMETRY = cellautoapp.VERTICAL_SYMMETRY;
  static int INCLUDE_HORIZONTAL_LINE = cellautoapp.INCLUDE_HORIZONTAL_LINE;
  static int INCLUDE_VERTICAL_LINE = cellautoapp.INCLUDE_VERTICAL_LINE;

  String[] symmetryStrings = {"no symmetry","horizontal symmetry 1","horizontal symmetry 2","vertical symmetry 1",
  "vertical symmetry 2","horizontal and vertical symmetry 1","horizontal and vertical symmetry 2",
  "horizontal and vertical symmetry 3","horizontal and vertical symmetry 4"};
  int[] symmetryindex = {0, HORIZONTAL_SYMMETRY,HORIZONTAL_SYMMETRY | INCLUDE_VERTICAL_LINE,
  VERTICAL_SYMMETRY,VERTICAL_SYMMETRY | INCLUDE_HORIZONTAL_LINE,VERTICAL_SYMMETRY | HORIZONTAL_SYMMETRY,
  VERTICAL_SYMMETRY | HORIZONTAL_SYMMETRY | INCLUDE_VERTICAL_LINE,VERTICAL_SYMMETRY | HORIZONTAL_SYMMETRY | INCLUDE_HORIZONTAL_LINE,
  VERTICAL_SYMMETRY | HORIZONTAL_SYMMETRY | INCLUDE_VERTICAL_LINE | INCLUDE_HORIZONTAL_LINE};
  int seed;
  newgamedialogc(String Title) {
    super(Title);
    seed = 1;
    GridBagLayout gl = new GridBagLayout();
    this.getContentPane().setLayout(gl);
    GridBagConstraints c = new GridBagConstraints();
    
    c.fill = GridBagConstraints.BOTH;
    c.weightx = 1.0;
    c.weighty = 1.0;
    
    c.gridwidth = GridBagConstraints.REMAINDER;
    boardlabel = new JLabel();
    boardlabel.setText("board size");
    gl.setConstraints(boardlabel, c);
    
    c.gridwidth = 3;
    widthlabel = new JLabel();
    widthlabel.setText("width");
    gl.setConstraints(widthlabel, c);

    widthedit = new JTextField();
    widthedit.setText(String.valueOf(cellautoapp.board.width));
    c.gridwidth = GridBagConstraints.REMAINDER;
    gl.setConstraints(widthedit, c);

    heightlabel = new JLabel();
    heightlabel.setText("height");
    c.gridwidth = 3;
    gl.setConstraints(heightlabel, c);

    heightedit = new JTextField();
    heightedit.setText(String.valueOf(cellautoapp.board.height));
    c.gridwidth = GridBagConstraints.REMAINDER;
    gl.setConstraints(heightedit, c);
    
    c.gridwidth = GridBagConstraints.REMAINDER;
    rectanglelabel = new JLabel();
    rectanglelabel.setText("rectangle of random cells");
    gl.setConstraints(rectanglelabel, c);
    
    c.gridwidth = 3;
    seedlabel = new JLabel();
    seedlabel.setText("seed");
    gl.setConstraints(seedlabel, c);
    
    c.gridwidth = GridBagConstraints.REMAINDER;
    seededit = new JTextField();
    seededit.setText(Integer.toString(seed));
    gl.setConstraints(seededit, c);
    
    c.gridwidth = 3;
    numcolorslabel = new JLabel();
    numcolorslabel.setText("colors");
    gl.setConstraints(numcolorslabel, c);
    
    c.gridwidth = GridBagConstraints.REMAINDER;
    numcolorsedit = new JTextField();
    numcolorsedit.setText("0");
    gl.setConstraints(numcolorsedit, c);
    
    c.gridwidth = 3;
    rectoffsetxlabel = new JLabel();
    rectoffsetxlabel.setText("offset x");
    gl.setConstraints(rectoffsetxlabel, c);
    
    c.gridwidth = GridBagConstraints.REMAINDER;
    rectoffsetxedit = new JTextField();
    rectoffsetxedit.setText("0");
    gl.setConstraints(rectoffsetxedit, c);
    
    c.gridwidth = 3;
    rectoffsetylabel = new JLabel();
    rectoffsetylabel.setText("offset y");
    gl.setConstraints(rectoffsetylabel, c);
    
    c.gridwidth = GridBagConstraints.REMAINDER;
    rectoffsetyedit = new JTextField();
    rectoffsetyedit.setText("0");
    gl.setConstraints(rectoffsetyedit, c);
    
    c.gridwidth = 3;
    rectwidthlabel = new JLabel();
    rectwidthlabel.setText("width");
    gl.setConstraints(rectwidthlabel, c);
    
    c.gridwidth = GridBagConstraints.REMAINDER;
    rectwidthedit = new JTextField();
    rectwidthedit.setText("0");
    gl.setConstraints(rectwidthedit, c);
    
    c.gridwidth = 3;
    rectheightlabel = new JLabel();
    rectheightlabel.setText("height");
    gl.setConstraints(rectheightlabel, c);
    
    c.gridwidth = GridBagConstraints.REMAINDER;
    rectheightedit = new JTextField();
    rectheightedit.setText("0");
    gl.setConstraints(rectheightedit, c);


    selectionbutton = new JButton();
    selectionbutton.setText("use selection");
    selectionbutton.setActionCommand("useselectionbuttonclick");
    selectionbutton.addActionListener(cellautoapp.actlis);
    c.gridwidth = GridBagConstraints.REMAINDER;
    
    gl.setConstraints(selectionbutton, c);
    
    
    c.gridwidth = GridBagConstraints.REMAINDER;
    horizontalsymmetrycheckBox = new JCheckBox();
    horizontalsymmetrycheckBox.setText("horizontal symmetry");
    gl.setConstraints(horizontalsymmetrycheckBox, c);
    
    
    c.gridwidth = GridBagConstraints.REMAINDER;
    verticalsymmetrycheckBox = new JCheckBox();
    verticalsymmetrycheckBox.setText("vertical symmetry");
    gl.setConstraints(verticalsymmetrycheckBox, c);
    
    c.gridwidth = GridBagConstraints.REMAINDER;
    addcellscheckBox = new JCheckBox();
    addcellscheckBox.setText("add cells");
    gl.setConstraints(addcellscheckBox, c);
    

    c.gridwidth = GridBagConstraints.REMAINDER;
    iscirclecheckBox = new JCheckBox();
    iscirclecheckBox.setText("is circle");
    gl.setConstraints(iscirclecheckBox, c);
    
    
    c.gridwidth = GridBagConstraints.REMAINDER;
    symmetrylabel = new JLabel();
    symmetrylabel.setText("symmetry");
    gl.setConstraints(symmetrylabel, c);
    
    c.gridwidth = GridBagConstraints.REMAINDER;
    symmetrycombobox = new JComboBox(symmetryStrings);
    symmetrycombobox.setSelectedIndex(0);
    gl.setConstraints(symmetrycombobox, c);
    
    
    okbutton = new JButton();
    okbutton.setText("ok");
    okbutton.setActionCommand("newgameokbuttonclick");
    okbutton.addActionListener(cellautoapp.actlis);
    c.gridwidth = 2;
    
    gl.setConstraints(okbutton, c);
    
    applybutton = new JButton();
    applybutton.setText("apply");
    applybutton.setActionCommand("newgameapplybuttonclick");
    applybutton.addActionListener(cellautoapp.actlis);
    c.gridwidth = GridBagConstraints.REMAINDER;
    gl.setConstraints(applybutton, c);
    
    cancelbutton = new JButton();
    cancelbutton.setText("cancel");
    cancelbutton.setActionCommand("newgamecancelbuttonclick");
    cancelbutton.addActionListener(cellautoapp.actlis);
    c.gridwidth = 2;
    gl.setConstraints(cancelbutton, c);
    
    
    clearbutton = new JButton();
    clearbutton.setText("clear");
    clearbutton.setActionCommand("newgameclearbuttonclick");
    clearbutton.addActionListener(cellautoapp.actlis);
    c.gridwidth = GridBagConstraints.REMAINDER;
    gl.setConstraints(clearbutton, c);
    
    
    this.getContentPane().add(boardlabel);
    this.getContentPane().add(widthlabel);
    this.getContentPane().add(widthedit);
    this.getContentPane().add(heightlabel);
    this.getContentPane().add(heightedit);
    this.getContentPane().add(rectanglelabel);
    this.getContentPane().add(seedlabel);
    this.getContentPane().add(seededit);
    this.getContentPane().add(numcolorslabel);
    this.getContentPane().add(numcolorsedit);
    this.getContentPane().add(rectoffsetxlabel);
    this.getContentPane().add(rectoffsetxedit);
    this.getContentPane().add(rectoffsetylabel);
    this.getContentPane().add(rectoffsetyedit);
    this.getContentPane().add(rectwidthlabel);
    this.getContentPane().add(rectwidthedit);
    this.getContentPane().add(rectheightlabel);
    this.getContentPane().add(rectheightedit);

    this.getContentPane().add(selectionbutton);
    this.getContentPane().add(horizontalsymmetrycheckBox);
    this.getContentPane().add(verticalsymmetrycheckBox);
    this.getContentPane().add(addcellscheckBox);
    this.getContentPane().add(iscirclecheckBox);
    this.getContentPane().add(symmetrylabel);
    this.getContentPane().add(symmetrycombobox);
    this.getContentPane().add(okbutton);
    this.getContentPane().add(applybutton);
    this.getContentPane().add(cancelbutton);
    this.getContentPane().add(clearbutton);
    
    this.pack();
  }
  void useselection() {
    rectoffsetxedit.setText(Integer.toString(cellautoapp.selx));
    rectoffsetyedit.setText(Integer.toString(cellautoapp.sely));
    rectwidthedit.setText(Integer.toString(cellautoapp.selw));
    rectheightedit.setText(Integer.toString(cellautoapp.selh));
    
  }
  
  void clear() {
    int width = Integer.parseInt(widthedit.getText().trim());
    int height = Integer.parseInt(heightedit.getText().trim());
    cellautoapp.cellauto131.filename = null;
    boardc b = cellautoapp.board;
    cellautoapp.board = new boardc(width,height);
    cellautoapp.board.wrapx = b.wrapx;
    cellautoapp.board.wrapy = b.wrapy;
    if (cellautoapp.cellauto131.rulefamily != null) {
      cellautoapp.board.background_tile_sub_board = new simpleboardc(
      cellautoapp.cellauto131.rulefamily.get_background_tile_width(),
      cellautoapp.cellauto131.rulefamily.get_background_tile_height());
    } else {
      cellautoapp.board.background_tile_sub_board = new simpleboardc(1,1);
    }
    cellautoapp.board2 = new boardc(cellautoapp.board);
    cellautoapp.generation = 0;
    cellautoapp.updatestatusbar();
    cellautoapp.cellautomainwindow.repaint();
  }

  void newgame() {
    cellautoapp.seednumcolors = Integer.parseInt(numcolorsedit.getText().trim());

    int numcolors = cellautoapp.seednumcolors;
    if (numcolors <= 1){numcolors = cellautoapp.cellauto131.numcolors;}
    if (numcolors > cellautoapp.cellauto131.numcolors){
      numcolors = cellautoapp.cellauto131.numcolors;
    }
    int width = Integer.parseInt(widthedit.getText().trim());
    int height = Integer.parseInt(heightedit.getText().trim());
    int seed2 = Integer.parseInt(seededit.getText().trim());
    int sx = Integer.parseInt(rectoffsetxedit.getText().trim());
    int sy = Integer.parseInt(rectoffsetyedit.getText().trim());
    int swidth = Integer.parseInt(rectwidthedit.getText().trim());
    int sheight = Integer.parseInt(rectheightedit.getText().trim());
    int swidth2 = swidth;
    int sheight2 = sheight;
    boolean horizontalsymmetry = horizontalsymmetrycheckBox.isSelected();
    boolean verticalsymmetry = verticalsymmetrycheckBox.isSelected();
    boolean addcells = addcellscheckBox.isSelected();
    boolean iscircle = iscirclecheckBox.isSelected();
    cellautoapp.cellauto131.filename = null;
    
    
    //seed the board
    seededit.setText(Integer.toString(seed2+1));
    seed = seed2 + 1;
    if (addcells == false) {
      boardc b = cellautoapp.board;
      cellautoapp.board = new boardc(width,height);
      cellautoapp.board.wrapx = b.wrapx;
      cellautoapp.board.wrapy = b.wrapy;
      if (cellautoapp.cellauto131.rulefamily != null) {
        cellautoapp.board.background_tile_sub_board = new simpleboardc(
          cellautoapp.cellauto131.rulefamily.get_background_tile_width(),
          cellautoapp.cellauto131.rulefamily.get_background_tile_height());
      } else {
        cellautoapp.board.background_tile_sub_board = new simpleboardc(1,1);
      }
      cellautoapp.board2 = new boardc(cellautoapp.board);
      
    }
    cellautoapp.rand.setSeed(seed2);
    if (horizontalsymmetry) {
      swidth2 = (swidth >> 1) + (swidth & 1);
    }
    if (verticalsymmetry) {
      sheight2 = (sheight >> 1) + (sheight & 1);
    }
    
    //add random cells to board
    for (int x = 0;x < swidth;x++) {
      for (int y = 0;y < sheight;y++) {
        int a = cellautoapp.rand.nextInt(numcolors);
        if (iscircle == true) {
          double dx = ((double) x) / ((double) swidth);
          double dy = ((double) y) / ((double) sheight);
          dx = (dx * 2.0) - 1.0;
          dy = (dy * 2.0) - 1.0;
          double l = Math.sqrt((dx*dx)+(dy*dy));
          if (l > 1.0){a = 0;}
        }                                          
        cellautoapp.board.setsq(x+sx,y+sy,a);
        if (horizontalsymmetry) {cellautoapp.board.setsq((swidth-x-1)+sx,y+sy,a);}
        if (verticalsymmetry) {cellautoapp.board.setsq(x+sx,(sheight-y-1)+sy,a);}
        if (horizontalsymmetry) {
          if (verticalsymmetry) {
            cellautoapp.board.setsq((swidth-x-1)+sx,(sheight-y-1)+sy,a);
          }
        }
      }
    }
    if (addcells == false) {
      cellautoapp.generation = 0;
    }
    cellautoapp.updatestatusbar();
    cellautoapp.cellautomainwindow.repaint();
    int w2 = cellautoapp.cellautomainwindow.getWidth() / cellautomainwindowc.sqsize;
    int h2 = cellautoapp.cellautomainwindow.getHeight() / cellautomainwindowc.sqsize;

    cellautoapp.offsetx = sx-((w2-swidth)/2);
    cellautoapp.offsety = sy-((h2-sheight)/2);
    cellautoapp.symmetrybits = symmetryindex[symmetrycombobox.getSelectedIndex()];
  }
  void update_symmetrycombobox(int s) {
    if (s == 0) {
      symmetrycombobox.setSelectedIndex(0);
    } else {
      for (int i = 0;i < symmetryindex.length;i++) {
        if (s == symmetryindex[i]) {
          symmetrycombobox.setSelectedIndex(i);
        }
      }
    }
  }
}

class edittablewindowc extends JFrame {
  public edittablepanelc edittablepanel;
  public JScrollBar hscroll;
  public JScrollBar vscroll;
  edittableadjlisc adjlis;
  
  edittablewindowc(String Title){
    super(Title);
    adjlis = new edittableadjlisc();
    edittablepanel = new edittablepanelc();
    hscroll = new JScrollBar();
    vscroll = new JScrollBar();
    vscroll.setOrientation(JScrollBar.VERTICAL);
    vscroll.setMinimum(0);
    vscroll.setVisibleAmount(0);
    vscroll.setMaximum(cellautoapp.cellauto131.tableheight);
    vscroll.addAdjustmentListener(adjlis);
    hscroll.setMinimum(0);
    hscroll.setVisibleAmount(0);
    hscroll.setMaximum(cellautoapp.cellauto131.tablewidth);
    hscroll.addAdjustmentListener(adjlis);
    hscroll.setOrientation(JScrollBar.HORIZONTAL);
    SpringLayout spl = new SpringLayout();
    this.getContentPane().setLayout(spl);
    spl.putConstraint(SpringLayout.EAST,vscroll,0,SpringLayout.EAST,this.getContentPane());    
    spl.putConstraint(SpringLayout.EAST,edittablepanel,0,SpringLayout.WEST,vscroll);
    spl.putConstraint(SpringLayout.WEST,edittablepanel,0,SpringLayout.WEST,this.getContentPane());
    
    spl.putConstraint(SpringLayout.SOUTH,hscroll,0,SpringLayout.SOUTH,this.getContentPane());    
    spl.putConstraint(SpringLayout.SOUTH,edittablepanel,0,SpringLayout.NORTH,hscroll);    
    spl.putConstraint(SpringLayout.NORTH,edittablepanel,0,SpringLayout.NORTH,this.getContentPane());
    
    spl.putConstraint(SpringLayout.SOUTH,vscroll,0,SpringLayout.NORTH,hscroll);    
    spl.putConstraint(SpringLayout.NORTH,vscroll,0,SpringLayout.NORTH,this.getContentPane());    
    
    spl.putConstraint(SpringLayout.EAST,hscroll,0,SpringLayout.WEST,vscroll);    
    spl.putConstraint(SpringLayout.WEST,hscroll,0,SpringLayout.WEST,this.getContentPane());    
    this.getContentPane().add(edittablepanel);
    this.getContentPane().add(vscroll);
    this.getContentPane().add(hscroll);
    this.pack();  
    edittablepanel.setFocusable(true);
  }
};

class periodcheckerthreadc extends Thread {
  boolean running = true;
  boardc periodcheckerboard;
  boardc periodcheckerboard2;
  int period = 0;
  int shipdx = 0;
  int shipdy = 0;
  boolean period_found = false;

  // this function runs the period checker
  public void run(){
    period = 0;
    running = true;
    periodcheckerboard = new boardc(cellautoapp.board.width,cellautoapp.board.height);
    periodcheckerboard2 = new boardc(cellautoapp.board.width,cellautoapp.board.height);    
    for (int x = 0;x < cellautoapp.selw;x++) {
      for (int y = 0;y < cellautoapp.selh;y++) {
        int i = cellautoapp.seldata[x][y];

        periodcheckerboard.setsq(x,y,i);
        periodcheckerboard2.setsq(x,y,i);
      }
    }
    while (running == true) {
      if (checkoneperiod() == true) {
        period_found = true;
        running = false;
        break;
      }
      try {
        sleep(1);
      } catch (InterruptedException e) {
        e.printStackTrace();
      }
      
    }
    running = false;
  } 

  boolean compareboardtoselection(int dx,int dy) {
    for (int x = 0;x < cellautoapp.selw;x++) {
      for (int y = 0;y < cellautoapp.selh;y++) {
        int i = cellautoapp.seldata[x][y];
        int i2 = periodcheckerboard.getsq(x+dx,y+dy);
        if (i != i2) {
          return false;
        }
      }
    }
    return true;
  }
  boolean checkoneperiod() {
    int bordersize = 1;
    if (cellautoapp.cellauto131.rulefamily != null) {
      bordersize = cellautoapp.cellauto131.rulefamily.getbordersize();
    } else {
      bordersize = cellautoapp.cellauto131.bordersize;
    }
    boardc tmp = periodcheckerboard;
    periodcheckerboard = cellautoapp.cellauto131.calc3(periodcheckerboard,periodcheckerboard2);
    periodcheckerboard2 = tmp;
    period++;
    for (int dx = -bordersize*period;dx <= bordersize*period;dx++) {
      for (int dy = -bordersize*period;dy <= bordersize*period;dy++) {
        shipdx = dx;
        shipdy = dy;
        if (running == false) {return false;}
        try {
          sleep(0);
        } catch (InterruptedException e) {
          e.printStackTrace();
        }
        boolean b = compareboardtoselection(dx,dy);
        if (b == true) {return true;}
        
      }
    }

    return false;
  }  
}
class periodcheckeractlisc implements ActionListener {
  periodcheckerdialogc periodcheckerdialog;
  public void actionPerformed(ActionEvent e) {
    periodcheckerdialog.checkthread();
  }
}
class simple_file_type_option_dailogboxc extends JFrame{
  JLabel file_type_label;
  JLabel file_type_label2;
  JComboBox file_type_combo_box;
  JButton okbutton;
  JButton cancelbutton;
  String filename;
  String combo_box_strings[] = {"frank's java cellular automaton program","java square cell"};
  simple_file_type_option_dailogboxc(String Title) {
    super(Title);
    GridBagLayout gl = new GridBagLayout();
    this.getContentPane().setLayout(gl);
    GridBagConstraints c = new GridBagConstraints();

    c.fill = GridBagConstraints.BOTH;
    c.weightx = 1.0;
    c.weighty = 1.0;

    c.gridwidth = GridBagConstraints.REMAINDER;
    file_type_label = new JLabel();
    file_type_label.setText("what format do you want to save");
    gl.setConstraints(file_type_label, c);
    this.getContentPane().add(file_type_label);


    c.gridwidth = GridBagConstraints.REMAINDER;
    file_type_label2 = new JLabel();
    file_type_label2.setText(filename + " in?");
    gl.setConstraints(file_type_label2, c);
    this.getContentPane().add(file_type_label2);

    c.gridwidth = GridBagConstraints.REMAINDER;
    file_type_combo_box = new JComboBox(combo_box_strings);
    file_type_combo_box.setSelectedIndex(1);
    gl.setConstraints(file_type_combo_box, c);
    this.getContentPane().add(file_type_combo_box);
    
    c.gridwidth = 2;
    okbutton = new JButton("ok");
    gl.setConstraints(okbutton, c);
    this.getContentPane().add(okbutton);
    okbutton.setActionCommand("simple_file_type_ok_button");
    okbutton.addActionListener(cellautoapp.actlis);

    c.gridwidth = GridBagConstraints.REMAINDER;
    cancelbutton = new JButton("cancel");
    gl.setConstraints(cancelbutton, c);
    this.getContentPane().add(cancelbutton);
    cancelbutton.setActionCommand("simple_file_type_cancel_button");
    cancelbutton.addActionListener(cellautoapp.actlis);
    
  }
  void show(String filename2){
    this.filename = filename2;
    this.file_type_label2.setText(filename + " in?");
    this.setVisible(true);
  }
  void okbuttonclick() {
    int i = file_type_combo_box.getSelectedIndex();
    File f = new File(filename);
    if (f.exists() == false){
      try{
        if (i == 1) {
          cellautoapp.savesqc(new BufferedWriter(new FileWriter(filename,true)));
        } else {
          cellautoapp.savetext(new BufferedWriter(new FileWriter(filename,true)));
        }
      } catch (Exception err){
        err.printStackTrace();
      }  
    } else {
      JOptionPane.showMessageDialog(cellautoapp.cellautowindowframe,new JLabel("file already exists"),"error",JOptionPane.ERROR_MESSAGE);
    }
    this.setVisible(false);
  }
  void cancelbuttonclick() {
    this.setVisible(false);
  }
  
}

class periodcheckerdialogc extends JFrame {
  JButton checkbutton;
  JButton closebutton; 
  public JScrollPane text2; 
  public JTextArea text; 
  public javax.swing.Timer timer = null;

  periodcheckeractlisc actlis;
  periodcheckerthreadc periodcheckerthread = null;

  periodcheckerdialogc(String Title) {
    super(Title);              
    SpringLayout spl = new SpringLayout();
    this.getContentPane().setLayout(spl);
    checkbutton = new JButton("start");
    closebutton = new JButton("close");

    actlis = new periodcheckeractlisc();
    actlis.periodcheckerdialog = this;
    text = new JTextArea();
    text2 = new JScrollPane(text);
    spl.putConstraint(SpringLayout.SOUTH,checkbutton,-5,SpringLayout.SOUTH,this.getContentPane());
    spl.putConstraint(SpringLayout.SOUTH,closebutton,-5,SpringLayout.SOUTH,this.getContentPane());
    spl.putConstraint(SpringLayout.SOUTH,text2,-5,SpringLayout.NORTH,checkbutton);
    spl.putConstraint(SpringLayout.WEST,closebutton,5,SpringLayout.EAST,checkbutton);
    spl.putConstraint(SpringLayout.WEST,checkbutton,5,SpringLayout.WEST,this.getContentPane());

    spl.putConstraint(SpringLayout.NORTH,text2,5,SpringLayout.NORTH,this.getContentPane());
    spl.putConstraint(SpringLayout.EAST,text2,-5,SpringLayout.EAST,this.getContentPane());
    spl.putConstraint(SpringLayout.WEST,text2,5,SpringLayout.WEST,this.getContentPane());

    checkbutton.setActionCommand("periodcheckercheckbuttonclick");
    checkbutton.addActionListener(cellautoapp.actlis);
    closebutton.setActionCommand("periodcheckerclosebuttonclick");
    closebutton.addActionListener(cellautoapp.actlis);


    this.getContentPane().add(text2);
    this.getContentPane().add(checkbutton);
    this.getContentPane().add(closebutton);

    defaultlabeltext();
    this.pack();
  }
  void defaultlabeltext() {
    text.setText(" make a selection of the object \n you want to check then \n press the check button \n");
 
  }

  void checkobject() {
    if (periodcheckerthread == null) {
       if (cellautoapp.is_selection_empty() == true) {
        text.setText("no object found");
      } else {
        periodcheckerthread = new periodcheckerthreadc();

        checkbutton.setText("stop");
        text.setText("the period checker is running. \n" + 
                     "press the stop button to stop it. \n");
        periodcheckerthread.start();
        if (timer == null) {
          timer = new javax.swing.Timer(100,actlis);

        }
        timer.start();
      }
    } else {
      text.setText("no object found");
      timer.stop();
      periodcheckerthread.running = false;
      periodcheckerthread = null;
      checkbutton.setText("start");
    }

  }
  void checkthread(){
    if (periodcheckerthread == null) {return;}
    if (periodcheckerthread.running == false) {
      if (periodcheckerthread.period_found == true) {
        objectfound();
      }
    }
  }

  //this function is called when a ship or a oscillator is found
  void objectfound() {

    if (periodcheckerthread == null) {return;}
    
    if ((periodcheckerthread.shipdx == 0) & (periodcheckerthread.shipdy == 0)) {
        text.setText("oscillator found \n" + "its period is " + periodcheckerthread.period + "\n");
    } else {

        String str = "ship found \n";
        str = str + "it moves ";
        if (periodcheckerthread.shipdy < -1)  {str = str + (-periodcheckerthread.shipdy) + " cells up";}
        if (periodcheckerthread.shipdy == -1) {str = str + " 1 cell up";}
        if (periodcheckerthread.shipdy == 1)  {str = str + " 1 cell down";}
        if (periodcheckerthread.shipdy > 1)   {str = str + periodcheckerthread.shipdy + " cells down";}
        if ((periodcheckerthread.shipdx != 0) & (periodcheckerthread.shipdy != 0)) {
          str = str + " and ";
        }
        if (periodcheckerthread.shipdx < -1)  {str = str + (-periodcheckerthread.shipdx) + " cells left";}
        if (periodcheckerthread.shipdx == -1) {str = str + " 1 cell left";}
        if (periodcheckerthread.shipdx == 1)  {str = str + " 1 cell right";}
        if (periodcheckerthread.shipdx > 1)   {str = str + periodcheckerthread.shipdx + " cells right";}
        if (periodcheckerthread.period == 1) {
          str = str + " every period ";
        } else {
          str = str + " every " + periodcheckerthread.period + " periods ";
        }
        text.setText(str);
    }
    checkbutton.setText("start");
    periodcheckerthread = null;
  }
}
class keylistdescriptionwindowc extends JFrame {
  public JScrollPane text2; 
  public JTextArea text; 
  public JButton okbutton;
  public JButton cancelbutton;
  keylistdescriptionwindowc(String Title) {
    super(Title);
    SpringLayout spl = new SpringLayout();
    this.getContentPane().setLayout(spl);
    text = new JTextArea();
    text2 = new JScrollPane(text);
    okbutton = new JButton();
    okbutton.setText("ok");
    cancelbutton = new JButton();
    cancelbutton.setText("cancel");
    spl.putConstraint(SpringLayout.SOUTH,okbutton,-5,SpringLayout.SOUTH,this.getContentPane());
    spl.putConstraint(SpringLayout.SOUTH,cancelbutton,-5,SpringLayout.SOUTH,this.getContentPane());
    spl.putConstraint(SpringLayout.SOUTH,text2,-5,SpringLayout.NORTH,okbutton);
    spl.putConstraint(SpringLayout.WEST,cancelbutton,5,SpringLayout.EAST,okbutton);
    spl.putConstraint(SpringLayout.WEST,okbutton,5,SpringLayout.WEST,this.getContentPane());
    
    
    spl.putConstraint(SpringLayout.NORTH,text2,5,SpringLayout.NORTH,this.getContentPane());
    spl.putConstraint(SpringLayout.EAST,text2,-5,SpringLayout.EAST,this.getContentPane());
    spl.putConstraint(SpringLayout.WEST,text2,5,SpringLayout.WEST,this.getContentPane());


    okbutton.setActionCommand("keylistokbuttonclick");
    okbutton.addActionListener(cellautoapp.actlis);
    cancelbutton.setActionCommand("keylistcancelbuttonclick");
    cancelbutton.addActionListener(cellautoapp.actlis);
    this.getContentPane().add(text2);
    this.getContentPane().add(okbutton);
    this.getContentPane().add(cancelbutton);
    this.pack();  

    
  }
  void show_keys(){
    String str = "";
    str = str + "you can change the keys by editing options.txt \n";
    str = str + "see tutorial 4 editing the options at \n";
    str = str + "http://www.geocities.com/tinycat2001/cellauto/tutorial4.html \n";
    str = str + "here are some of the keys \n";
    str = str + "key name                   " + "key description                                           " + "key \n";
    str = str + "pencil_tool_key        " + "select the pencil tool                                 " + cellautokeys.pencil_tool_key + "\n";
    str = str + "select_tool_key        " + "select the selection tool                           " + cellautokeys.select_tool_key + "\n";
    str = str + "save_to_stack_key  " + "save a generation on the stack               " + cellautokeys.save_to_stack_key + "\n";
    str = str + "undo_key                   " + "go back to the last generation saved     " + cellautokeys.undo_key + "\n";
    str = str + "redo_key                    " + "go back to the current generation           " + cellautokeys.redo_key + "\n";
    str = str + "find_selection_key   " + "find the selection                                       " + cellautokeys.find_selection_key + "\n";
    str = str + "pan_mode_key        " + "switch pan mode on or off                        " + cellautokeys.pan_mode_key + "\n";
    str = str + "calc_key                     " + "calculate the next generations                " + cellautokeys.calc_key + "\n";
    str = str + "calc_key2                   " + "calculate the next generations                " + cellautokeys.calc_key2 + "\n";
    str = str + "prev_color_key         " + "select the previous state                          " + cellautokeys.prev_color_key + "\n";
    str = str + "next_color_key         " + "select the next state                                   " + cellautokeys.next_color_key + "\n";
    str = str + "xor_mode_key         " + "switch xor mode on or off                          " + cellautokeys.xor_mode_key + "\n";

    text.setText(str);
  }
}
class editdescriptionwindowc extends JFrame {
  public JScrollPane text2; 
  public JTextArea text; 
  public JButton okbutton;
  public JButton cancelbutton;
  editdescriptionwindowc(String Title){
    super(Title);
    SpringLayout spl = new SpringLayout();
    this.getContentPane().setLayout(spl);
    text = new JTextArea();
    text2 = new JScrollPane(text);
    okbutton = new JButton();
    okbutton.setText("ok");
    cancelbutton = new JButton();
    cancelbutton.setText("cancel");
    //spl.putConstraint(SpringLayout.SOUTH,text2,-5,SpringLayout.NORTH,okbutton);
    spl.putConstraint(SpringLayout.SOUTH,okbutton,-5,SpringLayout.SOUTH,this.getContentPane());
    spl.putConstraint(SpringLayout.SOUTH,cancelbutton,-5,SpringLayout.SOUTH,this.getContentPane());
    spl.putConstraint(SpringLayout.SOUTH,text2,-5,SpringLayout.NORTH,okbutton);
    spl.putConstraint(SpringLayout.WEST,cancelbutton,5,SpringLayout.EAST,okbutton);
    spl.putConstraint(SpringLayout.WEST,okbutton,5,SpringLayout.WEST,this.getContentPane());
    spl.putConstraint(SpringLayout.NORTH,text2,5,SpringLayout.NORTH,this.getContentPane());
    spl.putConstraint(SpringLayout.EAST,text2,-5,SpringLayout.EAST,this.getContentPane());
    spl.putConstraint(SpringLayout.WEST,text2,5,SpringLayout.WEST,this.getContentPane());

    okbutton.setActionCommand("descriptionokbuttonclick");
    okbutton.addActionListener(cellautoapp.actlis);
    cancelbutton.setActionCommand("descriptioncancelbuttonclick");
    cancelbutton.addActionListener(cellautoapp.actlis);
    text.setText(cellautoapp.cellauto131.description);
    this.getContentPane().add(text2);
    this.getContentPane().add(okbutton);
    this.getContentPane().add(cancelbutton);
    this.pack();  

    
  }
  void okbuttonclick(){
    cellautoapp.cellauto131.description = text.getText();
    setVisible(false);
  }
  void cancelbuttonclick(){
    setVisible(false);
  }
}

class ToolBar_Action extends AbstractAction{
  static Vector toolbar_list = null;
  String name;
  ToolBar_Action(String name2, Icon icon, String description) {
    if (toolbar_list == null) {
      toolbar_list = new Vector();
    }	    
    this.name = name2;
    putValue(Action.NAME, name2);
    putValue(Action.SMALL_ICON, icon);
    putValue(Action.SHORT_DESCRIPTION, description);
    toolbar_list.add(this);
  }
  String get_name() {
    return name;
  }
  void set_name(String n) {
    putValue(Action.NAME, n);    
    name = n;
  }
  public void actionPerformed(ActionEvent event) {  
    String name = (String) getValue(Action.NAME);
    System.out.println(name);
    if (name.equals("new")) {
      cellautoapp.newgamedialog.setVisible(true);
    }
    if (name.equals("open")) {
      cellautoapp.open2();
    }
    if (name.equals("save")) {
      cellautoapp.save2();
    }
    if (name.equals("pencil")) {
      cellautoapp.toollistindex = cellautoapp.PENCIL_TOOL;
      cellautoapp.updatestatusbar();
    }
    if (name.equals("selection")) {
      cellautoapp.toollistindex = cellautoapp.SELECT_TOOL;
      cellautoapp.updatestatusbar();
    }
    
    if (name.equals("stop")) {
      cellautoapp.stop();
    }
    if (name.equals("run")) {
      cellautoapp.run();
    }
    if (name.equals("step")) {
      cellautoapp.calc(1,true);
    }
    if (name.equals("undo")) {
      if (cellautothreadc.running == true){
        cellautoapp.stop();
        cellautothreadc.undoevent = true;
      } else {
        cellautoapp.undo();
      }
    }
    if (name.equals("redo")) {
      cellautoapp.redo();
    }
    if (name.equals("addundo")) {
      boardstate.s = 1;
      cellautoapp.updatestatusbar();
    }
    if (name.equals("zoomin")) {
      int x = cellautoapp.offsetx + (cellautoapp.cellautomainwindow.getWidth()/(cellautomainwindowc.sqsize*2));
      int y = cellautoapp.offsety + (cellautoapp.cellautomainwindow.getHeight()/(cellautomainwindowc.sqsize*2));
      cellautoapp.zoom(x,y,cellautoapp.ZOOM_IN);
      cellautoapp.cellautomainwindow.repaint();
    }
    if (name.equals("zoomout")) {
      int x = cellautoapp.offsetx + (cellautoapp.cellautomainwindow.getWidth()/(cellautomainwindowc.sqsize*2));
      int y = cellautoapp.offsety + (cellautoapp.cellautomainwindow.getHeight()/(cellautomainwindowc.sqsize*2));
      cellautoapp.zoom(x,y,cellautoapp.ZOOM_OUT);
      cellautoapp.cellautomainwindow.repaint();
    }
    if (name.equals("select_all")) {
      cellautoapp.select_all();
    }
    if (name.equals("select_center")) {
        cellautoapp.find_selection();
    }
    if (name.equals("select_rand")) {
      cellautoapp.randomize_selection();
      cellautoapp.cellautomainwindow.repaint();
    }
    if (name.equals("select_fill")) {
      for (int x = 0;x < cellautoapp.selw;x++) {
        for (int y = 0;y < cellautoapp.selh;y++) {
          cellautoapp.seldata[x][y] = cellautoapp.colorlistindex;
        }
      }
      cellautoapp.cellautomainwindow.repaint();
    }
    if (name.equals("flipy")) {
      cellautoapp.flipy();
      cellautoapp.cellautomainwindow.repaint();
    }
    if (name.equals("flipx")) {
      cellautoapp.flipx();
      cellautoapp.cellautomainwindow.repaint();
    }
    if (name.equals("rotatecc")) {
      cellautoapp.rotatec();
      cellautoapp.cellautomainwindow.repaint();
    }
    if (name.equals("rotatec")) {
      cellautoapp.rotatecc();
      cellautoapp.cellautomainwindow.repaint();
    }
    if (name.equals("clear_selection")) {
      //int option = JOptionPane.showConfirmDialog(cellautoapp.cellautowindowframe,new JLabel("clear the selection?"),"question",JOptionPane.YES_NO_OPTION,JOptionPane.QUESTION_MESSAGE);
      //if (option == JOptionPane.YES_OPTION) { 
        cellautoapp.saveboard();
        for (int x = 0;x < cellautoapp.selw;x++) {
          for (int y = 0;y < cellautoapp.selh;y++) {
            cellautoapp.seldata[x][y] = 0;
          }
        }
      //}
      cellautoapp.cellautomainwindow.repaint();
    }
    if (name.equals("clear_outside_selection")) {
      //int option = JOptionPane.showConfirmDialog(cellautoapp.cellautowindowframe,new JLabel("clear outside the selection?"),"question",JOptionPane.YES_NO_OPTION,JOptionPane.QUESTION_MESSAGE);
      //if (option == JOptionPane.YES_OPTION) { 
        cellautoapp.saveboard();
        cellautoapp.board = new boardc(cellautoapp.board.width,cellautoapp.board.height);
        cellautoapp.board2 = new boardc(cellautoapp.board);
        if (cellautoapp.cellauto131.rulefamily != null) {
          cellautoapp.board.background_tile_sub_board = new simpleboardc(
          cellautoapp.cellauto131.rulefamily.get_background_tile_width(),
          cellautoapp.cellauto131.rulefamily.get_background_tile_height());
        } else {
          cellautoapp.board.background_tile_sub_board = new simpleboardc(1,1);
        }
        cellautoapp.updatestatusbar();
        cellautoapp.cellautomainwindow.repaint();
      //}
    }
    cellautoapp.cellautowindowframe.requestFocusInWindow();
    
  }
}

class boardstate{
  int generation = 0;
  boardc board;
  cellautorulec c;
  String filename;
  static int s; 
  int offsetx = 0;
  int offsety = 0;
  
  int selx1 = 0;
  int sely1 = 0;
  int selx2 = 0;
  int sely2 = 0;
  int selx = 0;
  int sely = 0;
  int selw = 0;
  int selh = 0;
  int seldata[][];
}

//note: 
//these keys below are just the defaults  
//the keys usually are read from options.txt
//to configure the keys, edit options.txt
class cellautokeys {
  static String open_ctrl_key = "O";
  static String save_ctrl_key = "S";
  static String cut_ctrl_key = "X";
  static String copy_ctrl_key = "C";
  static String paste_ctrl_key = "V";
  static String flipy_ctrl_key = "Z";
  static String flipx_ctrl_key = "A";
  static String rotatec_ctrl_key = "D";
  static String rotatecc_ctrl_key = "F";
  static String options_ctrl_key = "P";
  static String seletionoption_ctrl_key = "L";
  static String random_table_ctrl_key = "R";
  static String table_tool_option_ctrl_key = "G";
  static String add_state_ctrl_key = "T";
  static String edit_state_ctrl_key = "E";
  static String random_selection_ctrl_key = "B";
  static String color_picker_tool_ctrl_key = "K";
  static String rule_family_options_ctrl_key = "W";

  static char prev_color_key = ',';
  static char next_color_key = '.';

  static char prev_tool_key = '<';
  static char next_tool_key = '>';

  
  static char pencil_tool_key = 'd';
  static char select_tool_key = 's';
  static char move_tool_key = 'a';
  static char zoom_in_tool_key = 'f';
  static char zoom_out_tool_key = 'g';
  
  
  static char save_and_clear_key = 'b';
  static char save_to_stack_key = 'x';       
  static char undo_key = 'z';
  static char redo_key = 'v';
  static char find_selection_key = 'c';
  static char pan_mode_key = 'p';
  static char xor_mode_key = 't';

  static char calc_key = 'n';
  static char calc_key2 = 'm';
}
class cellautoapp{
  static infowindowc infowindow;
  static neighborhoodvaluesdialogc neighborhoodvaluesdialog[] = new neighborhoodvaluesdialogc[4];
  static randomize_rule_table_dialogc randomize_rule_table_dialog = null;
  static double random_rule_table_sparseness = 0;
  static boolean xor_mode = false;
  static boolean random_rule_table_clear = false;
  static boolean randomize_only_unused_entries = false;
  static boolean use_new_adjust_method = true;
  static table_grid_spacing_dialogc table_grid_spacing_dialog;
  static periodcheckerdialogc periodcheckerdialog;
  static boolean clear_selection_before_loading = true;
  static boolean table_tool_show_a_generation_ahead = false;
  static boolean save_and_clear_key_adds_random_cells = false;
  static optionsdialogc optionsdialog = null;
  static trydiffpositionswindowc trydiffpositionswindow = null;
  static boolean dropselectionbeforerunning = true;
  static boolean keepselectionwhenpasting = true;
  static int menubarheight = 0;
  static int gridminsize = 4;
  static Rectangle toolboxrectangle = null;
  static Rectangle colorboxrectangle = null;
  static Rectangle mainwindowrectangle = new Rectangle(0,0,600,400);
  static Rectangle ruletablewindowrectangle = null;
  static String programname = "frank's java cellular automaton program ";
  static String programversion = " v 1.7 ";
  static String programversion2 = "1.7";
  static String programversion3 = programversion2;
  static double savefileversion = 1.7;
  static boolean panmode = true;
  static int generation = 0;
  static JLabel cellautostatusbar;
  static int timestep = 5;
  static int timestep2 = 1;
  static int movestep = 5;
  static boolean gridon = true;
  static boolean transparentselection = true;
  static newgamedialogc newgamedialog = null;
  static Stack undodata;
  static Stack redodata;
  static boolean autoadjustoffset = true;
  static addeditstatedialogc addeditstatedialog;
  static JMenu filemenu = null;
  static JMenu editmenu = null;
  static JMenu tablemenu = null;
  static JMenu viewmenu = null;
  static JMenu plugins_menu = null;
  static JMenuBar mainmenu = null;
  static cellautorulec cellauto131;
  static boardc board = null;
  static boardc board2 = null;
 
  static JPanel cellautomainpanel = null;
  static JFrame cellautowindowframe = null;
  static genewindowc genewindow = null;
  static edittablewindowc edittablewindow = null;
  static cellautomainwindowc cellautomainwindow = null;
  static colorboxc colorbox = null;
  static toolboxc toolbox = null;
  static keylisc keylis;
  static mouselisc mouselis;
  static mousemotionlisc mousemotionlis;
  static actlisc actlis;
  static int offsetx;
  static int offsety;
  static int selx1 = 0;
  static int sely1 = 0;
  static int selx2 = 0;
  static int sely2 = 0;
  static int selx = 0;
  static int sely = 0;
  static int selw = 0;
  static int selh = 0;
  static int lastx = 0;
  static int lasty = 0;  
  static int seldata[][];
  static int clipboardx = 0;
  static int clipboardy = 0;
  static int clipboarddata[][];
  static int clipboardwidth = 0;
  static int clipboardheight = 0;
  static int toollistindex = 8;
  static int colorlistindex = 0;//selcolor
  static int seednumcolors = 4;
  static boolean selectionsavexy = false;
  static Random rand;
  static String filename = null;
  static boolean ZOOM_IN = true;
  static boolean ZOOM_OUT = false;
  static editdescriptionwindowc editdescriptionwindow = null;
  static keylistdescriptionwindowc keylistdescriptionwindow = null;
  static boolean calc_one_row = false;
  static int randb = 0;
  static int randn = 0;
  static addmanystatesdialogc addmanystatesdialog;
  static statistics_windowc statistics_window; 
  static JToolBar cellauto_toolbar;
  static ImageIcon run_img;
  static ImageIcon stop_img;
  static ToolBar_Action run_action;
  
  
  static int RLUNCOMP = 1;       // 64K of uncompressed rule follows
  static int RLRUN = 2;          // 3-256 byte run of value follows
  static int RLONEB = 3;         // Single byte of specified value follows
  static int RLUNCS = 4;         // Uncompressed string follows
  static int RLCOPYB = 5;        // Copy previously specified bank
  static int RLEND =  6;         // End of rule definition
  static int RLLRUN = 7;
  static int RLLUNCS = 8;
  
  static int RSHTEXT = 64;       // Horizontal texture specification
  static int RSVTEXT = 65;       // Vertical texture specification
  static int RSRAND = 66;        // Random bit specification
  static int RSPAT = 67;         // Request load of pattern
  static int RSPAL = 68;         // Request load of palette
  static int RSRSEED = 71;       // Initial random seed
  static int RSOCODE = 72;       // Request load of user own code
  static int RSEPAT = 69;        // Embedded palette address
  static int RSEPAL = 70;        // Embedded pattern address
  static int RSEOCODE = 73;
  
  static int FILLEDRECTANGLE_TOOL = 0;
  static int SELECT_TOOL = 1;
  static int MOVE_TOOL = 2;
  static int TABLE_TOOL = 3;
  static int RECTANGLE_TOOL = 4;
  static int CIRCLE_TOOL = 5;
  static int FILLEDCIRCLE_TOOL = 6;
  static int LINE_TOOL = 7;
  static int PENCIL_TOOL = 8;
  static int ZOOMIN_TOOL = 9;
  static int ZOOMOUT_TOOL = 10;
  static int FILL_TOOL = 11;
  static int COLOR_PICKER_TOOL = 12;
  
  static int SAVE_TO_UNDO_STACK = 0;
  static int SAVE_TO_REDO_STACK = 1;
  static int RESTORE_FROM_UNDO_STACK = 0;
  static int RESTORE_FROM_REDO_STACK = 1;
                                          
  static int symmetrybits = 0;
  static int HORIZONTAL_SYMMETRY = 4;
  static int VERTICAL_SYMMETRY = 8;
  static int INCLUDE_HORIZONTAL_LINE = 2;
  static int INCLUDE_VERTICAL_LINE = 1;
  static boolean keywordfound = false;
  static boolean grid_highlighting_use_powers_of_4 = true;
  static boolean enable_file_compression = false;
  static int selectiontextbackground = 0;
  static TextTransferc TextTransfer;
  static int numtools = 13;
  static boolean usetableshortcut53 = false;
  static String toolname[] = {"filled rectange","select","move",
    "table","rectangle","circle","filled circle","line","pencil",
  "zoom in","zoom out","bucket fill","color picker"};
  static filebrowserc filebrowser;
  static rulefamilybrowserc rulefamilybrowser;
  static double file_version = 0;
  static boolean verbose = false;
  static boolean repaint_every_generation = true;
  static int simulator_delay = 200;
  static boolean save_board_offset_to_stack = false;
  static simple_file_type_option_dailogboxc simple_file_type_option_dailogbox;
  static boolean is_selection_empty(){
    for (int x = 0;x < cellautoapp.selw;x++){
      for (int y = 0;y < cellautoapp.selh;y++){
        int i = cellautoapp.seldata[x][y];
        if (i != cellautoapp.board.get_background_color(x,y)){
          return false;
        }
      }
    }
    return true;
  }
  //this function flips the selection horizontally
  static void flipx(){
    for (int x = 0;x < (cellautoapp.selw / 2);x++){
      for (int y = 0;y < cellautoapp.selh;y++){
        int tmp = cellautoapp.seldata[x][y];
        cellautoapp.seldata[x][y] = cellautoapp.seldata[cellautoapp.selw-x-1][y];
        cellautoapp.seldata[cellautoapp.selw-x-1][y] = tmp; 
      }
    }
    cellautoapp.cellautomainwindow.repaint();
    
  }
  
  //this function flips the selection vertically
  static void flipy(){
    for (int x = 0;x < cellautoapp.selw;x++){
      for (int y = 0;y < (cellautoapp.selh / 2);y++){
        int tmp = cellautoapp.seldata[x][y];
        cellautoapp.seldata[x][y] = cellautoapp.seldata[x][cellautoapp.selh-y-1];
        cellautoapp.seldata[x][cellautoapp.selh-y-1] = tmp; 
      }
    }
    cellautoapp.cellautomainwindow.repaint();
  }
  
  static void show_randomize_rule_table_dialog() {
    if (cellautoapp.randomize_rule_table_dialog == null){
      cellautoapp.randomize_rule_table_dialog = new randomize_rule_table_dialogc("randomize rule table");
      cellautoapp.randomize_rule_table_dialog.setBounds(0,0,200,200);
    }
    if (cellautoapp.randomize_rule_table_dialog.isVisible() == false) {
      cellautoapp.randomize_rule_table_dialog.setVisible(true);
    } else {          
      cellautoapp.randomize_rule_table_dialog.randomize_buttonclick();
      
    }
  }
  
  //this function adds random entries to the rule table
  static void randomizeruletable(int from_row,int to_row,int from_state,int to_state){
    double s = cellautoapp.random_rule_table_sparseness;
    double s2 = 100.0;
    int n = cellautoapp.cellauto131.numcolors;
    int n2 = to_state-from_state+1;
    if (from_state < 0) {from_state = 0;}
    if (to_state >= n) {to_state = n-1;}
    if (n > n2) {n = n2;}

    cellautoapp.saveboard();
    for (int x = 0;x < cellautoapp.cellauto131.tablewidth;x++){
      for (int y = 0;y < cellautoapp.cellauto131.tableheight;y++){
        if ((y >= from_row) & (y <= to_row)) {
          s2 = 100.0;
          if (s > 0.0){
            s2 = rand.nextDouble() * 100.0;
          }
          if ((cellautoapp.cellauto131.getlookuptableused(x,y) == 0) | 
              (randomize_only_unused_entries == false)) {
            if (s2 > s){
              
              int a = rand.nextInt(n) + from_state;
              cellautoapp.cellauto131.setlookuptable(x,y,a);
            } else if (cellautoapp.random_rule_table_clear == true) {
              cellautoapp.cellauto131.setlookuptable(x,y,0);
            }
          }
        }
      }
    }
    cellautoapp.cellauto131.setlookuptable(0,0,0);
  }

  //this function rotates the selection 90 degrees
  static void rotatec(){
    int tmp[][] = new int[cellautoapp.selh][cellautoapp.selw];
    for (int x = 0;x < cellautoapp.selw;x++){
      for (int y = 0;y < cellautoapp.selh;y++){
        int x2 = cellautoapp.selh-y-1;
        int y2 = x;
        tmp[x2][y2] = cellautoapp.seldata[x][y];
      }
    }
    int tmp2 = cellautoapp.selw;
    cellautoapp.selw = cellautoapp.selh;
    cellautoapp.selh = tmp2;
    cellautoapp.seldata = new int[cellautoapp.selw][cellautoapp.selh];
    cellautoapp.selx1 = cellautoapp.selx;
    cellautoapp.sely1 = cellautoapp.sely;
    cellautoapp.selx2 = cellautoapp.selx1 + cellautoapp.selw;
    cellautoapp.sely2 = cellautoapp.sely1 + cellautoapp.selh;
    for (int x = 0;x < cellautoapp.selw;x++){
      for (int y = 0;y < cellautoapp.selh;y++){
        cellautoapp.seldata[x][y] = tmp[x][y];
      }
    }
    int x1 = cellautoapp.selx1;
    int y1 = cellautoapp.sely1;
    int x2 = cellautoapp.selx2;
    int y2 = cellautoapp.sely2;
    
    cellautoapp.cellautomainwindow.repaint();
    
  }
  
  //this function rotates the selection 270 degrees
  static void rotatecc(){
    int tmp[][] = new int[cellautoapp.selh][cellautoapp.selw];
    for (int x = 0;x < cellautoapp.selw;x++){
      for (int y = 0;y < cellautoapp.selh;y++){
        int x2 = y;
        int y2 = cellautoapp.selw-x-1;
        tmp[x2][y2] = cellautoapp.seldata[x][y];
      }
    }
    int tmp2 = cellautoapp.selw;
    cellautoapp.selw = cellautoapp.selh;
    cellautoapp.selh = tmp2;
    cellautoapp.seldata = new int[cellautoapp.selw][cellautoapp.selh];
    cellautoapp.selx1 = cellautoapp.selx;
    cellautoapp.sely1 = cellautoapp.sely;
    cellautoapp.selx2 = cellautoapp.selx1 + cellautoapp.selw;
    cellautoapp.sely2 = cellautoapp.sely1 + cellautoapp.selh;
    for (int x = 0;x < cellautoapp.selw;x++){
      for (int y = 0;y < cellautoapp.selh;y++){
        cellautoapp.seldata[x][y] = tmp[x][y];
      }
    }
    int x1 = cellautoapp.selx1;
    int y1 = cellautoapp.sely1;
    int x2 = cellautoapp.selx2;
    int y2 = cellautoapp.sely2;
    
    cellautoapp.cellautomainwindow.repaint();
    
  }
  static void select_all() {
    byte vline[] = new byte[board.width];
    byte hline[] = new byte[board.height];
    long t1 = System.currentTimeMillis();
    cellautoapp.pasteseldata();

    boolean hasCells = false;
    int selx1b = selx1;
    int selx2b = selx2;
    int sely1b = sely1;
    int sely2b = sely2;
    
    for (int y = 0;y < board.height;y = y + 32) {
      for (int x = 0;x < board.width;x = x + 32) {
        if (board.block[x >> 5][y >> 5] != null) {
          for (int y2 = 0;y2 < 32;y2++) {
            for (int x2 = 0;x2 < 32;x2++) {
              if (board.block[x >> 5][y >> 5].board[x2][y2] != board.get_background_color(x+x2,y+y2)) {
                vline[x+x2] = 1;
                hline[y+y2] = 1;          
                hasCells = true;
              }
            }
          }
        }
      }
    }
    if (hasCells == false) {return;}
    //for (int y = 0;y < board.height;y++) {
    //  for (int x = 0;x < board.width;x++) {
    //    if (board.getsq(x,y) != board.get_background_color(x,y)) {
    //      vline[x] = 1;
    //      hline[y] = 1;          
    //    }
    //  }
    //}

    if (board.wrapx == true) {
    int bestoffset = 0;
    int bestlength = 0;
    int length = 0;
    int offset = 0;
    for (int i = 0;i < (board.width*2);i++) {
      if (vline[i%board.width] == 1) {
        if (length > bestlength){
          bestlength = length;
          bestoffset = offset;
        }
        length = 0;
        offset = i;
      } else {
        length++;
      }
    }
    //if (length > bestlength){bestlength = length;}
    selx1 = ((bestoffset+bestlength) % board.width) + 1;
    selx2 = selx1 + (board.width - bestlength);
    } else {
      for (int i = 0;i < board.width;i++) {
        if (vline[i] == 1) {selx2 = i+1;}
      }
      for (int i = (board.width-1);i >= 0;i--) {
        if (vline[i] == 1) {selx1 = i;}
      }
    }
    
    if (board.wrapy == true) {
    int bestoffset = 0;
    int bestlength = 0;
    int length = 0;
    int offset = 0;
    for (int i = 0;i < (board.height*2);i++) {
      if (hline[i%board.height] == 1) {
        if (length > bestlength){
          bestlength = length;
          bestoffset = offset;
        }
        length = 0;
        offset = i;
      } else {
        length++;
      }
    }
    //if (length > bestlength){bestlength = length;}
    sely1 = ((bestoffset+bestlength) % board.height) + 1;
    sely2 = sely1 + (board.height - bestlength);
    } else {
      for (int i = 0;i < board.width;i++) {
        if (hline[i] == 1) {sely2 = i+1;}
      }
      for (int i = (board.width-1);i >= 0;i--) {
        if (hline[i] == 1) {sely1 = i;}
      }
    }


    int n = (selx2-selx1) * (sely2-sely1);
    if (n > 10000) {
      int option = JOptionPane.showConfirmDialog(cellautoapp.cellautowindowframe,new JLabel("select all cells?"),"question",JOptionPane.YES_NO_OPTION,JOptionPane.QUESTION_MESSAGE);    
      if (option == JOptionPane.NO_OPTION) {
        selx1 = selx1b;
        selx2 = selx2b;
        sely1 = sely1b;
        sely2 = sely2b;
        n = 0;
      }
    }
    if (n > 0) {
      cellautoapp.setupsel();
      cellautoapp.cutseldata();
      cellautoapp.find_selection();
    } else {
      cellautoapp.cutseldata();
    }
    cellautoapp.cellautomainwindow.repaint();
  }
  static double updatehue(double hue,double offset){
    hue = hue + offset;
    while (hue < 0.0){hue = hue + 1536.0;}
    while (hue > 1536.0){hue = hue - 1536.0;}
    return hue;
  }
  static Color getcolorfromhue(double hue){
    return new Color(getprimecolorfromhue(hue,0.0),getprimecolorfromhue(hue,512.0),getprimecolorfromhue(hue,1024.0));
  }
  static int getprimecolorfromhue(double hue,double offset){
    double c = 0.0;
    hue = updatehue(hue,offset);
    if ((hue >= 0.0) & (hue < 256.0)){c = hue;}
    if ((hue >= 256.0) & (hue < 768.0)){c = 255.0;}
    if ((hue >= 768.0) & (hue < 1024.0)){c = 1023.0 - hue;}
    return (int) c;
  }
  
  //fill a shape
  static void bucketfill(int x,int y,int c1,int c2,int depth){
    if (c1 == c2){return;}
    if (depth == 0){return;}
    if (board.getsq(x,y) != c2){return;}
    board.setsq(x,y,c1);
    board2.setsq(x,y,c1);
    bucketfill(x+1,y,c1,c2,depth-1);
    bucketfill(x,y+1,c1,c2,depth-1);
    bucketfill(x-1,y,c1,c2,depth-1);
    bucketfill(x,y-1,c1,c2,depth-1);
    
  }
  
  //this function zooms in or out
  static void zoom(int x,int y,boolean zoomtype){
    int w = cellautomainwindow.getWidth();
    int h = cellautomainwindow.getHeight();
    if (zoomtype == ZOOM_IN){
      //cellautomainwindowc.sqsize = cellautomainwindowc.sqsize + ((cellautomainwindowc.sqsize+9) / 10);
      cellautomainwindowc.sqsize = cellautomainwindowc.sqsize + 1;
    }
    if (zoomtype == ZOOM_OUT){
      if (cellautomainwindowc.sqsize > 1){
        //cellautomainwindowc.sqsize = cellautomainwindowc.sqsize - ((cellautomainwindowc.sqsize+8) / 10);
        cellautomainwindowc.sqsize = cellautomainwindowc.sqsize - 1;
      }
    }
    //System.out.println("sqsize " + cellautomainwindowc.sqsize);
    offsetx = x - (w/(cellautomainwindowc.sqsize*2));
    offsety = y - (h/(cellautomainwindowc.sqsize*2));
    cellautoapp.cellautomainwindow.repaint();
  }
  
  //this function draws a line
  static void drawline(int x1,int y1,int x2,int y2){
    Graphics g = cellautoapp.cellautomainwindow.getGraphics();
    int x3 = x2-x1;
    int y3 = y2-y1;
    if (x3 < 0){x3 = -x3;}
    if (y3 < 0){y3 = -y3;}
    if (x3 >= y3){
      if (x2 > x1){
        double f0 = ((float)y3) / ((float)x3);
        double f1 = ((float) y1)+0.5;
        if (y1 < 0){f1 = ((float) y1)-0.5;}
        //if (y2 < y1){f1 = y2;}
        
        int y = ((int) f1);
        cellautoapp.board.setsq(x1,y,cellautoapp.colorlistindex);
        cellautoapp.board2.setsq(x1,y,cellautoapp.colorlistindex);
        cellautoapp.cellautomainwindow.paintsquare(g,x1-cellautoapp.offsetx,y-cellautoapp.offsety,cellautoapp.colorlistindex);
        for (int x = (x1+1);x <= x2;x++){
          if (y2 > y1){
            f1 = f1 + f0; 
          }else{
            f1 = f1 - f0;
          }
          y = ((int) f1);
          cellautoapp.board.setsq(x,y,cellautoapp.colorlistindex);
          cellautoapp.board2.setsq(x,y,cellautoapp.colorlistindex);
          cellautoapp.cellautomainwindow.paintsquare(g,x-cellautoapp.offsetx,y-cellautoapp.offsety,cellautoapp.colorlistindex);
          
        }
      }else{
        double f0 = ((float)y3) / ((float)x3);
        double f1 = ((float) y2)+0.5;
        if (y2 < 0){f1 = ((float) y2)-0.5;}
        //if (y1 < y2){f1 = y1;}
        int y = ((int) f1);
        cellautoapp.board.setsq(x2,y,cellautoapp.colorlistindex);
        cellautoapp.board2.setsq(x2,y,cellautoapp.colorlistindex);
        cellautoapp.cellautomainwindow.paintsquare(g,x2-cellautoapp.offsetx,y-cellautoapp.offsety,cellautoapp.colorlistindex);
        for (int x = (x2+1);x <= x1;x++){
          if (y2 > y1){
            f1 = f1 - f0; 
          }else{
            f1 = f1 + f0;
          }
          y = ((int) f1);
          cellautoapp.board.setsq(x,y,cellautoapp.colorlistindex);
          cellautoapp.board2.setsq(x,y,cellautoapp.colorlistindex);
          cellautoapp.cellautomainwindow.paintsquare(g,x-cellautoapp.offsetx,y-cellautoapp.offsety,cellautoapp.colorlistindex);
          
        }
        
      }
    }else{
      if (y2 > y1){
        double f0 = ((float)x3) / ((float)y3);
        double f1 = ((float) x1)+0.5;
        if (x1 < 0){f1 = ((float) x1)-0.5;}
        //if (x2 < x1){f1 = x2;}
        int x = ((int) f1);
        cellautoapp.board.setsq(x,y1,cellautoapp.colorlistindex);
        cellautoapp.board2.setsq(x,y1,cellautoapp.colorlistindex);
        cellautoapp.cellautomainwindow.paintsquare(g,x-cellautoapp.offsetx,y1-cellautoapp.offsety,cellautoapp.colorlistindex);
        for (int y = (y1+1);y <= y2;y++){
          if (x2 > x1){
            f1 = f1 + f0; 
          }else{
            f1 = f1 - f0;
          }
          x = ((int) f1);
          cellautoapp.board.setsq(x,y,cellautoapp.colorlistindex);
          cellautoapp.board2.setsq(x,y,cellautoapp.colorlistindex);
          cellautoapp.cellautomainwindow.paintsquare(g,x-cellautoapp.offsetx,y-cellautoapp.offsety,cellautoapp.colorlistindex);
          
        }
      }else{
        double f0 = ((float)x3) / ((float)y3);
        double f1 = ((float)x2) +0.5;
        if (x2 < 0){f1 = ((float) x2)-0.5;}
        //if (x1 < x2){f1 = x1;}
        int x = ((int) f1);
        cellautoapp.board.setsq(x,y2,cellautoapp.colorlistindex);
        cellautoapp.board2.setsq(x,y2,cellautoapp.colorlistindex);
        cellautoapp.cellautomainwindow.paintsquare(g,x-cellautoapp.offsetx,y2-cellautoapp.offsety,cellautoapp.colorlistindex);
        for (int y = (y2+1);y <= y1;y++){
          if (x2 > x1){
            f1 = f1 - f0; 
          }else{
            f1 = f1 + f0;
          }
          x = ((int) f1);
          cellautoapp.board.setsq(x,y,cellautoapp.colorlistindex);
          cellautoapp.board2.setsq(x,y,cellautoapp.colorlistindex);
          cellautoapp.cellautomainwindow.paintsquare(g,x-cellautoapp.offsetx,y-cellautoapp.offsety,cellautoapp.colorlistindex);
          
        }
      }    
    }
  }
  
  //this function draws the outline of a rectangle
  static void drawrectangle(int x1,int y1,int x2,int y2){
    int tmp = 0;
    Graphics g = cellautoapp.cellautomainwindow.getGraphics();
    if (x2 < x1){
      tmp = x2;
      x2 = x1;
      x1 = tmp;
    }
    if (y2 < y1){
      tmp = y2;
      y2 = y1;
      y1 = tmp;
    }
    //draw corners
    cellautoapp.board.setsq(x1,y1,cellautoapp.colorlistindex);
    cellautoapp.board2.setsq(x1,y1,cellautoapp.colorlistindex);
    cellautoapp.cellautomainwindow.paintsquare(g,x1-cellautoapp.offsetx,y1-cellautoapp.offsety,cellautoapp.colorlistindex);
    
    if (y1 != y2){
      cellautoapp.board.setsq(x1,y2,cellautoapp.colorlistindex);
      cellautoapp.board2.setsq(x1,y2,cellautoapp.colorlistindex);
      cellautoapp.cellautomainwindow.paintsquare(g,x1-cellautoapp.offsetx,y2-cellautoapp.offsety,cellautoapp.colorlistindex);
    }
    if (x1 != x2){
      cellautoapp.board.setsq(x2,y1,cellautoapp.colorlistindex);
      cellautoapp.board2.setsq(x2,y1,cellautoapp.colorlistindex);
      cellautoapp.cellautomainwindow.paintsquare(g,x2-cellautoapp.offsetx,y1-cellautoapp.offsety,cellautoapp.colorlistindex);
    }
    
    if (x1 != x2){
      if (y1 != y2){
        cellautoapp.board.setsq(x2,y2,cellautoapp.colorlistindex);
        cellautoapp.board2.setsq(x2,y2,cellautoapp.colorlistindex);
        cellautoapp.cellautomainwindow.paintsquare(g,x2-cellautoapp.offsetx,y2-cellautoapp.offsety,cellautoapp.colorlistindex);
      }
    }
    for (int x = (x1+1);x < x2;x++){
      cellautoapp.board.setsq(x,y1,cellautoapp.colorlistindex);
      cellautoapp.board2.setsq(x,y1,cellautoapp.colorlistindex);
      cellautoapp.cellautomainwindow.paintsquare(g,x-cellautoapp.offsetx,y1-cellautoapp.offsety,cellautoapp.colorlistindex);
      
      cellautoapp.board.setsq(x,y2,cellautoapp.colorlistindex);
      cellautoapp.board2.setsq(x,y2,cellautoapp.colorlistindex);
      cellautoapp.cellautomainwindow.paintsquare(g,x-cellautoapp.offsetx,y2-cellautoapp.offsety,cellautoapp.colorlistindex);
    }
    
    for (int y = (y1+1);y < y2;y++){    
      cellautoapp.board.setsq(x1,y,cellautoapp.colorlistindex);
      cellautoapp.board2.setsq(x1,y,cellautoapp.colorlistindex);
      cellautoapp.cellautomainwindow.paintsquare(g,x1-cellautoapp.offsetx,y-cellautoapp.offsety,cellautoapp.colorlistindex);
      
      cellautoapp.board.setsq(x2,y,cellautoapp.colorlistindex);
      cellautoapp.board2.setsq(x2,y,cellautoapp.colorlistindex);
      cellautoapp.cellautomainwindow.paintsquare(g,x2-cellautoapp.offsetx,y-cellautoapp.offsety,cellautoapp.colorlistindex);
    }
  }
  
  //draw a filled rectangle
  static void fillrectangle(int x1,int y1,int x2,int y2){
    int tmp = 0;
    if (x2 < x1){
      tmp = x2;
      x2 = x1;
      x1 = tmp;
    }
    if (y2 < y1){
      tmp = y2;
      y2 = y1;
      y1 = tmp;
    }
    Graphics g = cellautoapp.cellautomainwindow.getGraphics();
    for (int x = x1;x <= x2;x++){
      for (int y = y1;y <= y2;y++){
        cellautoapp.board.setsq(x,y,cellautoapp.colorlistindex);
        cellautoapp.board2.setsq(x,y,cellautoapp.colorlistindex);
        cellautoapp.cellautomainwindow.paintsquare(g,x-cellautoapp.offsetx,y-cellautoapp.offsety,cellautoapp.colorlistindex);
      }
    }
  }
  
  //draw a filled circle
  static void fillcircle(int x1,int y1,int x2,int y2){
    Graphics g = cellautoapp.cellautomainwindow.getGraphics();
    double x3 = (((double) (x2+x1)) / 2.0);
    double y3 = (((double) (y2+y1)) / 2.0);
    double x4 = (((double) (x2-x1)) / 2.0);
    double y4 = (((double) (y2-y1)) / 2.0);
    double x5 = x3-x4+0.5;
    double y5 = y3-y4+0.5;
    while (x5 < (x3+x4)){
      double x6 = (x5-x3) / x4; 
      double y6 = Math.sqrt(1-(x6*x6));
      y5 = y3-(y6*y4);
      while (y5 < (y3+(y6*y4))){
        cellautoapp.board.setsq(((int) x5),((int) y5),cellautoapp.colorlistindex);
        cellautoapp.board2.setsq(((int) x5),((int) y5),cellautoapp.colorlistindex);
        cellautoapp.cellautomainwindow.paintsquare(g,((int) x5)-cellautoapp.offsetx,((int) y5)-cellautoapp.offsety,cellautoapp.colorlistindex);
        y5 = y5 + 1.0;
      }
      
      x5 = x5 + 1.0;
    }
    
  }
  
  //draw the outline of a circle
  static void drawcircle(int x1,int y1,int x2,int y2){
    Graphics g = cellautoapp.cellautomainwindow.getGraphics();
    double x3 = (((double) (x2+x1)) / 2.0);
    double y3 = (((double) (y2+y1)) / 2.0);
    double x4 = (((double) (x2-x1)) / 2.0);
    double y4 = (((double) (y2-y1)) / 2.0);
    double x5 = (x3-x4);
    double y5 = y3-y4;
    double f1 = 0;
    double f2 = (x5-x3) / x4;
    f2 = Math.sqrt(1-(f2*f2));
    x5 = x5 + 1.0;
    while (x5 <= (x3+x4)){
      f2 = f1;
      f1 = (x5-x3) / x4;
      f1 = Math.sqrt(1-(f1*f1));
      if (f1 > f2){
        
        y5 = y3-(f1*y4);
        while (y5 <= (y3-(f2*y4))){
          cellautoapp.board.setsq(((int) (x5+0.5)),((int) (y5+0.5)),cellautoapp.colorlistindex);
          cellautoapp.board2.setsq(((int) (x5+0.5)),((int) (y5+0.5)),cellautoapp.colorlistindex);
          cellautoapp.cellautomainwindow.paintsquare(g,((int) (x5+0.5))-cellautoapp.offsetx,((int) (y5+0.5))-cellautoapp.offsety,cellautoapp.colorlistindex);
          y5 = y5 + 1.0;
        }
        
        y5 = y3+(f2*y4);
        while (y5 <= (y3+(f1*y4))){
          cellautoapp.board.setsq(((int) (x5+0.5)),((int) (y5+0.5)),cellautoapp.colorlistindex);
          cellautoapp.board2.setsq(((int) (x5+0.5)),((int) (y5+0.5)),cellautoapp.colorlistindex);
          cellautoapp.cellautomainwindow.paintsquare(g,((int) (x5+0.5))-cellautoapp.offsetx,((int) (y5+0.5))-cellautoapp.offsety,cellautoapp.colorlistindex);
          y5 = y5 + 1.0;
        }
      }
      if (f1 <= f2){
        y5 = y3-(f2*y4);
        while (y5 <= (y3-(f1*y4))){
          cellautoapp.board.setsq(((int) (x5+0.5)),((int) (y5+0.5)),cellautoapp.colorlistindex);
          cellautoapp.board2.setsq(((int) (x5+0.5)),((int) (y5+0.5)),cellautoapp.colorlistindex);
          cellautoapp.cellautomainwindow.paintsquare(g,((int) (x5+0.5))-cellautoapp.offsetx,((int) (y5+0.5))-cellautoapp.offsety,cellautoapp.colorlistindex);
          y5 = y5 + 1.0;
        }
        
        y5 = y3+(f1*y4);
        while (y5 <= (y3+(f2*y4))){
          cellautoapp.board.setsq(((int) (x5+0.5)),((int) (y5+0.5)),cellautoapp.colorlistindex);
          cellautoapp.board2.setsq(((int) (x5+0.5)),((int) (y5+0.5)),cellautoapp.colorlistindex);
          cellautoapp.cellautomainwindow.paintsquare(g,((int) (x5+0.5))-cellautoapp.offsetx,((int) (y5+0.5))-cellautoapp.offsety,cellautoapp.colorlistindex);
          y5 = y5 + 1.0;
        }
      }
      x5 = x5 + 1.0;
    }
  }

  static void undo() {
    cellautoapp.restoreboard(cellautoapp.RESTORE_FROM_UNDO_STACK);
    cellautoapp.updatestatusbar();
    cellautoapp.cellautomainwindow.repaint();
    cellautoapp.edittablewindow.edittablepanel.repaint();
    cellautoapp.colorbox.colorboxpanel.repaint();
  }
  static void redo() {
    cellautoapp.restoreboard(cellautoapp.RESTORE_FROM_REDO_STACK);
    cellautoapp.updatestatusbar();
    cellautoapp.cellautomainwindow.repaint();
    cellautoapp.edittablewindow.edittablepanel.repaint();
    cellautoapp.colorbox.colorboxpanel.repaint();
  }
  
  
  static boolean isFileCompressed(String filename) {
    try{
      FileInputStream f = new FileInputStream(filename);
      int b = f.read();
      int b2 = f.read();
      f.close();
      if (b == 31) {
        if (b2 == 139) {
          return true;
        }
      }
    } catch (Exception err){
      err.printStackTrace();
    }
    return false;
  }
  static void open2() {
      try{
        if (cellautothreadc.running == true){
          cellautoapp.stop();
	}
        FileDialog f = new FileDialog(cellautoapp.cellautowindowframe,"open pattern",FileDialog.LOAD);
        f.show();
        if (f.getFile() != null) {
          cellautoapp.cellauto131.filename = f.getFile();
          String filename = f.getDirectory() + f.getFile();
          cellautoapp.open(filename);
        } else {
          
        }
        cellautoapp.cellautowindowframe.requestFocusInWindow();
        cellautoapp.cellautomainwindow.repaint();
        
      } catch (Exception err) {
        System.out.println("menuopen error");
        System.out.println(err.getMessage());
        err.printStackTrace();
      }
  }
  static void save2() {
      try{
        if (cellautothreadc.running == true){
	  cellautoapp.stop();
	}
        FileDialog f = new FileDialog(cellautoapp.cellautowindowframe,"save pattern",FileDialog.SAVE);
        f.show();
        if (f.getFile() != null) {
          cellautoapp.cellauto131.filename = f.getFile();
          String filename = f.getDirectory() + f.getFile();
          cellautoapp.save(filename);
          
          //cellautoapp.cellautomainwindow.setFocusTraversalKeysEnabled(true);
          cellautoapp.cellautomainwindow.repaint();
        }
        cellautoapp.cellautowindowframe.requestFocusInWindow();
      } catch (Exception err) {
        System.out.println("menusave error");
        System.out.println(err.getMessage());
        err.printStackTrace();
      }
  }
  
  //this function opens a file and reads from it
  //Parameters:
  //  filename: the file to read from
  static void open(String filename){
    int l = filename.length();
    //System.out.println(" l " + l);
    try{

      if (l > 0){
        String filetype = cellautoapp.getfiletype(filename);
        if (filetype.equals("sqc")) {
          int r = opensqc(new BufferedReader(new FileReader(filename)));
          if (r == -1){
            opentext(new BufferedReader(new FileReader(filename)));
          }
        } else if (filetype.equals("gz")) {
          boolean c = isFileCompressed(filename);
          if (c == true) {
            opentext(new BufferedReader(new InputStreamReader(new GZIPInputStream(new FileInputStream(filename)))));
          } else {
            opentext(new BufferedReader(new FileReader(filename)));
          }
        } else if (filetype.equals("jc")) {
          String path = cellautoapp.getpath(filename);
          //System.out.println("path " + path);
          int r = openjc(new RandomAccessFile(filename,"r"),path);
          if (r == -1){
            opentext(new BufferedReader(new FileReader(filename)));
          }
        } else if (filetype.equals("jcc")) {
          int r = openjcc(new RandomAccessFile(filename,"r"));
          if (r == -1){
            opentext(new BufferedReader(new FileReader(filename)));
          }
        } else if (filetype.equals("jcp")) {
          int r = openjcp(new RandomAccessFile(filename,"r"));
          if (r == -1){
            opentext(new BufferedReader(new FileReader(filename)));
          }
        } else {
          opentext(new BufferedReader(new FileReader(filename)));
        }
        board2 = new boardc(board);
        board2 = cellauto131.calcbgcolor(board,board2);
        board2.changecellstates(board.get_background_color(0,0),board2.get_background_color(0,0));
        
      }
    } catch (Exception err){
      System.out.println("menuopen error");
      err.printStackTrace();
    }
    updatestatusbar();
    cellautoapp.colorbox.colorboxpanel.repaint();
    cellautoapp.edittablewindow.edittablepanel.repaint();
  }
  
  //this function saves a files and writes to it
  //Parameters:
  //  filename: the file to read from
  static void save(String filename){
    try{
      int l = filename.length();
      if (l > 0){
        String filetype = cellautoapp.getfiletype(filename);
        File f = new File(filename);
        if (f.exists() == false){
          if (filetype.equals("sqc")) {
            //savesqc(new BufferedWriter(new FileWriter(filename,true)));
            if (simple_file_type_option_dailogbox == null) {
              simple_file_type_option_dailogbox = new simple_file_type_option_dailogboxc("choose file type");
              simple_file_type_option_dailogbox.setBounds(0,0,400,200);
            }
            simple_file_type_option_dailogbox.show(filename);
            //simple_file_type_option_dailogbox = new simple_file_type_option_dailogboxc();
          } else if (filetype.equals("gz") & (enable_file_compression == true)) {
            savetext(new BufferedWriter(new OutputStreamWriter(new GZIPOutputStream(new FileOutputStream(filename,true)))));
          } else {
            savetext(new BufferedWriter(new FileWriter(filename,true)));
          }
        }else{
          JOptionPane.showMessageDialog(cellautoapp.cellautowindowframe,new JLabel("file already exists"),"error",JOptionPane.ERROR_MESSAGE);
        }
      }
    } catch (Exception err){
      System.out.println("menusave error");
      err.printStackTrace();
    }
    updatestatusbar();
    
  }
  
  
  static void saveboard(){
    saveboard(cellautoapp.SAVE_TO_UNDO_STACK);
  }
  
  //this function saves the board state to the undo stack or the redo stack
  static void saveboard(int t){
    boardstate b = new boardstate();
    
    b.board = new boardc(board);
    //b.board.usenonstillblocks(board2);
    b.board.usenonemptyblocks();
    boardstate.s = 0;
    b.filename = cellautoapp.cellauto131.filename;
    b.generation = generation;
    b.selx1 = selx1;
    b.sely1 = sely1;
    b.selx2 = selx2;
    b.sely2 = sely2;
    b.selx = selx;
    b.sely = sely;
    b.selw = selw;
    b.selh = selh;
    b.offsetx = offsetx;
    b.offsety = offsety;
    b.c = new cellautorulec(cellauto131);
    b.seldata = new int[selw][selh];
    for (int x = 0;x < selw;x++){
      for (int y = 0;y < selh;y++){
        b.seldata[x][y] = seldata[x][y];
      }
    }
    if (t == cellautoapp.SAVE_TO_UNDO_STACK){
      undodata.push(b);
    }
    if (t == cellautoapp.SAVE_TO_REDO_STACK){
      redodata.push(b);
    }
    
  }  
  static void restoreboard(){
    restoreboard(cellautoapp.RESTORE_FROM_UNDO_STACK);
  }
  
  //this function restores the board state from the undo stack or the redo stack
  static void restoreboard(int t){
    boardstate b = null;
    if (t == cellautoapp.RESTORE_FROM_UNDO_STACK){
      if (undodata.empty() == true){return;}
      saveboard(cellautoapp.SAVE_TO_REDO_STACK);
      b = (boardstate) undodata.pop();
    }
    if (t == cellautoapp.RESTORE_FROM_REDO_STACK){
      if (redodata.empty() == true){return;}
      saveboard(cellautoapp.SAVE_TO_UNDO_STACK);
      b = (boardstate) redodata.pop();
    }
    boardstate.s = 1;
    cellauto131 = b.c;
    board = b.board;
    board2 = new boardc(board);
    board2 = cellauto131.calcbgcolor(board,board2);
    board2.changecellstates(board.get_background_color(0,0),board2.get_background_color(0,0));
    generation = b.generation;
    selx1 = b.selx1;
    sely1 = b.sely1;
    selx2 = b.selx2;
    sely2 = b.sely2;
    selx = b.selx;
    sely = b.sely;
    selw = b.selw;
    selh = b.selh;
    if (save_board_offset_to_stack == true) {
      offsetx = b.offsetx;
      offsety = b.offsety;
    }
    cellautoapp.cellauto131.filename = b.filename;

    seldata = new int[selw][selh]; 
    for (int x = 0;x < b.selw;x++){
      for (int y = 0;y < b.selh;y++){
        seldata[x][y] = b.seldata[x][y];
      }
    }
    int selcolor = cellautoapp.colorbox.colorboxpanel.selcolor;
    int numcolors = cellautoapp.cellauto131.numcolors;
    if (selcolor >= numcolors) {
      selcolor = numcolors - 1;
      cellautoapp.colorlistindex = selcolor;
      if (cellautoapp.addeditstatedialog.isVisible() == true){
        cellautoapp.addeditstatedialog.selectstate(cellautoapp.colorlistindex);
      }
      cellautoapp.colorbox.colorboxpanel.selcolor = selcolor;
      cellautoapp.colorbox.colorboxpanel.repaint();
      cellautoapp.updatestatusbar();
    }
    cellautoapp.updatestatusbar();
  }  
  
  static void addrandombits() {
      for (int bit = randb;bit < (randb+randn);bit++) {
      //System.out.println("addrandombits " + bit);  
        for (int x = 0;x < board.width;x++) {
          for (int y = 0;y < board.height;y++) {
            int p = cellautoapp.rand.nextInt(2);
            int sq = board.getsq(x,y);
            if (p == 1) {
              sq = sq | (1 << bit);
            } else {
              sq = sq & ~(1 << bit);
            }
            board.setsq(x,y,sq);
          }
        }
      }
  }
  //this function calculates the board's next state
  public static void calc(int n,boolean repaint){
    cellautoapp.redodata.clear();
    if (boardstate.s == 1){
      cellautoapp.saveboard();
    }
    if (cellautoapp.dropselectionbeforerunning == true){
      cellautoapp.pasteseldata();
      cellautoapp.selx1 = 0;
      cellautoapp.sely1 = 0;
      cellautoapp.selx2 = 0;
      cellautoapp.sely2 = 0;
      cellautoapp.setupsel();
    }
    

    cellautoapp.cellauto131.numcellscalculate = 0;
    if (n > 1){
    try {
      if (cellautothreadc.running == false){
        cellautothreadc t = new cellautothreadc(n,cellautoapp.repaint_every_generation,1);
        t.start();
      }
    } catch (IllegalThreadStateException  e) {
      e.printStackTrace();
    }
    } else {
      if ((cellautoapp.calc_one_row == true) & (cellautoapp.board.height > 1)) {
        cellautoapp.board = cellautoapp.cellauto131.calc_one_row_func(cellautoapp.board);
      } else {
        boardc tmp = cellautoapp.board;
        cellautoapp.board = cellautoapp.cellauto131.calc3(cellautoapp.board,cellautoapp.board2);
        cellautoapp.board2 = tmp;
      }
      cellautoapp.generation = cellautoapp.generation + n;
      cellautoapp.updatestatusbar();
      if (repaint == true) {
        cellautoapp.cellautomainwindow.repaint();
      }
      if (cellautoapp.randn > 0){cellautoapp.addrandombits();}
      if (cellautoapp.cellauto131.lookuptableallused == false) {
        cellautoapp.edittablewindow.repaint();
      }
    }

  }
  //cut the selection to clipboard
  public static void cuttoclipboard(){
    if (selw > 0){
      if (selh > 0){
        String str = writeselectiontostring();
        TextTransfer.setClipboardContents(str);
        selx1 = 0;
        sely1 = 0;
        selx2 = 0;
        sely2 = 0;       
        setupsel();
      }
    }
    return;
    
    
  }
  
  public static void find_selection() {
        if (cellautoapp.selw > 0){
          if (cellautoapp.selh > 0){
            //find the selection
            int w2 = cellautoapp.cellautomainwindow.getWidth();
            int h2 = cellautoapp.cellautomainwindow.getHeight();
            cellautoapp.offsetx = cellautoapp.selx - (w2/(cellautomainwindowc.sqsize*2)) + (cellautoapp.selw / 2);
            cellautoapp.offsety = cellautoapp.sely - (h2/(cellautomainwindowc.sqsize*2)) + (cellautoapp.selh / 2);
            cellautoapp.cellautomainwindow.repaint();
          }
        }
  }

  public static void copy_ruletable_to_clipboard(){
    String str = write_ruletable_to_string();
    TextTransfer.setClipboardContents(str);
  }
  
  
  public static void paste_ruletable_from_clipboard(){
    String str = TextTransfer.getClipboardContents();
    read_ruletable_from_string(str);
  }  
  //copy the selection to clipboard
  public static void copytoclipboard(){
    if (selw > 0){
      if (selh > 0){
        String str = writeselectiontostring();
        TextTransfer.setClipboardContents(str);
      }
    }
    return;
  }
  
  
  //paste the selection from clipboard
  public static void pastefromclipboard(){
    String str = TextTransfer.getClipboardContents();
    readselectionfromstring(str);
    return;
  }
  
  //add random cells inside the selection
  public static void randomize_selection() {
    boolean horizontalsymmetry = cellautoapp.newgamedialog.horizontalsymmetrycheckBox.isSelected();
    boolean verticalsymmetry = cellautoapp.newgamedialog.verticalsymmetrycheckBox.isSelected();
    int numcolors = cellautoapp.seednumcolors;
    if (numcolors <= 1){numcolors = cellautoapp.cellauto131.numcolors;}
    if (numcolors > cellautoapp.cellauto131.numcolors){
      numcolors = cellautoapp.cellauto131.numcolors;
    }
    for (int x = 0;x < cellautoapp.selw;x++) {
      for (int y = 0;y < cellautoapp.selh;y++) {
        int a = cellautoapp.rand.nextInt(numcolors);
        cellautoapp.seldata[x][y] = a;
        if (horizontalsymmetry) {cellautoapp.seldata[(cellautoapp.selw-x-1)][y] = a;}
        if (verticalsymmetry) {cellautoapp.seldata[x][(cellautoapp.selh-y-1)] = a;}
        if (horizontalsymmetry) {
          if (verticalsymmetry) {
            cellautoapp.seldata[(cellautoapp.selw-x-1)][(cellautoapp.selh-y-1)] = a;
          }
        }
      }
    }
  }
  
  
  //move cells from the board to the selection
  public static void cutseldata(){
    if ((selw > 0) & (selh > 0)){
      seldata = new int[selw][selh];
      for (int x = 0;x < selw;x++){
        for (int y = 0;y < selh;y++){
          int i = cellautoapp.board.getsq(x+selx,y+sely);
          seldata[x][y] = i;
          cellautoapp.board.setsq(x+selx,y+sely,0);
          cellautoapp.board2.setsq(x+selx,y+sely,0);
        }
      }
    }else{
      seldata = null;
    }
  }
  
  //copy cells from the board to the selection
  public static void copyseldata(){
    if ((selw > 0) & (selh > 0)){
      seldata = new int[selw][selh];
      for (int x = 0;x < selw;x++){
        for (int y = 0;y < selh;y++){
          int i = cellautoapp.board.getsq(x+selx,y+sely);
          seldata[x][y] = i;
        }
      }
    }else{
      seldata = null;
    }
  }
  
  //move cells from the selection to the board
  public static void pasteseldata(){
    for (int x = 0;x < selw;x++){
      for (int y = 0;y < selh;y++){
        int i = seldata[x][y];
        if (transparentselection){
          if (i != cellautoapp.board.get_background_color(x+selx,y+sely)){
            cellautoapp.board.setsq(x+selx,y+sely,i);
            cellautoapp.board2.setsq(x+selx,y+sely,i);
          }
        }else{
          cellautoapp.board.setsq(x+selx,y+sely,i);
          cellautoapp.board2.setsq(x+selx,y+sely,i);
        }
      }
    }
    
  }
  
  public static void count_seldata_into_array(int c[]){
    for (int x = 0;x < selw;x++){
      for (int y = 0;y < selh;y++){
        int n = seldata[x][y];
        c[n] = c[n] + 1;
      }
    }
  }
  
  //setup the selection
  public static void setupsel(){
    if (cellautoapp.selx1 < cellautoapp.selx2){
      selx = cellautoapp.selx1;
      selw = cellautoapp.selx2-cellautoapp.selx1;
    }else{
      selx = cellautoapp.selx2;
      selw = cellautoapp.selx1-cellautoapp.selx2;
    }
    if (cellautoapp.sely1 < cellautoapp.sely2){
      sely = cellautoapp.sely1;
      selh = cellautoapp.sely2-cellautoapp.sely1;
    }else{
      sely = cellautoapp.sely2;
      selh = cellautoapp.sely1-cellautoapp.sely2;
    }
    
  }
  
  public static String getkey(String name){
    keywordfound = true;
    return name.toUpperCase();
  }
  public static char getkey2(String name){
    keywordfound = true;
    if (name.equals("space")){return ' ';}
    if (name.equals("comma")){return ',';}
    if (name.equals("dot")){return '.';}
    if (name.equals("period")){return '.';}
    if (name.equals("nokey")){return 0;}

    return Character.toLowerCase(name.charAt(0));
  }
  
  //read the options from a file
  public static void readoptionsfromfile(String filename){
    File f = new File(filename);
    String line = null;
    int linenum = 1;
    String errorstr = null;
    boolean iserror = false;
    boolean duplicate_keyword = false;
    if (f.exists()){
      System.out.println("reading " + filename);
      try{
        HashMap hash = new HashMap();
        BufferedReader r2 = new BufferedReader(new FileReader(filename));
        line = r2.readLine();
        while (line != null){
          keywordfound = false;
          duplicate_keyword = false;
          String ss[] = line.split(",");
          for (int i = 0;i < ss.length;i++){
            ss[i] = ss[i].trim();
          }
          String st = ss[0];
          String ss2[] = st.split("#");
          st = ss2[0];
          st = st.toLowerCase();
          if (st.equals("")){
            keywordfound = true;
          }
          if (st.length() > 0){
            if (hash.containsKey(st)){
              Integer i = (Integer) hash.get(st);
              errorstr = "error at line " + linenum + ": " + st + " is already defined at line " + i.intValue();
              System.out.println(errorstr);
              iserror = true;
            }
            if (duplicate_keyword == false) {
              hash.put(st,new Integer(linenum));
            }
          }
          if (st.equals("load_plugin")) {
            errorstr = "the load_plugin option no longer works";
            iserror = true;
            keywordfound = true;
          }
          if (st.equals("save_board_offset_to_stack")) {
            int i = Integer.valueOf(ss[1]).intValue();
            if (i != 0){
              save_board_offset_to_stack = true;
            } else {
              save_board_offset_to_stack = false;
            }
            keywordfound = true;
            
          }
          if (st.equals("random_rule_table_clear")){
            int i = Integer.valueOf(ss[1]).intValue();
            if (i != 0){
              random_rule_table_clear = true;
            } else {
              random_rule_table_clear = false;
            }
            keywordfound = true;
          }
          if (st.equals("repaint_every_generation")) {
            int i = Integer.valueOf(ss[1]).intValue();
            if (i != 0) {
              repaint_every_generation = true;
            } else {
              repaint_every_generation = false;
            }
            keywordfound = true;
          }
          //if (st.equals("adjust_pattern_when_loading")) {
          //  int i = Integer.valueOf(ss[1]).intValue();
          //  if (i != 0){
          //    use_new_adjust_method = true;
          //  } else {
          //    use_new_adjust_method = false;
          //  }
          //}
          if (st.equals("random_rule_table_sparseness")) {
            random_rule_table_sparseness = Double.valueOf(ss[1]).doubleValue();
            keywordfound = true;
          }
          if (st.equals("selectiontextbackground")) {
            selectiontextbackground = Integer.valueOf(ss[1]).intValue();
            keywordfound = true;
          }
          if (st.equals("clear_selection_before_loading")){
            int i = Integer.valueOf(ss[1]).intValue();
            if (i != 0){
              clear_selection_before_loading = true;
            } else {
              clear_selection_before_loading = false;
            }            
            keywordfound = true;
          }
          if (st.equals("table_tool_show_a_generation_ahead")){
            int i = Integer.valueOf(ss[1]).intValue();
            if (i != 0){
              table_tool_show_a_generation_ahead = true;
            } else {
              table_tool_show_a_generation_ahead = false;
            }
            keywordfound = true;
          }
          if (st.equals("enable_file_compression")){
            int i = Integer.valueOf(ss[1]).intValue();
            if (i != 0){
              enable_file_compression = true;
            } else {
              enable_file_compression = false;
            }
            keywordfound = true;
          }
          if (st.equals("grid_highlighting_use_powers_of_4")){
            int i = Integer.valueOf(ss[1]).intValue();
            if (i != 0){
              grid_highlighting_use_powers_of_4 = true;
            } else{
              grid_highlighting_use_powers_of_4 = false;
            }
            keywordfound = true;
          }

          if (st.equals("save_and_clear_key_adds_random_cells")) {
            int i = Integer.valueOf(ss[1]).intValue();
            if (i != 0) {
              cellautoapp.save_and_clear_key_adds_random_cells = true;
            } else {
              cellautoapp.save_and_clear_key_adds_random_cells = false;
            }
            keywordfound = true;
          }
          if (st.equals("colorboxautoscroll")) {
            int i = Integer.valueOf(ss[1]).intValue();
            if (i != 0) {
              colorboxc.colorboxautoscroll = true;
            } else {
              colorboxc.colorboxautoscroll = false;
            }
            keywordfound = true;
          }
          if (st.equals("save_file_version")) {
            double version = Double.valueOf(ss[1]).doubleValue();
            if (savefileversion > version) {
              savefileversion = version;
              programversion3 = ss[1];
              JOptionPane.showMessageDialog(cellautoapp.cellautowindowframe,new JLabel(
                "the program will now save files as version " + version),"info",JOptionPane.INFORMATION_MESSAGE);
            }
            keywordfound = true;
          }
          if (st.equals("open_ctrl_key")) {
            cellautokeys.open_ctrl_key = getkey(ss[1]);
          }
          if (st.equals("save_ctrl_key")) {
            cellautokeys.save_ctrl_key = getkey(ss[1]);
          }
          if (st.equals("cut_ctrl_key")) {
            cellautokeys.cut_ctrl_key = getkey(ss[1]);
          }
          if (st.equals("copy_ctrl_key")) {
            cellautokeys.copy_ctrl_key = getkey(ss[1]);
          }
          if (st.equals("paste_ctrl_key")) {
            cellautokeys.paste_ctrl_key = getkey(ss[1]);
          }
          if (st.equals("flipx_ctrl_key")) {
            cellautokeys.flipx_ctrl_key = getkey(ss[1]);
          }
          if (st.equals("flipy_ctrl_key")) {
            cellautokeys.flipy_ctrl_key = getkey(ss[1]);
          }
          if (st.equals("rotatec_ctrl_key")) {
            cellautokeys.rotatec_ctrl_key = getkey(ss[1]);
          }
          if (st.equals("rotatecc_ctrl_key")) {
            cellautokeys.rotatecc_ctrl_key = getkey(ss[1]);
          }
          if (st.equals("options_ctrl_key")) {
            cellautokeys.options_ctrl_key = getkey(ss[1]);
          }
          if (st.equals("seletionoption_ctrl_key")) {
            cellautokeys.seletionoption_ctrl_key = getkey(ss[1]);
          }
          if (st.equals("random_table_ctrl_key")) {
            cellautokeys.random_table_ctrl_key = getkey(ss[1]);
          }
          if (st.equals("add_state_ctrl_key")) {
            cellautokeys.add_state_ctrl_key = getkey(ss[1]);
          }
          if (st.equals("edit_state_ctrl_key")) {
            cellautokeys.edit_state_ctrl_key = getkey(ss[1]);
          }
          if (st.equals("random_selection_ctrl_key")) {
            cellautokeys.random_selection_ctrl_key = getkey(ss[1]);
          }
          if (st.equals("table_tool_option_ctrl_key")) {
            cellautokeys.table_tool_option_ctrl_key = getkey(ss[1]);
          }
          if (st.equals("color_picker_tool_ctrl_key")) {
            cellautokeys.color_picker_tool_ctrl_key = getkey(ss[1]);
          }
          if (st.equals("rule_family_options_ctrl_key")) {
            cellautokeys.rule_family_options_ctrl_key = getkey(ss[1]);
          }
          if (st.equals("prev_tool_key")) {
            cellautokeys.prev_tool_key = getkey2(ss[1]);
          }
          if (st.equals("next_tool_key")) {
            cellautokeys.next_tool_key = getkey2(ss[1]);
          }
          if (st.equals("prev_color_key")) {
            cellautokeys.prev_color_key = getkey2(ss[1]);
          }
          if (st.equals("next_color_key")) {
            cellautokeys.next_color_key = getkey2(ss[1]);
          }
          if (st.equals("calc_key")) {
            cellautokeys.calc_key = getkey2(ss[1]);
          }
          if (st.equals("calc_key2")) {
            cellautokeys.calc_key2 = getkey2(ss[1]);
          }
          if (st.equals("find_selection_key")) { 
            cellautokeys.find_selection_key = getkey2(ss[1]);
          }
          if (st.equals("pencil_tool_key")) {
            cellautokeys.pencil_tool_key = getkey2(ss[1]);
          }
          if (st.equals("select_tool_key")) {
            cellautokeys.select_tool_key = getkey2(ss[1]);
          }
          if (st.equals("move_tool_key")) {
            cellautokeys.move_tool_key = getkey2(ss[1]);
          }
          if (st.equals("zoom_in_tool_key")) {
            cellautokeys.zoom_in_tool_key = getkey2(ss[1]);
          }
          if (st.equals("zoom_out_tool_key")) {
            cellautokeys.zoom_out_tool_key = getkey2(ss[1]);
          }
          if (st.equals("pan_mode_key")) {
            cellautokeys.pan_mode_key = getkey2(ss[1]);
          }
          if (st.equals("xor_mode_key")) {
            cellautokeys.xor_mode_key = getkey2(ss[1]);
          }
          if (st.equals("redo_key")) {
            cellautokeys.redo_key = getkey2(ss[1]);
          }
          if (st.equals("undo_key")) {
            cellautokeys.undo_key = getkey2(ss[1]);
          }
          if (st.equals("save_to_stack_key")) {
            cellautokeys.save_to_stack_key = getkey2(ss[1]);
          }
          if (st.equals("save_and_clear_key")) {
            cellautokeys.save_and_clear_key = getkey2(ss[1]);
          }

          
          if (st.equals("gridcolor") | st.equals("gridcolor2") | st.equals("gridcolor3")
            | st.equals("gridcolor4") | st.equals("gridcolor5") | st.equals("table_gridcolor1") 
            | st.equals("table_gridcolor2") | st.equals("table_gridcolor3")){
            int r = Integer.valueOf(ss[1]).intValue();
            int g = Integer.valueOf(ss[2]).intValue();
            int b = Integer.valueOf(ss[3]).intValue();
            Color c = new Color(r,g,b);
            if (st.equals("table_gridcolor1")){
              edittablepanelc.gridcolor1 = c;
            }
            if (st.equals("table_gridcolor2")){
              edittablepanelc.gridcolor2 = c;
            }
            if (st.equals("table_gridcolor3")){
              edittablepanelc.gridcolor3 = c;
            }
            if (st.equals("gridcolor")){
              cellautomainwindowc.gridcolor = c;
            }
            if (st.equals("gridcolor2")){
              cellautomainwindowc.gridcolor2 = c;
            }
            if (st.equals("gridcolor3")){
              cellautomainwindowc.gridcolor3 = c;
            }
            if (st.equals("gridcolor4")){
              cellautomainwindowc.gridcolor4 = c;
            }
            if (st.equals("gridcolor5")){
              cellautomainwindowc.gridcolor5 = c;
            }
            keywordfound = true;
          }

          if (st.equals("showtoolbox")){
            int x = Integer.valueOf(ss[1]).intValue();
            int y = Integer.valueOf(ss[2]).intValue();
            int w = Integer.valueOf(ss[3]).intValue();
            int h = Integer.valueOf(ss[4]).intValue();
            cellautoapp.toolboxrectangle = new Rectangle(x,y,w,h);
            keywordfound = true;
          }
          if (st.equals("showcolorbox")){
            int x = Integer.valueOf(ss[1]).intValue();
            int y = Integer.valueOf(ss[2]).intValue();
            int w = Integer.valueOf(ss[3]).intValue();
            int h = Integer.valueOf(ss[4]).intValue();
            cellautoapp.colorboxrectangle = new Rectangle(x,y,w,h);
            keywordfound = true;
            
          }
          if (st.equals("showmainwindow")){
            int x = Integer.valueOf(ss[1]).intValue();
            int y = Integer.valueOf(ss[2]).intValue();
            int w = Integer.valueOf(ss[3]).intValue();
            int h = Integer.valueOf(ss[4]).intValue();
            cellautoapp.mainwindowrectangle = new Rectangle(x,y,w,h);
            keywordfound = true;
          }
          if (st.equals("showruletablewindow")){
            int x = Integer.valueOf(ss[1]).intValue();
            int y = Integer.valueOf(ss[2]).intValue();
            int w = Integer.valueOf(ss[3]).intValue();
            int h = Integer.valueOf(ss[4]).intValue();
            cellautoapp.ruletablewindowrectangle = new Rectangle(x,y,w,h);
            keywordfound = true;
            
          }
          if (st.equals("sqsize")){
            cellautomainwindowc.sqsize = Integer.valueOf(ss[1]).intValue();
            keywordfound = true;
          }
          if (st.equals("numcolorsperrow")){
            colorboxpanelc.numcolorsperrow = Integer.valueOf(ss[1]).intValue();
            keywordfound = true;
          }
          if (st.equals("colorboxsqsize")){
            colorboxpanelc.sqsize = Integer.valueOf(ss[1]).intValue();
            keywordfound = true;
          }
          if (st.equals("gridminsqsize")){
            cellautoapp.gridminsize = Integer.valueOf(ss[1]).intValue();
            keywordfound = true;
          }
          if (st.equals("edittablesqsize")){
            edittablepanelc.sqsize = Integer.valueOf(ss[1]).intValue();
            keywordfound = true;
          }
          if (st.equals("timestep")){
            timestep = Integer.valueOf(ss[1]).intValue();
            keywordfound = true;
          }
          if (st.equals("timestep2")){
            timestep2 = Integer.valueOf(ss[1]).intValue();
            keywordfound = true;
          }
          if (st.equals("movestep")){
            movestep = Integer.valueOf(ss[1]).intValue();
            keywordfound = true;
          }
          if (st.equals("panmodeon")){
            panmode = true;
            keywordfound = true;
          }
          if (st.equals("autoadjustoffset_off")){
            cellautoapp.autoadjustoffset = false;
            keywordfound = true;
          }
          if (st.equals("autoadjustoffset_on")){
            cellautoapp.autoadjustoffset = true;
            keywordfound = true;
          }
          if (st.equals("panmodeoff")){
            panmode = false;
            keywordfound = true;
          }
          if (st.equals("gridon")){
            gridon = true;
            keywordfound = true;
          }
          if (st.equals("gridoff")){
            gridon = false;
            keywordfound = true;
          }
          if (st.equals("defaultfilenametoload")){
            filename = ss[1];
            keywordfound = true;
          }
          if (keywordfound == false){
            errorstr = "error at line " + linenum + ": keyword " + st + " does not exist ";
            System.out.println(errorstr);
            iserror = true;
          }
          line = r2.readLine();
          linenum = linenum + 1;
        }
        r2.close();
      } catch (IOException e){
        e.printStackTrace();
      } catch (NumberFormatException e) {
        errorstr = "error at line " + linenum + ": can not read number";
        System.out.println("error: can not read number, line number is " + linenum + " line is ");
        System.out.println(line);
        iserror = true;
      }
      if (iserror == true){
        JOptionPane.showMessageDialog(cellautoapp.cellautowindowframe,new JLabel(errorstr),"error",JOptionPane.ERROR_MESSAGE);  
      }
    }
  }
  
  public static void plugin_init() {
    //future plugins go here
    SaveImage_plugin.init();
  }
  static JToolBar create_cellauto_toolbar() {
    cellauto_toolbar = new JToolBar();
    run_img = cellautoapp.createImageIcon2("toolbar/run.png");
    stop_img = cellautoapp.createImageIcon2("toolbar/stop.png");
    
    cellauto_toolbar.add(new ToolBar_Action("new",cellautoapp.createImageIcon2("toolbar/new.png"),"new pattern"));
    cellauto_toolbar.add(new ToolBar_Action("open",cellautoapp.createImageIcon2("toolbar/open.png"),"open pattern"));
    cellauto_toolbar.add(new ToolBar_Action("save",cellautoapp.createImageIcon2("toolbar/save.png"),"save pattern"));
    cellauto_toolbar.add(new ToolBar_Action("pencil",cellautoapp.createImageIcon2("toolbar/pencil_small.png"),"select pencil tool"));
    cellauto_toolbar.add(new ToolBar_Action("selection",cellautoapp.createImageIcon2("toolbar/select_small.png"),"select selection tool"));
    run_action = new ToolBar_Action("run",run_img,"run");
    cellauto_toolbar.add(run_action);
    cellauto_toolbar.add(new ToolBar_Action("step",cellautoapp.createImageIcon2("toolbar/step.png"),"step"));
    cellauto_toolbar.add(new ToolBar_Action("undo",cellautoapp.createImageIcon2("toolbar/undo.png"),"undo to last generation saved"));
    cellauto_toolbar.add(new ToolBar_Action("redo",cellautoapp.createImageIcon2("toolbar/redo.png"),"redo to the current generation"));
    cellauto_toolbar.add(new ToolBar_Action("addundo",cellautoapp.createImageIcon2("toolbar/addundo.png"),"save generation to the undo stack"));

    cellauto_toolbar.add(new ToolBar_Action("select_all",cellautoapp.createImageIcon2("toolbar/select_all.png"),"select all"));
    cellauto_toolbar.add(new ToolBar_Action("select_center",cellautoapp.createImageIcon2("toolbar/select_center.png"),"center selection"));
    cellauto_toolbar.add(new ToolBar_Action("select_rand",cellautoapp.createImageIcon2("toolbar/select_rand.png"),"randomize selection"));
    cellauto_toolbar.add(new ToolBar_Action("select_fill",cellautoapp.createImageIcon2("toolbar/select_fill.png"),"fill selection with a color"));

    cellauto_toolbar.add(new ToolBar_Action("zoomin",cellautoapp.createImageIcon2("toolbar/zoomin_small.png"),"zoom in"));
    cellauto_toolbar.add(new ToolBar_Action("zoomout",cellautoapp.createImageIcon2("toolbar/zoomout_small.png"),"zoom out"));

    
    cellauto_toolbar.add(new ToolBar_Action("flipy",cellautoapp.createImageIcon2("toolbar/FlipX.png"),"flip vertical"));
    cellauto_toolbar.add(new ToolBar_Action("flipx",cellautoapp.createImageIcon2("toolbar/FlipY.png"),"flip horizontal"));
    cellauto_toolbar.add(new ToolBar_Action("rotatecc",cellautoapp.createImageIcon2("toolbar/Rotate270.png"),"rotate clockwise"));
    cellauto_toolbar.add(new ToolBar_Action("rotatec",cellautoapp.createImageIcon2("toolbar/Rotate90.png"),"rotate counterclockwise"));
    cellauto_toolbar.add(new ToolBar_Action("clear_selection",cellautoapp.createImageIcon2("toolbar/clear_selection.png"),"clear selection"));
    cellauto_toolbar.add(new ToolBar_Action("clear_outside_selection",cellautoapp.createImageIcon2("toolbar/clear_outside_selection.png"),"clear outside selection"));
    
    return cellauto_toolbar;
  }
  public static void main(String[] args){

    TextTransfer = new TextTransferc();
    undodata = new Stack();
    redodata = new Stack();
    cellauto131 = new cellautorulec();
    rand = new Random();
    //command line options
    try {
      savefileversion = Double.valueOf(programversion2).doubleValue();
    } catch (Exception e){
      e.printStackTrace();
    }
    readoptionsfromfile("options.txt");
    int i = 0;
    while (i < args.length){
      if (args[i].equals("-filename")){
          i++;
          if (i < args.length) {filename = args[i];}
      }
      if (args[i].charAt(0) != '-'){
          filename = args[i];
      }
      if (args[i].equals("-selectionsavexy")){
        selectionsavexy = true;
        System.out.println("saving the x and y offsets of any selection");
      }
      
      if (args[i].equals("-o") | args[i].equals("-options")){
        i++;
        if (i < args.length) {
          readoptionsfromfile(args[i]);
        }
      }
      if (args[i].equals("-v") | args[i].equals("-verbose")){
        cellautoapp.verbose = true;
      }
      if (args[i].equals("-sqsize")){
        i++;
        if (i < args.length) {
          cellautomainwindowc.sqsize = Integer.valueOf(args[i]).intValue();
        }
      }
      if (args[i].equals("-colorboxsqsize")){
        i++;
        if (i < args.length) {
          colorboxpanelc.sqsize = Integer.valueOf(args[i]).intValue();
        }
      }
      if (args[i].equals("-edittablesqsize")){
        i++;
        if (i < args.length) {
          edittablepanelc.sqsize = Integer.valueOf(args[i]).intValue();
        }
      }
      if (args[i].equals("-timestep")){
        i++;
        if (i < args.length) {
          timestep = Integer.valueOf(args[i]).intValue();
        }
      }
      if (args[i].equals("-timestep2")){
        i++;
        if (i < args.length) {
          timestep2 = Integer.valueOf(args[i]).intValue();
        }
      }
      if (args[i].equals("-movestep")){
        i++;
        if (i < args.length) {
          movestep = Integer.valueOf(args[i]).intValue();
        }
      }
      if (args[i].equals("-panmodeon")){
        panmode = true;
      }      
      if (args[i].equals("-panmodeoff")){
        panmode = false;
      }
      if (args[i].equals("-gridon")){
        gridon = true;
      }
      if (args[i].equals("-gridoff")){
        gridon = false;
      }
      if (args[i].equals("-transparentselection")){
        transparentselection = true;
      }
      if (args[i].equals("-transparentselectionon")){
        transparentselection = true;
      }
      if (args[i].equals("-transparentselectionoff")){
        transparentselection = false;
      }
      if (args[i].equals("-bgcolor")){
        i++;
        if (i < args.length) {
          board.dfcolor = Integer.valueOf(args[i]).intValue();
          board.background_tile_sub_board.setsq(0,0,board.dfcolor);
        }
      }
      if (args[i].equals("-fgcolor")){
        i++;
        if (i < args.length) {
          colorboxpanelc.selcolor = Integer.valueOf(args[i]).intValue();
        }
      }
      i++;
    }
    
    if (board == null){ 
      board = new boardc(1024,1024);
    }
    board2 = new boardc(board);
    
    javax.swing.SwingUtilities.invokeLater(new Runnable() {
        
        public void run() {
          //cellautothread = new cellautothreadc();
          actlis = new actlisc();
          //setup the menu
          JMenuBar mb = new JMenuBar();
          //setup the file menu
          filemenu = new JMenu("file");
          mb.add(filemenu);
          
          JMenuItem minew = new JMenuItem("new");
          filemenu.add(minew);
          minew.setActionCommand("menunew");    
          minew.addActionListener(cellautoapp.actlis);
          
          
          JMenuItem miopen = new JMenuItem("open ctrl-" + cellautokeys.open_ctrl_key.toLowerCase());
          filemenu.add(miopen);
          miopen.setActionCommand("menuopen");
          miopen.addActionListener(cellautoapp.actlis);
          
          JMenuItem misave = new JMenuItem("save ctrl-" + cellautokeys.save_ctrl_key.toLowerCase());
          filemenu.add(misave);
          misave.setActionCommand("menusave");
          misave.addActionListener(cellautoapp.actlis);
          
          JMenuItem mioptions = new JMenuItem("options ctrl-" + cellautokeys.options_ctrl_key.toLowerCase());
          filemenu.add(mioptions);
          mioptions.setActionCommand("menuoptions");
          mioptions.addActionListener(cellautoapp.actlis);
          
          JMenuItem midescription = new JMenuItem("view description");
          filemenu.add(midescription);
          midescription.setActionCommand("menudescription");
          midescription.addActionListener(cellautoapp.actlis);
          
          JMenuItem miexit = new JMenuItem("exit");
          filemenu.add(miexit);
          miexit.setActionCommand("menuexit");
          miexit.addActionListener(cellautoapp.actlis);
          
          //setup the edit menu
          editmenu = new JMenu("edit");
          mb.add(editmenu);
          JMenuItem micut = new JMenuItem("cut ctrl-" + cellautokeys.cut_ctrl_key.toLowerCase());
          editmenu.add(micut);
          micut.setActionCommand("menucut");
          micut.addActionListener(cellautoapp.actlis);
          JMenuItem micopy = new JMenuItem("copy ctrl-" + cellautokeys.copy_ctrl_key.toLowerCase());
          editmenu.add(micopy);
          micopy.setActionCommand("menucopy");
          micopy.addActionListener(cellautoapp.actlis);
          JMenuItem mipaste = new JMenuItem("paste ctrl-" + cellautokeys.paste_ctrl_key.toLowerCase());
          editmenu.add(mipaste);
          mipaste.setActionCommand("menupaste");
          mipaste.addActionListener(cellautoapp.actlis);
          
          JMenuItem mirandom = new JMenuItem("random ctrl-" + cellautokeys.random_selection_ctrl_key.toLowerCase());
          editmenu.add(mirandom);
          mirandom.setActionCommand("menurandom");
          mirandom.addActionListener(cellautoapp.actlis);
          
          JMenuItem miflipx = new JMenuItem("flip horizontal ctrl-" + cellautokeys.flipx_ctrl_key.toLowerCase());
          editmenu.add(miflipx);
          miflipx.setActionCommand("menuflipx");
          miflipx.addActionListener(cellautoapp.actlis);
          
          JMenuItem miflipy = new JMenuItem("flip vertical ctrl-" + cellautokeys.flipy_ctrl_key.toLowerCase());
          editmenu.add(miflipy);
          miflipy.setActionCommand("menuflipy");
          miflipy.addActionListener(cellautoapp.actlis);
          
          JMenuItem mirotatec = new JMenuItem("rotate clockwise ctrl-" + cellautokeys.rotatec_ctrl_key.toLowerCase());
          editmenu.add(mirotatec);
          mirotatec.setActionCommand("menurotatec");
          mirotatec.addActionListener(cellautoapp.actlis);
          
          JMenuItem mirotatecc = new JMenuItem("rotate counterclockwise ctrl-" + cellautokeys.rotatecc_ctrl_key.toLowerCase());
          editmenu.add(mirotatecc);
          mirotatecc.setActionCommand("menurotatecc");
          mirotatecc.addActionListener(cellautoapp.actlis);
          
          JMenuItem mifillwithcolor = new JMenuItem("fill with the selected color");
          editmenu.add(mifillwithcolor);
          mifillwithcolor.setActionCommand("menufillwithcolor");
          mifillwithcolor.addActionListener(cellautoapp.actlis);

          JMenuItem miclearinsideselection = new JMenuItem("clear selection");
          editmenu.add(miclearinsideselection);
          miclearinsideselection.setActionCommand("menuclearinsideselection");
          miclearinsideselection.addActionListener(cellautoapp.actlis);

          JMenuItem miclearoutsideselection = new JMenuItem("clear outside selection");
          editmenu.add(miclearoutsideselection);
          miclearoutsideselection.setActionCommand("menuclearoutsideselection");
          miclearoutsideselection.addActionListener(cellautoapp.actlis);

          JMenuItem mirulefamilyoptions = new JMenuItem("rule family options ctrl-" + cellautokeys.rule_family_options_ctrl_key.toLowerCase());
          editmenu.add(mirulefamilyoptions);
          mirulefamilyoptions.setActionCommand("menurulefamilyoptions");
          mirulefamilyoptions.addActionListener(cellautoapp.actlis);
          
          
          
          JMenuItem miaddstate = new JMenuItem("add state ctrl-" + cellautokeys.add_state_ctrl_key.toLowerCase());
          editmenu.add(miaddstate);
          miaddstate.setActionCommand("menuaddstate");
          miaddstate.addActionListener(cellautoapp.actlis);

          JMenuItem miaddstates = new JMenuItem("add a bunch of states");
          editmenu.add(miaddstates);
          miaddstates.setActionCommand("menuaddstates");
          miaddstates.addActionListener(cellautoapp.actlis);

          
          JMenuItem mieditstate = new JMenuItem("edit state ctrl-" + cellautokeys.edit_state_ctrl_key.toLowerCase());
          editmenu.add(mieditstate);
          mieditstate.setActionCommand("menueditstate");
          mieditstate.addActionListener(cellautoapp.actlis);
          
          JMenuItem mitableoffset = new JMenuItem("edit the table offset");
          editmenu.add(mitableoffset);
          mitableoffset.setActionCommand("menutableoffset");
          mitableoffset.addActionListener(cellautoapp.actlis);
          
          
          tablemenu = new JMenu("table");
          mb.add(tablemenu);

          JMenuItem micleartable = new JMenuItem("clear used table");
          tablemenu.add(micleartable);
          micleartable.setActionCommand("menucleartable");
          micleartable.addActionListener(cellautoapp.actlis);
          
          JMenuItem mifilltable = new JMenuItem("fill used table");
          tablemenu.add(mifilltable);
          mifilltable.setActionCommand("menufilltable");
          mifilltable.addActionListener(cellautoapp.actlis);
          
          JMenuItem mirandtable = new JMenuItem("randomize rule table ctrl-" + cellautokeys.random_table_ctrl_key.toLowerCase());
          tablemenu.add(mirandtable);
          mirandtable.setActionCommand("menurandtable");
          mirandtable.addActionListener(cellautoapp.actlis);

          JMenuItem miresizeruletable = new JMenuItem("resize rule table");
          tablemenu.add(miresizeruletable);
          miresizeruletable.setActionCommand("menuresizeruletable");
          miresizeruletable.addActionListener(cellautoapp.actlis);
          
          JMenuItem micopyruletable = new JMenuItem("copy rule table");
          tablemenu.add(micopyruletable);
          micopyruletable.setActionCommand("menucopyruletable");
          micopyruletable.addActionListener(cellautoapp.actlis);

          JMenuItem mipasteruletable = new JMenuItem("paste rule table");
          tablemenu.add(mipasteruletable);
          mipasteruletable.setActionCommand("menupasteruletable");
          mipasteruletable.addActionListener(cellautoapp.actlis);


          JMenuItem mi_make_ruletable_wider = new JMenuItem("make rule table wider");
          tablemenu.add(mi_make_ruletable_wider);
          mi_make_ruletable_wider.setActionCommand("menu_make_rule_table_wider");
          mi_make_ruletable_wider.addActionListener(cellautoapp.actlis);
          
          
          //setup the view menu
          viewmenu = new JMenu("view");
          
          JMenuItem miedittable = new JMenuItem("show rule table");
          viewmenu.add(miedittable);
          miedittable.setActionCommand("menushowedittablewindow");
          miedittable.addActionListener(cellautoapp.actlis);
          //mb.add(viewmenu);
          
          JMenuItem micolorbox = new JMenuItem("show color box");
          viewmenu.add(micolorbox);
          micolorbox.setActionCommand("menushowcolorbox");
          micolorbox.addActionListener(cellautoapp.actlis);
          //mb.add(viewmenu);
          
          JMenuItem mitoolbox = new JMenuItem("show tool box");
          viewmenu.add(mitoolbox);
          mitoolbox.setActionCommand("menushowtoolbox");
          mitoolbox.addActionListener(cellautoapp.actlis);
          //mb.add(viewmenu);

          JMenuItem mifilebrowser = new JMenuItem("show file browser");
          viewmenu.add(mifilebrowser);
          mifilebrowser.setActionCommand("menushowfilebrowser");
          mifilebrowser.addActionListener(cellautoapp.actlis);

          JMenuItem mikeylist = new JMenuItem("show the keys");
          viewmenu.add(mikeylist);
          mikeylist.setActionCommand("menushowkeylist");
          mikeylist.addActionListener(cellautoapp.actlis);
          
          JMenuItem miinfowindow = new JMenuItem("show info window");
          viewmenu.add(miinfowindow);
          miinfowindow.setActionCommand("menushowinfowindow");
          miinfowindow.addActionListener(cellautoapp.actlis);
          
          JMenuItem mistatistics = new JMenuItem("show statistics");
          viewmenu.add(mistatistics);
          mistatistics.setActionCommand("statistics_window_show");
          mistatistics.addActionListener(cellautoapp.actlis);

          
          
          
          JMenuItem mi_table_grid_spacing = new JMenuItem("edit rule table grid spacing");
          viewmenu.add(mi_table_grid_spacing);
          mi_table_grid_spacing.setActionCommand("menu_edit_table_grid_spacing");
          mi_table_grid_spacing.addActionListener(cellautoapp.actlis);

            
          JMenuItem mineighborhoodvalues = new JMenuItem("edit neighborhood values");
          viewmenu.add(mineighborhoodvalues);
          mineighborhoodvalues.setActionCommand("menuneighborhoodvalues");
          mineighborhoodvalues.addActionListener(cellautoapp.actlis);
          

          JMenuItem mienterneighborhoodsize = new JMenuItem("enter neighborhood size");
          viewmenu.add(mienterneighborhoodsize);
          mienterneighborhoodsize.setActionCommand("menuenterneighborhoodsize");
          mienterneighborhoodsize.addActionListener(cellautoapp.actlis);
          
          
          
          JMenuItem mirulefamilybrowser = new JMenuItem("show rule family browser");
          viewmenu.add(mirulefamilybrowser);
          mirulefamilybrowser.setActionCommand("menushowrulefamilybrowser");
          mirulefamilybrowser.addActionListener(cellautoapp.actlis);
          
          JMenuItem miperiodchecker = new JMenuItem("show period checker");
          viewmenu.add(miperiodchecker);
          miperiodchecker.setActionCommand("menushowperiodchecker");
          miperiodchecker.addActionListener(cellautoapp.actlis);
          
          JMenuItem mitrydiffpositions = new JMenuItem("try different positions");
          viewmenu.add(mitrydiffpositions);
          mitrydiffpositions.setActionCommand("menutrydiffpositions");
          mitrydiffpositions.addActionListener(cellautoapp.actlis);
          //mb.add(viewmenu);

          JMenuItem migenes = new JMenuItem("genes");
          viewmenu.add(migenes);
          migenes.setActionCommand("menugenes");
          migenes.addActionListener(cellautoapp.actlis);
          mb.add(viewmenu);
          
          mainmenu = mb;
          
          
          
          keylis = new keylisc();
          mouselis = new mouselisc();
          mousemotionlis = new mousemotionlisc();
          newgamedialog = new newgamedialogc("new universe");
          cellautowindowframe = new JFrame(cellautoapp.programname + " " +  cellautoapp.programversion);
          cellautomainwindow = new cellautomainwindowc();
          cellautomainpanel = new JPanel();

          cellautowindowframe.addWindowListener(cellautomainwindow.winlis);
          //genewindow = new genewindowc("genes");
          
          cellautoapp.menubarheight = mb.getHeight();
          cellautowindowframe.setJMenuBar(mb);
          cellautowindowframe.repaint();
          SpringLayout spl = new SpringLayout();
          cellautomainpanel.setLayout(spl);
          spl.putConstraint(SpringLayout.EAST,cellautomainwindow,0,SpringLayout.EAST,cellautomainpanel);
          spl.putConstraint(SpringLayout.WEST,cellautomainwindow,0,SpringLayout.WEST,cellautomainpanel);
          
          cellautostatusbar = new JLabel("status bar"); 
          spl.putConstraint(SpringLayout.SOUTH,cellautostatusbar,0,SpringLayout.SOUTH,cellautomainpanel);
          spl.putConstraint(SpringLayout.SOUTH,cellautomainwindow,0,SpringLayout.NORTH,cellautostatusbar);
          spl.putConstraint(SpringLayout.NORTH,cellautomainwindow,0,SpringLayout.NORTH,cellautomainpanel);
          cellautowindowframe.getContentPane().add(cellautomainpanel,BorderLayout.CENTER);
          
          cellautomainpanel.add(cellautostatusbar);
          cellautomainpanel.add(cellautomainwindow);
          JToolBar bar = create_cellauto_toolbar();
          //bar.add(new JButton("test"));
          //cellautomainpanel.add(cellautomainwindow,BorderLayout.CENTER);
 
          //cellautomainwindow.add(bar,BorderLayout.NORTH);
          cellautowindowframe.getContentPane().add(bar,BorderLayout.NORTH);
          cellautowindowframe.pack();
          cellautomainwindow.setBounds(0,0,400,400);
         updatestatusbar();
          cellautowindowframe.setVisible(true);
          cellautowindowframe.setFocusable(true);
          cellautowindowframe.addKeyListener(keylis);
          cellautomainwindow.setFocusable(true);
          
          
          cellautomainwindow.addMouseListener(mouselis);
          cellautomainwindow.addMouseMotionListener(mousemotionlis);
          addeditstatedialog = new addeditstatedialogc("edit state");
          addeditstatedialog.setBounds(0,0,180,100);
          colorbox = new colorboxc("color box");	
          //colorbox.setVisible(true);
          toolbox = new toolboxc("tool box");
          //toolbox.setVisible(true);
          periodcheckerdialog = new periodcheckerdialogc("period checker");
          periodcheckerdialog.setBounds(0,0,400,250);
          //trydiffpositionswindow = new trydiffpositionswindowc("try diff positions for the selection");
          optionsdialog = new optionsdialogc("options");
          editdescriptionwindow = new editdescriptionwindowc("description");
          editdescriptionwindow.setBounds(0,0,300,200);
          edittablewindow = new edittablewindowc("rule table window");
          cellautowindowframe.setBounds(0,0,624,435);
          colorbox.setBounds(0,0,(colorboxpanelc.sqsize*16)+30,(colorboxpanelc.sqsize*2)+40);
          //colorbox.setBounds(0,335,540,120-5);
          //toolbox.setBounds(540,335,240,120-5);
          edittablewindow.setBounds(324,0,300,100);
          if (mainwindowrectangle != null){
            cellautowindowframe.setBounds(mainwindowrectangle);
          }
          if (ruletablewindowrectangle != null){
            edittablewindow.setBounds(ruletablewindowrectangle);
            edittablewindow.setVisible(true);
          }
          if (colorboxrectangle != null){
            colorbox.setBounds(colorboxrectangle);
            colorbox.setVisible(true);
          }
          if (toolboxrectangle != null){
            toolbox.setBounds(toolboxrectangle);
            toolbox.setVisible(true);
          }
          cellautoapp.optionsdialog.getoptions();
          cellautowindowframe.setVisible(true);
          //filebrowser = new filebrowserc();
          //filebrowser.setBounds(0,0,200,400);
          rulefamilybrowser = new rulefamilybrowserc("rule families");
          rulefamilybrowser.setBounds(0,0,200,400);
          keylistdescriptionwindow = new keylistdescriptionwindowc("the keys ");
          keylistdescriptionwindow.setBounds(0,0,500,400);
          plugin_init();
          if (filename != null){
            cellautoapp.open(filename);
          }

        }
    });
    
  }
  
  
  static void logruletable(String name){
    cellautorulec c = cellauto131;
    try{
      PrintWriter p = new PrintWriter(new BufferedWriter(new FileWriter(name,true)));
      //write the rule table
      int tableoffset = c.readtableoffset();
      p.println("tableoffset,"+tableoffset);
      p.println("cleartable,"+c.tablewidth+","+c.tableheight);
      
      for (int y = 0;y < c.tableheight;y++){
        p.print("table");
        for (int x = 0;x < c.tablewidth;x++){
          int i = c.getlookuptable(x,y);
          p.print(","+i);
        }
        p.println();
      }
      p.close();
    } catch (Exception e){
      e.printStackTrace();
    }
  }  

  static void setEnabled_toolbar_buttons(boolean b) {
      for (int i = 0;i < ToolBar_Action.toolbar_list.size();i++) {
	ToolBar_Action a = (ToolBar_Action) ToolBar_Action.toolbar_list.get(i);
	String name = a.get_name();
	if (name.equals("run") == true) {continue;}
	if (name.equals("stop") == true) {continue;}
	if (name.equals("open") == true) {continue;}
	if (name.equals("save") == true) {continue;}
	if (name.equals("undo") == true) {continue;}
	if (name.equals("zoomin") == true) {continue;}
	if (name.equals("zoomout") == true) {continue;}
        a.setEnabled(b);
      }
  }
  static void stop() {
      setEnabled_toolbar_buttons(true);
      run_action.putValue(Action.NAME, "run");
      run_action.set_name("run");
      run_action.putValue(Action.SMALL_ICON, cellautoapp.run_img);
      run_action.putValue(Action.SHORT_DESCRIPTION, "run");
      if (cellautothreadc.running == true){
        cellautothreadc.done = true;
      }
    
  }
  
  static void run() {
      setEnabled_toolbar_buttons(false);
      run_action.putValue(Action.NAME, "stop");
      run_action.set_name("stop");
      run_action.putValue(Action.SMALL_ICON, cellautoapp.stop_img);
      run_action.putValue(Action.SHORT_DESCRIPTION, "stop");
      cellautothreadc t = new cellautothreadc(2000000000,true,cellautoapp.simulator_delay);
      t.start();
  }
  
  
  
  static String getpath(String filename) {
    String path = "";
    String s = "";
    //int i2 = 0;
    for (int i = 0;i < filename.length();i++) {
      char ch = filename.charAt(i);
      s = s + ch;
      if (ch == File.separatorChar) {
        //i2 = i;
        path = s;
      }
    }
    return path;
  }
  static String getfiletype(String filename){
    String type = "";
    for (int i = filename.length()-1;i >= 0;i--){
      char ch = filename.charAt(i);
      if (ch == '.'){break;}                       
      if (ch == '\\'){break;}
      if (ch == '/'){break;}
      type = ch + type;
    }
    return type;
  }
  static void savetext(BufferedWriter w){
    cellautorulec c = cellauto131;
    boardc b = board;
    double version = 0;
    try{
      version = cellautoapp.savefileversion;
      PrintWriter p = new PrintWriter(w);
      p.println("programname," + programname);
      p.println("programversion," + programversion3);
      p.println("offset," + cellautoapp.offsetx + "," + cellautoapp.offsety);
      p.println("zoom," + cellautomainwindowc.sqsize);
      p.println("seed," + c.seed);
      p.println("seedinfo," + newgamedialog.seededit.getText() + "," + newgamedialog.rectwidthedit.getText() + "," + 
        newgamedialog.rectheightedit.getText() + "," + newgamedialog.rectoffsetxedit.getText() + "," + 
        newgamedialog.rectoffsetyedit.getText() + "," + offsetx + "," + offsety);
      p.println("selected_tool_name," + toolname[toollistindex]);
      p.println("generation," + generation);
      p.println("fgcolor," + colorboxpanelc.selcolor);
      p.println("symmetrybits," + cellautoapp.symmetrybits);
      if (cellautoapp.randn > 0) {
        p.println("jc_rand_4283," + cellautoapp.randb + "," + cellautoapp.randn);
      }
      if (calc_one_row == true) {
        p.println("calc_one_row,1");
      }
      if ((board.wrapx == true) & (board.wrapy == true)){p.println("board_wrap,1,1");}
      if ((board.wrapx == true) & (board.wrapy == false)){p.println("board_wrap,1,0");}
      if ((board.wrapx == false) & (board.wrapy == true)){p.println("board_wrap,0,1");}
      if ((board.wrapx == false) & (board.wrapy == false)){p.println("board_wrap,0,0");}
      
      if (c.description != null){
        String descline[] = c.description.split("\n");
        
        for (int i = 0;i < descline.length;i++){
          p.println("description," + descline[i]);
        }
      }
      p.println("table_grid_spacing," + edittablepanelc.grid_x_spacing + "," 
                                      + edittablepanelc.grid_y_spacing + ","
                                      + edittablepanelc.grid_x_spacing2 + ","
                                      + edittablepanelc.grid_y_spacing2);
      int bordersize = c.getbordersize();
      p.println("clearborder," + bordersize);
      for (int y = 0;y <= (bordersize*2);y++){
        p.print("border");
        for (int x = 0;x <= (bordersize*2);x++){
          int i = c.getbordervalue(y-bordersize,x-bordersize);
          p.print("," + i);
        }
        p.println();
      }
      
      //write the colors and their values
      int numcolors = c.getnumcolors();
      p.println("numcolors,"+numcolors);
      p.println("seednumcolors,"+seednumcolors);
      for (int i = 0;i < numcolors;i++){
        int i2 = c.getcellvalue(i);
        p.println("cellvalue,"+i+","+i2);
        Color c2 = c.getcellvaluecolor(i);
        p.println("cellvaluecolor,"+i+","+c2.getRed()+","+c2.getGreen()+","+c2.getBlue());
      }

      //write the rule family name
      if (c.rulefamily != null){
        p.print("rulefamily,"+c.rulefamily.getname());
        for (int i = 0;i < c.rulefamily.getnumargs();i++){
          p.print("," + c.rulefamily.getarg(i));
        }
        p.println();
        Vector tmpvec = new Vector();
        c.rulefamily.writelines(tmpvec);
        int s = tmpvec.size();
        if (s > 0){
          p.println("rulefamily_options_begin");
          for (int i = 0;i < s;i++){
            String s2 = (String) tmpvec.get(i);
            p.println(s2);
          }
          p.println("rulefamily_options_end");
        }
      }    
      for (int y = 0;y < b.background_tile_sub_board.get_height();y++) {
        p.print("bgcolor");
        for (int x = 0;x < b.background_tile_sub_board.get_width();x++) {
          int i = b.background_tile_sub_board.getsq(x,y);
          p.print("," + i);
        }
        p.println();
      }
      //write the rule table
      int tableoffset = c.readtableoffset();
      p.println("tableoffset,"+tableoffset);
      p.println("cleartable,"+c.tablewidth+","+c.tableheight);
      
      for (int y = 0;y < c.tableheight;y++){
        p.print("table");
        for (int x = 0;x < c.tablewidth;x++){
          int i = c.getlookuptable(x,y);
          p.print(","+i);
        }
        p.println();
      }
      if (c.lookuptableallused == false){
        for (int y = 0;y < c.tableheight;y++){
          p.print("tableused");
          for (int x = 0;x < c.tablewidth;x++){
            int i = c.getlookuptableused(x,y);
            p.print(","+i);
          }
          p.println();
        }
      }
      for (int y = 0;y < 2;y++){
        int a1 = c.readborderflip(0,y);
        int a2 = c.readborderflip(1,y);
        p.println("borderflip,"+a1+","+a2);
      }
      
      //write the board
      p.println("clearboard,"+b.width+","+b.height);
      for (int y = 0;y < b.height;y++){
        if (b.emptyline(y) == false){
          String rle = b.writerle(y);
          p.println("line,"+y+","+rle);
        }
      }
      
      //write the selection
      if (selw > 0){
        if (selh > 0){
          p.println("clearselection,"+selx+","+sely+","+selw+","+selh);
          for (int x = 0;x < selw;x++){  
            p.print("selection,");
            StringBuffer str = new StringBuffer();
            for (int y = 0;y < selh;y++){
              int a0 = seldata[x][y];
              char ch1 = (char) ((a0 >> 4) + 97);
              char ch2 = (char) ((a0 & 15) + 97);
              if ((a0 == 0) & (version > 1.045)){
                if (selectiontextbackground == 1){
                  ch1 = ' ';
                  ch2 = ' ';
                }
                if (selectiontextbackground == 2){
                  ch1 = '.';
                  ch2 = '.';
                }
              }
              str.append(ch1);
              str.append(ch2);
            }           
            p.println(str.toString());
          }
        }
      }
      p.close();
    } catch (Exception e){
      cellautoapp.cutseldata();
      e.printStackTrace();
    }
    
  }
  //update the status bar
  static void updatestatusbar(){
    int n = (undodata.size() + boardstate.s);
    int n2 = redodata.size();
    String str = "generation: " + generation + " undo: " + n;
    str = str + " redo: " + n2;
    str = str + " mode: ";
    if (panmode == true) {
      str = str + "p ";
    }
    if (dropselectionbeforerunning == true) {
      str = str + "d ";
    }
    if (table_tool_show_a_generation_ahead == true) {
      str = str + "t ";
    }
    if (xor_mode == true) {
      str = str + "x ";
    }
    //updatestatusbar
    str = str + " color: " + colorlistindex;
    str = str + " tool: " + toolname[toollistindex];
    str = str + " board size " + board.width + "x" + board.height;
    str = str + " pop count " + board.popcount;
    if (selw > 0){
      if (selh > 0){
        str = str + " selection: (" + selx + "," + sely + "," + selw + "," + selh + ")";
      }
    }
    if (cellautoapp.cellauto131.filename != null){
      str = str + " filename: " + cellautoapp.cellauto131.filename;
    }
    cellautostatusbar.setText(str);
    if (cellautoapp.infowindow != null){cellautoapp.infowindow.updateinfo();}
  }
  static ImageIcon createImageIcon2(String path) {
    java.net.URL imgURL = cellautoapp.class.getResource(path);
    if (imgURL != null) {
      return new ImageIcon(imgURL);
    } else {
      System.err.println("Couldn't find file: " + path);
      return null;
    }
  }

  static ImageIcon createImageIcon(String path, String description) {
    java.net.URL imgURL = cellautoapp.class.getResource(path);
    if (imgURL != null) {
      return new ImageIcon(imgURL, description);
    } else {
      System.err.println("Couldn't find file: " + path);
      return null;
    }
  }
  
  //this function writes the rule table to a string
  static String write_ruletable_to_string() {
    //int from_row,int to_row
    cellautorulec c = cellauto131;
    StringWriter strbuf = new StringWriter();
    PrintWriter p = new PrintWriter(strbuf);
    p.println("frank_cellauto_ruletable_clipboard,1");
    //p.println("resize_table," + c.tablewidth + "," + c.tableheight);
    for (int y = 0;y < c.tableheight;y++) {
      p.print("table");
      for (int x = 0;x < c.tablewidth;x++) {
        p.print("," + c.getlookuptable(x,y));
      }
      p.println();
    }
    for (int i = 0;i < c.numcolors;i++) {
      int i2 = c.getcellvalue(i);
      p.println("cellvalue,"+i+","+i2);
      Color c2 = c.getcellvaluecolor(i);
      p.println("cellvaluecolor,"+i+","+c2.getRed()+","+c2.getGreen()+","+c2.getBlue());
    }                               
    return strbuf.toString();
  }
  
  
  //this function writes the selection to a string
  static String writeselectiontostring(){
    StringWriter strbuf = new StringWriter();
    PrintWriter p = new PrintWriter(strbuf);
    p.println("javacellautoruleclipboard,1");
    p.println("clipboardsize," + selx + "," + sely + "," + selw + "," + selh);
    for (int y = 0;y < selh;y++){
      p.print("clipboarddata,");
      StringBuffer str = new StringBuffer();
      for (int x = 0;x < selw;x++){
        int a0 = seldata[x][y];
        char ch1 = (char) ((a0 >> 4) + 97);
        char ch2 = (char) ((a0 & 15) + 97);
        if (a0 == 0){
          if (selectiontextbackground == 1){
           ch1 = ' ';
           ch2 = ' ';
          }
          if (selectiontextbackground == 2){
           ch1 = '.';
           ch2 = '.';
          }
        }
        str.append(ch1);
        str.append(ch2);
      }
      p.println(str.toString());
    }
    return strbuf.toString();
  }
  
  static void read_ruletable_from_string(String str) {
    BufferedReader r = new BufferedReader(new StringReader(str));
    cellautorulec c = cellauto131;

    try{
      if (c.tableheight < c.getnumcolors()) {
        c.resizetable(c.tablewidth,c.getnumcolors());
      }
      int nc = c.tableheight;
      String line = r.readLine();
      while (line != null) {
        String ss[] = line.split(",");
        String st = ss[0];

        if (st.equals("table")) {

          int n = c.tableheight;
          c.resizetable(c.tablewidth,c.tableheight+1);
          int i = 1;
    
          while (i < ss.length) {
            int i3 = i-1;
            int i2 = Integer.valueOf(ss[i]).intValue();
            if (i3 < c.tablewidth) {
              c.setlookuptable(i3,n,nc+i2);
            }
            i++; 
          }
        }
        if (st.equals("cellvalue")) {
          int i = Integer.valueOf(ss[1]).intValue();
          int i2 = Integer.valueOf(ss[2]).intValue();
          c.setcellvalue(nc+i,i2);
        }
        if (st.equals("cellvaluecolor")) {
          int i = Integer.valueOf(ss[1]).intValue();
          int red = Integer.valueOf(ss[2]).intValue();
          int green = Integer.valueOf(ss[3]).intValue();
          int blue = Integer.valueOf(ss[4]).intValue();
          c.setcellvaluecolor(nc+i,new Color(red,green,blue));
        }
        line = r.readLine();
      }
    } catch(IOException e){
      e.printStackTrace();
    }

      //c.numcolors 
  }
  //this function reads the selection from a string
  static void readselectionfromstring(String str){
    BufferedReader r = new BufferedReader(new StringReader(str));
    try{
      if (keepselectionwhenpasting){
        cellautoapp.pasteseldata();
        cellautoapp.selx1 = 0;
        cellautoapp.sely1 = 0;
        cellautoapp.selx2 = 0;
        cellautoapp.sely2 = 0;
        cellautoapp.setupsel();
      }
      String line = r.readLine();
      int x = 0;
      int y = 0;
      
      while (line != null){
        String ss[] = line.split(",");
        String st = ss[0];
        if (st.equals("clipboardsize")){
          //if (selw > board.width){
          //  if (selh > board.height){
          //    JOptionPane.showMessageDialog(cellautoapp.cellautowindowframe,new JLabel("can not paste, try a bigger board"),"error",JOptionPane.ERROR_MESSAGE);
          //    return;
          //  }
          //}
          if (selectionsavexy){
            selx = Integer.valueOf(ss[1]).intValue();
            sely = Integer.valueOf(ss[2]).intValue();
          }else{
            selx = offsetx;
            sely = offsety;
          }
          selw = Integer.valueOf(ss[3]).intValue();
          selh = Integer.valueOf(ss[4]).intValue();
          seldata = new int[selw][selh];
          selx1 = selx;
          sely1 = sely;
          selx2 = selx+selw;
          sely2 = sely+selh;
        }
        if (st.equals("clipboarddata")){
          x = 0;
          String data = ss[1];
          int l = data.length();
          for (int i = 0;i < (l / 2);i++){
            char ch = data.charAt((i*2)+0);
            char ch2 = data.charAt((i*2)+1);
            int a = ((int )(ch - 97));
            int a2 = ((int )(ch2 - 97));
            if (x < selw){
              if (y < selh){
                if (((ch == ' ') & (ch2 == ' ')) | 
                    ((ch == '.') & (ch2 == '.'))){
                  seldata[x][y] = 0;
                }else{
                  int i2 = (a*16)+a2;
                  if ((i2 >= 0) & (i2 < cellauto131.numcolors)){
                    seldata[x][y] = i2;
                  }
                }
              }
            }
            x++;
          }
          y++;
        }
        line = r.readLine();
        
      }
    } catch(IOException e){
      e.printStackTrace();
    }
    
  }
  static Color getrandomcolor(){
    return new Color(rand.nextInt(256),rand.nextInt(256),rand.nextInt(256));
  }
  private static final int ItoU(int x) {
    return ((x << 1) | ((x >> 7) & 1)) & 0xFF;
  }
  static int read_address(RandomAccessFile r) {
    int addr2 = 0;
    try {
      int[] addr = new int[4];
      addr[0] = r.read();
      addr[1] = r.read();
      addr[2] = r.read();
      addr[3] = r.read();
      addr2 = addr[0] + (addr[1] << 8) + (addr[2] << 16) + (addr[3] << 24);
    } catch (IOException e){
      e.printStackTrace();
    }
    return addr2;
  }
  static String read_string(RandomAccessFile r) {
    try {
      int l = r.read();
      byte b[] = new byte[l-1];
      r.read(b,0,l-1);
      r.read();
      return new String(b);
    } catch (IOException e){
      e.printStackTrace();
      return "";  
    }
  }
  static int openjcc(RandomAccessFile r) {
    try {
    cellautorulec c = cellauto131;
    int red;
    int green;
    int blue;
    int b;
    b = r.read();
    if (b != 0x34) {return -1;}
    b = r.read();
    if (b != 0x0D) {return -1;}
    b = r.read();
    if (b != 0x0A) {return -1;}
    for (int i = 0;i < 256;i++) {
      red = (r.read() & 63) << 2;
      green = (r.read() & 63) << 2;
      blue = (r.read() & 63) << 2;
      c.setcellvaluecolor(i,new Color(red,green,blue));
    }
    } catch (IOException e){
      e.printStackTrace();
      //return "";
    }
    return 0;
  }
  static int openjcp(RandomAccessFile r) {
    cellautorulec c = cellauto131;
    int x = 0;
    int y = 0;
    int b;
    int b2;
    int b3;
    board = new boardc(322,200);
    try {
      b = r.read();
      if (b != 58) {return -1;}
      b = r.read();
      b = r.read();
      b = r.read();
      b = r.read();
      while (b != -1) {
        if (b == RLEND) {
          break;
        }
        if (b == RLUNCOMP) {
          for (int y2 = 0;y2 < board.height;y2++) {
            for (int x2 = 0;x2 < board.width;x2++) {
              b3 = r.read();
              board.setsq(x2,y2,ItoU(b3));
            }
          }
        }
        if (b == RLRUN) {
          b2 = r.read();
          b3 = r.read();
          //System.out.println("rlrun " + b2 + " " + b3);
          for (int i = 0;i <= b2;i++) {
            board.setsq(x,y,ItoU(b3));
            x++;
            if (x >= board.width){x = 0;y++;}
          }
        } 
        if (b == RLONEB) {
          b2 = r.read();
          //System.out.println("rlone " + b2);
          board.setsq(x,y,ItoU(b2));
          x++;
          if (x >= board.width){x = 0;y++;}
        }
        if (b == RLUNCS) {
            b2 = r.read();
            //System.out.println("rluncs " + b2);
            for (int i = 0;i <= b2;i++) {
              b3 = r.read();
              board.setsq(x,y,ItoU(b3));
              x++;
              if (x >= board.width){x = 0;y++;}
            }
        }
        if (b == RLLRUN) {
          b2 = r.read();
          b3 = r.read();
          b2 = (b2*256) + b3;
          b3 = r.read();
          //System.out.println("rllrun " + b2 + " " + b3);
          for (int i = 0;i <= b2;i++) {
            board.setsq(x,y,ItoU(b3));
            x++;
            if (x >= board.width){x = 0;y++;}
          }
          
        }
        if (b == RLLUNCS) {
          b2 = r.read();
          b3 = r.read();
          b2 = (b2*256) + b3;
          //System.out.println("rlluncs " + b2);
          for (int i = 0;i <= b2;i++) {
            b3 = r.read();
            board.setsq(x,y,ItoU(b3));
            x++;
            if (x >= board.width){x = 0;y++;}
          }
          
        }
        b = r.read();
      }
      board2 = new boardc(board);
      board2 = cellauto131.calcbgcolor(board,board2);
      board2.changecellstates(board.get_background_color(0,0),board2.get_background_color(0,0));
    } catch (IOException e){
      e.printStackTrace();
    }
    return 0;
    
  }

  static void setuprugrule(int a) {
    cellautorulec c = cellauto131;
        c.rulefamily = abstractcellautorulefamily.getrulefamily("rug_avereging");

        rug_avereging_rulefamilyc r = (rug_avereging_rulefamilyc) c.rulefamily;
        r.num_bits_of_local_state = 6-a;
        c.setbordervalue( 0, 0,  0);
        c.setbordervalue( 0,-1,  1); //n
        c.setbordervalue(-1, 0,  1); // w
        c.setbordervalue( 1, 0,  1); // e
        c.setbordervalue( 0, 1,  1); //s
        
        c.setbordervalue(-1,-1,  a); //nw
        c.setbordervalue( 1,-1,  a); //ne
        c.setbordervalue(-1, 1,  a); //sw
        c.setbordervalue( 1, 1,  a); //se
    
  }
  static void loadjccode(String code) {
    cellautorulec c = cellauto131;
    System.out.println("code is " + code);
    code = code.toLowerCase();
    if (code.equals("semi8")) {
        setuprugrule(1);
        //wrapb = false;
        return;
    }
    if (code.equals("semi4")) {
        setuprugrule(0);
        //wrapb = false;
        return;
    }
    if (code.equals("langton")) {

      c.rulefamily = abstractcellautorulefamily.getrulefamily("jc_langton");
      return;
    }
    if (code.equals("vonn3")) {
      c.rulefamily = abstractcellautorulefamily.getrulefamily("jc_vonn3");
      return;
    }
    if (code.equals("margolus")) {
      c.rulefamily = abstractcellautorulefamily.getrulefamily("jc_margolus");
      return;
    }
    if (code.equals("vonn2")) {
      c.rulefamily = abstractcellautorulefamily.getrulefamily("jc_vonn2");
      return;
    }
    if (code.equals("switch")) {
      c.rulefamily = abstractcellautorulefamily.getrulefamily("jc_switch");
      return;
    }
    if (code.equals("cycle")) {
      c.rulefamily = abstractcellautorulefamily.getrulefamily("jc_cycle");
      return;
    }
    if (code.equals("average")) {
      c.rulefamily = abstractcellautorulefamily.getrulefamily("jc_average");
      return;
    }
    
    if (code.equals("marg5tot")) {
      c.rulefamily = abstractcellautorulefamily.getrulefamily("jc_margolus_tot5");
      return;
    }
    if (code.equals("marg6rug")) {
      c.rulefamily = abstractcellautorulefamily.getrulefamily("jc_margolus_rug6");
      return;
    }
    if (code.equals("marg5sum")) {
      c.rulefamily = abstractcellautorulefamily.getrulefamily("jc_margolus_sum5");
      return;
    }
    if (code.equals("marg8sum")) {
      c.rulefamily = abstractcellautorulefamily.getrulefamily("jc_margolus_sum8");
      return;
    }
    if (code.equals("average4")) {
      c.rulefamily = abstractcellautorulefamily.getrulefamily("jc_average4");
      return;
    }

    JOptionPane.showMessageDialog(cellautoapp.cellautowindowframe,new JLabel("error: can not load code: " + code),"error",JOptionPane.ERROR_MESSAGE);
  }
  
  static int openjc(RandomAccessFile r,String path) {
    cellautorulec c = cellauto131;
    int tablex = 0;
    int tabley = 0;
    int b;
    int b2;
    int b3;
    //cellautorulec c = cellauto131;
    cellautoapp.randb = 0;
    cellautoapp.randn = 0;
    try {
      byte strb[] = new byte[11];
      r.read(strb);
      String str = new String(strb);
      str = str.toLowerCase();
      if (str.equals("programname")) {
        return -1;
      }
      r.seek(0);
      c.rulefamily = null;
      cellautoapp.calc_one_row = false;
      c.cleartable(256,256);
      c.clearborder(1);
      c.setbordervalue(-1,-1,  128);//nw
      c.setbordervalue( 0,-1,  64); //n
      c.setbordervalue( 1,-1,  32); //ne
      c.setbordervalue(-1, 0,  16); // w
      c.setbordervalue( 1, 0,  8);  // e
      c.setbordervalue(-1, 1,  4);  //sw
      c.setbordervalue( 0, 1,  2);  //s
      c.setbordervalue( 1, 1,  1);  //se
      c.setbordervalue( 0, 0,  0);
      int i2 = c.getnumcolors();
      c.setnumcolors(256);
      for (int i = i2;i < 256;i++) {
        c.setcellvaluecolor(i,getrandomcolor());
      }
      for (int i = 0;i < 256;i++) {
        if ((i & 1) == 1) {
          c.setcellvalue(i,1);
        } else {
          c.setcellvalue(i,0);
        }
      }
      b = r.read();
      for (tabley = 0;tabley < 256;tabley++) {
        if (b == RLEND) {
          break;
        }
        if (b == RLUNCOMP) {
          for (int y2 = 0;y2 < 256;y2++) {
            for (int x2 = 0;x2 < 256;x2++) {
              b3 = r.read();
              c.setlookuptable(x2,y2,ItoU(b3));
            }
          }
        }
        if (b == RLCOPYB) {
          b2 = r.read();
          tablex = 0;
          while (tablex < 256) {
            int i = c.getlookuptable(tablex,b2);
            c.setlookuptable(tablex,tabley,i);
            tablex++;
          }
          b = r.read();
          continue;
        }
        tablex = 0;
        while ((tablex < 256) & (b > -1)) {
          if (b == RLRUN) {
            b2 = r.read();
            b3 = r.read();
            for (int i = 0;i <= b2;i++) {
              c.setlookuptable(tablex,tabley,ItoU(b3));
              tablex = tablex + 1;
            }
          }
          if (b == RLONEB) {
            b2 = r.read();
            c.setlookuptable(tablex,tabley,ItoU(b2));
            tablex = tablex + 1;
          }
          if (b == RLUNCS) {
            b2 = r.read();
            for (int i = 0;i <= b2;i++) {
              b3 = r.read();
              c.setlookuptable(tablex,tabley,ItoU(b3));
              tablex = tablex + 1;
            }
          }
         
          b = r.read();
        }
        if (b == RLEND) {
          break;
        }

      }
      int texthb = 0;
      int texthn = 0;
      int textvb = 0;
      int textvn = 0;
      int rseedb = 0;
      int rseedn = 0;
      int rseedp = 0;
      String patfile;
      String palfile;
      String codefile;
      
      while ((b != RLEND) & (b != -1)) {
        if (b == RSHTEXT) {
          texthb = r.read();
          texthn = r.read();
        }
        if (b == RSVTEXT) {
          textvb = r.read();
          textvn = r.read();
        }
        if (b == RSRAND) {
          cellautoapp.randb = r.read();
          cellautoapp.randn = r.read();
        }
        if (b == RSRSEED) {
          rseedb = r.read();
          rseedn = r.read();
          rseedp = r.read();
        }
        if (b == RSPAT) {
          patfile = read_string(r);
          try {
            openjcp(new RandomAccessFile(path + patfile + ".jcp","r"));
          } catch (FileNotFoundException e) {
            JOptionPane.showMessageDialog(cellautoapp.cellautowindowframe,new JLabel("note: the pattern file " + patfile + ".jcp" + " is not found"),"info",JOptionPane.INFORMATION_MESSAGE);             
          }
        }
        if (b == RSPAL) {
          palfile = read_string(r);
          try {
            openjcc(new RandomAccessFile(path + palfile + ".jcc","r"));
          } catch (FileNotFoundException e) {
            JOptionPane.showMessageDialog(cellautoapp.cellautowindowframe,new JLabel("note: the palette file " + palfile + ".jcp" + " is not found"),"info",JOptionPane.INFORMATION_MESSAGE);             
          }
        }
        if (b == RSEPAT) {
          int addr = read_address(r);
          long addr2 = r.getFilePointer();
          r.seek(addr);
          openjcp(r);
          r.seek(addr2);
        }
        if (b == RSEPAL) {
          int addr = read_address(r);
          long addr2 = r.getFilePointer();
          r.seek(addr);
          openjcc(r);
          r.seek(addr2);
        }
        if (b == RSEOCODE) {
          int addr = read_address(r);
          JOptionPane.showMessageDialog(cellautoapp.cellautowindowframe,new JLabel("error: can not load embedded code"),"error",JOptionPane.ERROR_MESSAGE);
        }
        if (b == RSOCODE) {
          codefile = read_string(r);
          loadjccode(codefile);
        }                                
        b = r.read();
      }
      
      int worldtype = r.read();
      int randdens = r.read();
      int auxplane = r.read();
      int wrap = worldtype & 1;
      boolean wrapb = false;
      if (wrap == 1) {wrapb = true;}
      int worldtype2 = worldtype - wrap;
      

      if (worldtype < 10) {
        int tmptable[][] = new int[256][256];
        for (int y = 0;y < 256;y++) {
          for (int x = 0;x < 256;x++) {
            tmptable[x][ItoU(y)] = c.getlookuptable(x,y);
          }
        }
        for (int y = 0;y < 256;y++) {
          for (int x = 0;x < 256;x++) {
            c.setlookuptable(x,y,tmptable[x][y]);
          }
        }
      }
      
      if ((worldtype >= 2) & (worldtype < 10)) {
        c.rulefamily = abstractcellautorulefamily.getrulefamily("cell_auto_1d");
        ca1drulefamilyc c2 = (ca1drulefamilyc) c.rulefamily;
        cellautoapp.calc_one_row = true;
        if (worldtype2 == 2) {
          c2.clear_neighborhood(4);
          c2.set_neighborhood_value(0,128);
          c2.set_neighborhood_value(1,64);
          c2.set_neighborhood_value(2,32);
          c2.set_neighborhood_value(3,16);
          c2.set_neighborhood_value(5,8);
          c2.set_neighborhood_value(6,4);
          c2.set_neighborhood_value(7,2);
          c2.set_neighborhood_value(8,1);
          for (int i = 0;i < 256;i++) {
            c.setcellvalue(i,(i & 1));
          }
        }
        if (worldtype2 == 4) {
          c2.clear_neighborhood(2);
          c2.set_neighborhood_value(0,64);
          c2.set_neighborhood_value(1,16);
          c2.set_neighborhood_value(3,4);
          c2.set_neighborhood_value(4,1);
          for (int i = 0;i < 256;i++) {
            c.setcellvalue(i,(i & 3));
          }
        }
        if (worldtype2 == 8) {
          c2.clear_neighborhood(1);
          c2.set_neighborhood_value(0,16);
          c2.set_neighborhood_value(2,1);
          for (int i = 0;i < 256;i++) {
            c.setcellvalue(i,(i & 15));
          }
        }
      }
      if (worldtype == 10) {
        setuprugrule(1);
        wrapb = true;
      }
      if (worldtype == 11) {
        setuprugrule(0);
        wrapb = true;
      }
      int bg = board.get_background_color4();
      board.wrapx = wrapb;
      board.wrapy = wrapb;
      if ((texthn > 0) & (textvn > 0)) {
        for (int x = 0;x < board.width;x++) {
          for (int y = 0;y < board.height;y++) {
            int sq = board.getsq(x,y);
            sq = sq ^ ((x & ((1 << texthn)-1)) << texthb) ^ ((y & ((1 << textvn)-1)) << textvb);
            board.setsq(x,y,sq);
          }
        }
      }
      if (rseedp > 0) {
        for (int x = 0;x < board.width;x++) {
          for (int y = 0;y < board.height;y++) {
            for (int bit = rseedb;bit < (rseedb+rseedn);bit++) {
              int p = cellautoapp.rand.nextInt(512);
              if (rseedp > p) {
                int sq = board.getsq(x,y);
                sq = sq | (1 << bit);
                board.setsq(x,y,sq);
              }
            }
          }
        }
      }
      cellautoapp.edittablewindow.vscroll.setMaximum(cellautoapp.cellauto131.tableheight);
      cellautoapp.edittablewindow.hscroll.setMaximum(cellautoapp.cellauto131.tablewidth);
    } catch (IOException e){
      e.printStackTrace();
    }
    return 0;
  }
  static int opensqc(BufferedReader r) {
    int sw_offset = 0;
    int nw_row = 0;
    int rt_row = 0;
    int rows = 0;
    int columns = 0;
    int noStates = 0;
    int noCounts = 0;
    String data_str = "";
    String line = "";
    int linenum = 0;
    int w = board.get_width() & 0xFFFFFFFC;
    int h = board.get_height() & 0xFFFFFFFC;
    if (w < 512) {w = 512;}
    if (h < 512) {h = 512;}

    cellautoapp.randb = 0;
    cellautoapp.randn = 0;
    cellautorulec c = cellauto131;
    c.clearborder(2);
    c.rulefamily = null;
    try {
      line = r.readLine();
      linenum = linenum + 1;
      line.trim();
      if (line.equals("programname,frank's java cellular automaton program")){
        r.close();
        return -1;
      }
      c.setcellvaluecolor(0,Color.black);
      c.setcellvaluecolor(1,Color.red);
      c.setcellvaluecolor(2,Color.green);
      c.setcellvaluecolor(3,Color.blue);
      c.setcellvaluecolor(4,Color.yellow);
      c.setcellvaluecolor(5,Color.cyan);
      c.setcellvaluecolor(6,Color.magenta);
      c.setcellvaluecolor(7,Color.orange);
      c.setcellvaluecolor(8,Color.pink);
      c.setcellvaluecolor(9,Color.lightGray);
      while (line != null) {
        String ss[] = line.split(" ");
        String st = ss[0];
        if (st.equals("#rows")) {
          rows = Integer.valueOf(ss[2]).intValue();
          rows = (rows + (rows >> 1)) & 0xFFFFFFFC;
          if (h > rows){rows = h;}
          if (rows > 0) {
            board = new boardc(columns,rows);
          }
        }
        if (st.equals("#columns")) {
          columns = Integer.valueOf(ss[2]).intValue();
          columns = (columns + (columns >> 1)) & 0xFFFFFFFC;
          if (w > columns){columns = w;}
          if (columns > 0) {
            board = new boardc(columns,rows);
          }
        }
        if (st.equals("#noStates")) {
          noStates = Integer.valueOf(ss[2]).intValue();
          c.setnumcolors(noStates);
          if (noCounts > 0) {
            c.cleartable(noCounts,noStates);
          }
        }
        if (st.equals("#noCounts")) {
          noCounts = Integer.valueOf(ss[2]).intValue();
          if (noStates > 0) {
            c.cleartable(noCounts,noStates);
          }
        }
        if (st.equals("#SW")) {
          for (int i = 1;i < ss.length;i++) {
            int i2 = Integer.valueOf(ss[i]).intValue();
            c.setcellvalue(i+sw_offset-1,i2);
          }
          sw_offset = sw_offset + ss.length;
        }
        if (st.equals("#NW")){
          for (int i = 1;i < 6;i++) {
            int i2 = Integer.valueOf(ss[i]).intValue();
            c.setbordervalue(i-3,nw_row-2,i2);
          }
          nw_row++;
        }
        if (st.equals("#RT")) {
          for (int i = 1;i < ss.length;i++) {
            int i2 = Integer.valueOf(ss[i]).intValue();
            c.setlookuptable(i-1,rt_row,i2);
          }
          rt_row++;
        }
        if (st.equals("#L")) {
          data_str = data_str + ss[1];
        }
        line = r.readLine();
        linenum = linenum + 1;
      }
      //System.out.println("readsqcrle begin");
      board.readsqcrle(data_str);
      //System.out.println("readsqcrle end");
      //board2 = new boardc(board);
      if (newgamedialog != null){
        newgamedialog.widthedit.setText(Integer.toString(columns));
        newgamedialog.heightedit.setText(Integer.toString(rows));
      }
      cellautoapp.edittablewindow.vscroll.setMaximum(cellautoapp.cellauto131.tableheight);
      cellautoapp.edittablewindow.hscroll.setMaximum(cellautoapp.cellauto131.tablewidth);
      r.close();
    } catch (IOException e){
      e.printStackTrace();
    }
    return 0;
  }
  static String intToString(int i) {
    if (i < 0) return " " + i;
    if (i < 10) return " 0" + i; 
    return " " + i;
  }
  static void savesqc(BufferedWriter w) {
    cellautorulec c = cellauto131;
    int sw_offset = 0;
    int nw_row = 0;
    int rt_row = 0;
    int rows = board.height;
    int columns = board.width;
    int noStates = c.numcolors;
    int noCounts = c.tablewidth;
    String data_str = "";
    String line = "";
    int linenum = 0;
    //cellautorulec c = cellauto131;
    PrintWriter p = new PrintWriter(w);
    p.println("#rows = " + rows);
    p.println("#columns = " + columns);
    p.println("#noStates = " + noStates);
    p.println("#noCounts = " + noCounts);

    int numcolors = c.getnumcolors();
    p.print("#SW");
    for (int i = 0;i < numcolors;i++) {
      p.print(intToString(c.getcellvalue(i)));
    }
    p.println();

    if (c.bordersize == 1){
      p.println("#NW 00 00 00 00 00");
      for (int y = -1;y <= 1;y++) {
        p.print("#NW 00");
        for (int x = -1;x <= 1;x++) {
          p.print(intToString(c.getbordervalue(x,y)));
        }
        p.println(" 00");
      }
      p.println("#NW 00 00 00 00 00");
    } else {
      for (int y = -2;y <= 2;y++) {
        p.print("#NW");
        for (int x = -2;x <= 2;x++) {
          p.print(intToString(c.getbordervalue(x,y)));
        }
        p.println();
      }
    }
    for (int y = 0;y < c.tableheight;y++) {
      p.print("#RT");
      for (int x = 0;x < c.tablewidth;x++) {
        p.print(intToString(c.getlookuptable(x,y)));
      }
      p.println();
    }
    String rle = board.writesqcrle();
    int i = 0;
    int i2 = 60;
    int l = rle.length();
    while ((i+i2) < l){
      p.println("#L " + rle.substring(i,i+i2));
      i = i + i2;
    }
    p.println("#L " + rle.substring(i,l));
    
    p.close();
  }
  
  static void opentext(BufferedReader r){
    cellautorulec c = cellauto131;
    boardc b = board;
    int bordery = 0;
    int borderflip = 0;
    int tabley = 0;
    int tableusedy = 0;
    int numcells = 0;
    int fgcolor = 0;
    int bgcolor = 0;
    int rselx = 0;
    int rsely = 0;
    String line = null;
    int linenum = 0;
    int fileerror = 0;
    double version2 = 0;
    double version = 0;
    boolean new_table64 = false;
    calc_one_row = false;
    Vector bgcolor_string_list = new Vector();
    cellautoapp.randb = 0;
    cellautoapp.randn = 0;
    cellautoapp.symmetrybits = 0;
    c.description = null;

    try{
      c.filllookuptableused();
      c.rulefamily = null;
      if (cellautoapp.clear_selection_before_loading == true){
          cellautoapp.selx1 = 0;
          cellautoapp.sely1 = 0;
          cellautoapp.selx2 = 0;
          cellautoapp.sely2 = 0;        
          cellautoapp.setupsel();
      }
      version2 = Double.valueOf(programversion2).doubleValue();
      cellautoapp.seednumcolors = 0;
      line = r.readLine();
      linenum = linenum + 1;
      while (line != null){
        String ss[] = line.split(",");
        String ss2[] = new String[ss.length];
        for (int i = 0;i < ss.length;i++){
          ss2[i] = ss[i];
          ss[i] = ss[i].trim();
        }
        String st = ss[0];
        if (st.equals("programversion")){
          version = Double.valueOf(ss[1]).doubleValue();
          file_version = version;
          if (version > version2){
              JOptionPane.showMessageDialog(cellautoapp.cellautowindowframe,new JLabel(
                "can not load file, it is too new.  the program version is " + programversion2 + 
                ", the file version is " + version),"error",JOptionPane.ERROR_MESSAGE);
              break;
          }
        }
        if (st.equals("jc_rand_4283")) {
          cellautoapp.randb = Integer.valueOf(ss[1]).intValue();
          cellautoapp.randn = Integer.valueOf(ss[2]).intValue();
          
          if (cellautoapp.randb > 7) {cellautoapp.randn = 0;} 
          if (cellautoapp.randb < 0) {cellautoapp.randn = 0;} 
          if ((cellautoapp.randb+cellautoapp.randn) > 7) {cellautoapp.randn = 0;} 
          if (cellautoapp.randn < 0){cellautoapp.randn = 0;}
          System.out.println();
        }
        if (st.equals("seed")){
          c.seed = Integer.valueOf(ss[1]).intValue();
        }
        
        if (st.equals("generation")){
          generation = Integer.valueOf(ss[1]).intValue();
        }
        if (st.equals("calc_one_row")) {
          int a = Integer.valueOf(ss[1]).intValue();
          if (a != 0) {
            calc_one_row = true;
          }
        }
        if (st.equals("board_wrap")) {
          int a1 = Integer.valueOf(ss[1]).intValue();
          int a2 = Integer.valueOf(ss[2]).intValue();
          if (a1 == 0) {board.wrapx = false;}
          else {board.wrapx = true;}
          if (a2 == 0) {board.wrapy = false;}
          else {board.wrapy = true;}
        }
        if (st.equals("bgcolor")){
          bgcolor_string_list.add(line);
          bgcolor = Integer.valueOf(ss[1]).intValue();
          
        }
        
        if (st.equals("fgcolor")){
          fgcolor = Integer.valueOf(ss[1]).intValue();
        }
        
        if (st.equals("clearborder")){  
          int bordersize = Integer.valueOf(ss[1]).intValue();
          c.clearborder(bordersize);
          bordery = 0;
        }   

        if (st.equals("rulefamily")){
          c.rulefamily = abstractcellautorulefamily.getrulefamily(ss[1]);
          if (c.rulefamily != null){
            int i = 2;
            while (i < ss.length){
              c.rulefamily.addarg(ss[i]);
              i++;
            }
          }
        }
        if (st.equals("rulefamily_options_begin")){
          if (c.rulefamily != null){
            line = r.readLine();
            linenum = linenum + 1;
            line.trim();
            while (line != null){
              if (line.equals("rulefamily_options_end")){break;}
                c.rulefamily.readline(line);
                line = r.readLine();
                linenum = linenum + 1;
                line.trim();
            }
          }
        }        
        if (st.equals("line")){
          //read a row of the board
          if (b == null){ 
            b = new boardc(50,50);
            board = b;
          }
          int r2 = Integer.valueOf(ss[1]).intValue();
          String rle = ss[2];
          b.readrle(r2,rle);
        }
        if (st.equals("table_grid_spacing")) {
          edittablepanelc.grid_x_spacing = Integer.valueOf(ss[1]).intValue();
          edittablepanelc.grid_y_spacing = Integer.valueOf(ss[2]).intValue();
          edittablepanelc.grid_x_spacing2 = Integer.valueOf(ss[3]).intValue();
          edittablepanelc.grid_y_spacing2 = Integer.valueOf(ss[4]).intValue();
        }
        if (st.equals("border")){
          int i = 1;
          int borderx = 0;
          while (i < ss.length){
            int i2 = Integer.valueOf(ss[i]).intValue();
            c.setbordervalue(bordery-c.bordersize,borderx-c.bordersize,i2);
            borderx = borderx + 1;
            i++;
          }
          borderx = 0;
          bordery = bordery + 1;
        }
        
        if (st.equals("numcolors")){
          int i = Integer.valueOf(ss[1]).intValue();
          c.setnumcolors(i);
        }
        
        if (st.equals("seednumcolors")){
          int i = Integer.valueOf(ss[1]).intValue();
          cellautoapp.seednumcolors = i;
        }
        if (st.equals("clearboard")){
          //clear the board and resize it
          if (newgamedialog != null){
            newgamedialog.widthedit.setText(ss[1]);
            newgamedialog.heightedit.setText(ss[2]);
          }
          int x = Integer.valueOf(ss[1]).intValue();
          int y = Integer.valueOf(ss[2]).intValue();
          b = new boardc(x,y);
          b.wrapx = board.wrapx;
          b.wrapy = board.wrapy;
          board = b;
        }
        if (st.equals("symmetrybits")){
          cellautoapp.symmetrybits = Integer.valueOf(ss[1]).intValue();
          newgamedialog.update_symmetrycombobox(cellautoapp.symmetrybits);
        }
        if (st.equals("cleartable")){
          //clear the board and resize it
          int x = Integer.valueOf(ss[1]).intValue();
          int y = Integer.valueOf(ss[2]).intValue();
          c.cleartable(x,y);
          tabley = 0;
          new_table64 = true;
        }
        
        if (st.equals("tableoffset")){
          //read the table offset
          int a = Integer.valueOf(ss[1]).intValue();
          c.writetableoffset(a);
        }
        
        if (st.equals("bordertype")){
          String st2 = ss[1];
          if (st2.equals("square") | st2.equals("hex")){
            c.writeborderflip(0,0,0);
            c.writeborderflip(1,0,0);
            c.writeborderflip(0,1,0);
            c.writeborderflip(1,1,0);
          }
          if (st2.equals("pent")){
            c.writeborderflip(0,0,0);
            c.writeborderflip(1,0,1);
            c.writeborderflip(0,1,2);
            c.writeborderflip(1,1,3);
          }
          if (st2.equals("triangle")){
            c.writeborderflip(0,0,0);
            c.writeborderflip(1,0,3);
            c.writeborderflip(0,1,3);
            c.writeborderflip(1,1,0);
          }
        }
        
        if (st.equals("borderflip")){
          int a1 = Integer.valueOf(ss[1]).intValue();
          int a2 = Integer.valueOf(ss[2]).intValue();
          c.writeborderflip(0,borderflip,a1);
          c.writeborderflip(1,borderflip,a2);
          borderflip = borderflip ^ 1;
        }
        
        if (st.equals("cellvalue")){
          int i = Integer.valueOf(ss[1]).intValue();
          int i2 = Integer.valueOf(ss[2]).intValue();
          c.setcellvalue(i,i2);
        }
        
        if (st.equals("cellvaluecolor")){
          int i = Integer.valueOf(ss[1]).intValue();
          int red = Integer.valueOf(ss[2]).intValue();
          int green = Integer.valueOf(ss[3]).intValue();
          int blue = Integer.valueOf(ss[4]).intValue();
          c.setcellvaluecolor(i,new Color(red,green,blue));
        }    
        
        if (st.equals("tableused")){
          int i = 1;
          int tableusedx = 0;
          while (i < ss.length){
            int i2 = Integer.valueOf(ss[i]).intValue();
            c.setlookuptableused(tableusedx,tableusedy,i2);
            tableusedx = tableusedx + 1;
            i++;
          }
          tableusedx = 0;
          tableusedy = tableusedy + 1;
        }
        
        if (st.equals("table")){
          //read the rule table
          int i = 1;
          int tablex = 0;
          while (i < ss.length){
            int i2 = Integer.valueOf(ss[i]).intValue();
            c.setlookuptable(tablex,tabley,i2);
            tablex = tablex + 1;
            i++;
          }
          tablex = 0;
          tabley = tabley + 1;
        }
        
        if (st.equals("description")){
          //read the description
          int i = 1;
          while (i < ss.length){
            if (c.description != null){
              c.description = c.description + ss[i];
            }else{
              c.description = ss[i];
            }
            if (c.description != null){
              if (i < (ss.length-1)){
                c.description = c.description + ",";
              }else{
                c.description = c.description + "\n";
              }
            }else{
              if (i < (ss.length-1)){
                c.description = ",";
              }else{
                c.description = "\n";
              }
            }
            i++;
          }
        }
        
        if (st.equals("clearselection")){
          //clear the selection and resize it
          int x = Integer.valueOf(ss[1]).intValue();
          int y = Integer.valueOf(ss[2]).intValue();
          int w = Integer.valueOf(ss[3]).intValue();
          int h = Integer.valueOf(ss[4]).intValue();
          int w2 = cellautomainwindow.getWidth();
          int h2 = cellautomainwindow.getHeight();
          selx = x;
          sely = y;
          selw = w;
          selh = h;
          selx1 = selx;
          sely1 = sely;
          selx2 = selx+selw;
          sely2 = sely+selh;
          offsetx = selx - (w2/(cellautomainwindowc.sqsize*2)) + (cellautoapp.selw / 2);
          offsety = sely - (h2/(cellautomainwindowc.sqsize*2)) + (cellautoapp.selh / 2);
          seldata = new int[selw][selh];
        }
        
        if (st.equals("selection")){
          //read a row of the selection
          String data = ss2[1];
          int l = data.length();
          rsely = 0;
          for (int i = 0;i < (l / 2);i++){
            char ch = data.charAt((i*2)+0);
            char ch2 = data.charAt((i*2)+1);
            int a = ((int )(ch - 97));
            int a2 = ((int )(ch2 - 97));
            if (rselx < selw){
              if (rsely < selh){
                int i2 = (a*16)+a2;
                if (((ch == ' ') & (ch2 == ' ')) |
                   ((ch == '.') & (ch2 == '.'))) {
                  seldata[rselx][rsely] = 0;
                }else{
                  if ((i2 >= 0)&(i2 < cellauto131.numcolors)){
                    seldata[rselx][rsely] = i2;
                  }
                }
              }
            }
            rsely++;
          }
          rselx++;
        }
        line = r.readLine();
        linenum = linenum + 1;
      }

      if (new_table64 == false) {
        if (c.tableheight < c.getnumcolors()) {
          c.resizetable(c.tablewidth,c.getnumcolors());
        }        
      }
      if (c.rulefamily != null){
        if (file_version <= 1.1){
          if (c.rulefamily.getname().equals("generation_neighborhood")){
            generationneighborhoodrulefamilyc generationneighborhoodrulefamily = (generationneighborhoodrulefamilyc) c.rulefamily;
            generationneighborhoodrulefamily.load_cell_values(c);
          }
        }
        b.background_tile_sub_board = new simpleboardc(c.rulefamily.get_background_tile_width(),c.rulefamily.get_background_tile_height());
      } else {
        b.background_tile_sub_board = new simpleboardc(1,1);
      }
      b.background_tile_sub_board2 = new simpleboardc(b.background_tile_sub_board);
      for (int y = 0;y < bgcolor_string_list.size();y++) {
        line = (String) bgcolor_string_list.get(y);
        String ss[] = line.split(",");
        for (int x = 0;x < (ss.length-1);x++) {
          int sq = Integer.valueOf(ss[x+1]).intValue();
          b.background_tile_sub_board.setsq(x,y,sq);
        }
      }      
      for (int i = 0;i < 4;i++) {
        if (cellautoapp.neighborhoodvaluesdialog[i] != null) {
          cellautoapp.neighborhoodvaluesdialog[i].getbordervalues();      
        }
      }
      cellautoapp.optionsdialog.getoptions();
      if (cellautoapp.seednumcolors <= 1) {cellautoapp.seednumcolors = cellautoapp.cellauto131.numcolors;}
      cellautoapp.edittablewindow.vscroll.setMaximum(cellautoapp.cellauto131.tableheight);
      cellautoapp.edittablewindow.hscroll.setMaximum(cellautoapp.cellauto131.tablewidth);
      board.dfcolor = bgcolor;
      cellautoapp.colorlistindex = fgcolor;
      colorboxpanelc.selcolor = fgcolor;
      cellautoapp.colorbox.colorboxpanel.selcolor = fgcolor;
      cellautoapp.colorbox.colorboxpanel.repaint();
      if (cellautoapp.addeditstatedialog.isVisible() == true) {
        cellautoapp.addeditstatedialog.selectstate(cellautoapp.colorlistindex);
      }
      if (cellautoapp.editdescriptionwindow != null) {
        cellautoapp.editdescriptionwindow.text.setText(cellautoapp.cellauto131.description);
      }
      if (autoadjustoffset == true) {
        if (selw == 0) {
          if (selh == 0) {
            if (use_new_adjust_method == true){
              cellautoapp.cellautomainwindow.adjustpattern();
            } else {
              int f = 0;
              int w2 = ((cellautoapp.board.width-1) >> 5);
              int h2 = ((cellautoapp.board.height-1) >> 5);
              for (int x = 0;x <= w2;x++) {
                for (int y = 0;y <= h2;y++) {
                  if ((cellautoapp.board.block[x][y] != null) & (f == 0)) {
                    offsetx = x << 5;
                    offsety = y << 5;
                    f = 1;
                    break;
                  }
                }
              }
            }
          }
        }
      }
      if (cellautoapp.randomize_rule_table_dialog != null) {
        cellautoapp.randomize_rule_table_dialog.update_dialog();
      }      
      r.close();
    } catch (IOException e){
      e.printStackTrace();
    } catch (NumberFormatException e) {
      System.out.println("error: can not read number, line number is " + linenum + " line is ");
      System.out.println(line);
      fileerror = 1;
    }
    
    if (fileerror == 1){
      JOptionPane.showMessageDialog(cellautoapp.cellautowindowframe,new JLabel("can not open the file, " + 
        "see the console for details"),"error",JOptionPane.ERROR_MESSAGE);
    }
  }
};



class TextTransferc implements ClipboardOwner {
  public void lostOwnership( Clipboard aClipboard, Transferable aContents) {
  }
  
  public void setClipboardContents( String aString ){
    StringSelection stringSelection = new StringSelection( aString );
    Clipboard clipboard = Toolkit.getDefaultToolkit().getSystemClipboard();
    clipboard.setContents( stringSelection, this );
  }
  
  public String getClipboardContents() {
    String result = "";
    Clipboard clipboard = Toolkit.getDefaultToolkit().getSystemClipboard();
    Transferable contents = clipboard.getContents(null);
    boolean hasTransferableText = false;
    if ((contents != null)) {
      if (contents.isDataFlavorSupported(DataFlavor.stringFlavor)) {
        hasTransferableText = true;
      }
    }
    
    if ( hasTransferableText ) {
      try {
        result = (String)contents.getTransferData(DataFlavor.stringFlavor);
      }
      catch (Exception e) {
        e.printStackTrace();
      }
    }
    return result;
  }
} 



